;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module echo
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _net_recv
	.globl _net_send
	.globl _net_disconnect
	.globl _net_listen
	.globl _net_alloc
	.globl _log_printf
	.globl _echo_start
	.globl _echo_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;echo.c:26: static void echo_disconnect(ECHO *echo)
;	---------------------------------
; Function echo_disconnect
; ---------------------------------
_echo_disconnect:
	push	ix
	ld	ix,#0
	add	ix,sp
;echo.c:28: SOCKET *socket = echo->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;echo.c:29: log_printf("echo_disconnect:\r\n$");
	push	bc
	ld	hl, #___str_0
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;echo.c:30: net_disconnect(socket, (NF)echo_listen, echo);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_echo_listen
	push	hl
	push	de
	push	bc
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;echo.c:31: }		
	pop	ix
	ret
___str_0:
	.ascii "echo_disconnect:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;echo.c:34: static void echo_sent(ECHO *echo)
;	---------------------------------
; Function echo_sent
; ---------------------------------
_echo_sent:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;echo.c:36: SOCKET *socket = echo->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;echo.c:37: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00102$
;echo.c:38: echo_disconnect(echo);
	push	bc
	call	_echo_disconnect
	pop	af
	jr	00104$
00102$:
;echo.c:40: net_recv(socket, echo->buf, ECHO_BUF_SIZE, (NF)echo_received, echo);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	-2 (ix), #<(_echo_received)
	ld	-1 (ix), #>(_echo_received)
	ld	a, c
	add	a, #0x09
	ld	c, a
	jr	NC,00113$
	inc	b
00113$:
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	hl, #0x0100
	push	hl
	push	bc
	push	de
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00104$:
;echo.c:41: }		
	ld	sp, ix
	pop	ix
	ret
;echo.c:44: static void echo_received(ECHO *echo)
;	---------------------------------
; Function echo_received
; ---------------------------------
_echo_received:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;echo.c:46: SOCKET *socket = echo->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;echo.c:47: if ( socket->state == SS_ERROR )
	pop	hl
	push	hl
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00102$
;echo.c:48: echo_disconnect(echo);
	push	bc
	call	_echo_disconnect
	pop	af
	jr	00104$
00102$:
;echo.c:50: net_send(socket, echo->buf, socket->actual, (NF)echo_sent, echo);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	-2 (ix), #<(_echo_sent)
	ld	-1 (ix), #>(_echo_sent)
	pop	hl
	push	hl
	push	bc
	ld	bc, #0x001f
	add	hl, bc
	pop	bc
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	a, c
	add	a, #0x09
	ld	c, a
	jr	NC,00113$
	inc	b
00113$:
	push	de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	de
	push	hl
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00104$:
;echo.c:51: }
	ld	sp, ix
	pop	ix
	ret
;echo.c:54: static void echo_connected(ECHO *echo)
;	---------------------------------
; Function echo_connected
; ---------------------------------
_echo_connected:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;echo.c:56: SOCKET *socket = echo->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;echo.c:57: log_printf("echo_connected:\r\n$");
	push	bc
	ld	hl, #___str_1
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;echo.c:58: net_recv(socket, echo->buf, ECHO_BUF_SIZE, (NF)echo_received, echo);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_echo_received
	ld	a, c
	add	a, #0x09
	ld	c, a
	jr	NC,00103$
	inc	b
00103$:
	push	hl
	push	de
	ld	hl, #0x0100
	push	hl
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;echo.c:59: }
	ld	sp, ix
	pop	ix
	ret
___str_1:
	.ascii "echo_connected:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;echo.c:62: static void echo_listen(ECHO *echo)
;	---------------------------------
; Function echo_listen
; ---------------------------------
_echo_listen:
	push	ix
	ld	ix,#0
	add	ix,sp
;echo.c:64: SOCKET *socket = echo->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;echo.c:65: log_printf("echo_listen:\r\n$");
	push	bc
	ld	hl, #___str_2
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;echo.c:66: net_listen(socket, ECHO_PORT, (NF)echo_connected, echo);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_echo_connected
	push	hl
	push	de
	ld	hl, #0x0007
	push	hl
	push	bc
	call	_net_listen
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;echo.c:67: }
	pop	ix
	ret
___str_2:
	.ascii "echo_listen:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;echo.c:70: void echo_start(ECHO *echo)
;	---------------------------------
; Function echo_start
; ---------------------------------
_echo_start::
	push	ix
	ld	ix,#0
	add	ix,sp
;echo.c:72: echo->socket_alloc.fiber.queued = 0;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x00
;echo.c:73: net_alloc(&(echo->socket_alloc), (NF)echo_listen, echo);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_echo_listen
	push	hl
	push	de
	push	bc
	call	_net_alloc
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;echo.c:74: }
	pop	ix
	ret
;echo.c:77: void echo_init(void)
;	---------------------------------
; Function echo_init
; ---------------------------------
_echo_init::
;echo.c:79: }
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
