;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module ftpd
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _parse
	.globl _quit
	.globl _strncasecmp
	.globl _wiz_read_n
	.globl _log_close
	.globl _log_uint
	.globl _log_byte
	.globl _log_line
	.globl _log_printf
	.globl _log_open
	.globl _log_fatal
	.globl _net_recv
	.globl _net_send
	.globl _net_disconnect
	.globl _net_listen
	.globl _net_connect
	.globl _net_next_ephemeral_port
	.globl _net_alloc
	.globl _net_handle_interrupts
	.globl _net_init
	.globl _bdos_get_user
	.globl _bdos_disk_parameters
	.globl _bdos_logged_drives
	.globl _bdos_select_drive
	.globl _bdos_current_drive
	.globl _bdos_search_for_next
	.globl _bdos_search_for_first
	.globl _bdos_rename_file
	.globl _bdos_delete_files
	.globl _bdos_close_file
	.globl _bdos_write_file
	.globl _bdos_read_file
	.globl _bdos_create_file
	.globl _bdos_open_file
	.globl _bdos_set_dma_address
	.globl _bdos_inkey
	.globl _bdos_exit
	.globl _fiber_drain
	.globl _fiber_enqueue
	.globl _fiber_init
	.globl _strlen
	.globl _strstr
	.globl _memcmp
	.globl _nLoop
	.globl _nlist
	.globl _dlist
	.globl _ftp2
	.globl _ftp1
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_ftp1::
	.ds 289
_ftp2::
	.ds 289
_dlist::
	.ds 6656
_ftp_dlist_dir_65536_136:
	.ds 128
_ftp_dlist_fcb_65536_136:
	.ds 36
_ftpd_list_fcb_65536_165:
	.ds 36
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_nlist::
	.ds 2
_nLoop::
	.ds 2
_sta150:
	.ds 24
_sta200:
	.ds 9
_sta211:
	.ds 45
_sta215:
	.ds 27
_sta220:
	.ds 12
_sta221:
	.ds 13
_sta226:
	.ds 24
_sta227:
	.ds 45
_sta230:
	.ds 12
_sta250:
	.ds 14
_sta257:
	.ds 26
_sta350:
	.ds 16
_sta500:
	.ds 27
_sta501:
	.ds 25
_sta504:
	.ds 29
_sta550:
	.ds 21
_sta552:
	.ds 15
_psStatus:
	.ds 18
_first_fiber:
	.ds 7
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;ftpd.c:102: static void ftp_status (SOCKET *socket)
;	---------------------------------
; Function ftp_status
; ---------------------------------
_ftp_status:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:104: log_printf ("Socket $");
	ld	hl, #___str_0
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:105: log_uint ((socket->sra - W5100_ADDR_SOCKET) >> 8);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	l, e
	ld	h, d
	ld	bc, #0x0007
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, c
	add	a, #0x00
	ld	a, b
	adc	a, #0xfc
	ld	h, a
	ld	b, #0x00
	ld	c, h
	push	de
	push	bc
	call	_log_uint
	pop	af
	pop	de
;ftpd.c:106: log_printf (psStatus[socket->state]);
	ld	bc, #_psStatus+0
	ex	de,hl
	ld	de, #0x000e
	add	hl, de
	ld	l, (hl)
	ld	h, #0x00
	add	hl, hl
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_log_printf
	pop	af
;ftpd.c:107: }
	pop	ix
	ret
___str_0:
	.ascii "Socket $"
	.db 0x00
;ftpd.c:115: static char *ftp_copy (char *psDst, const char *psSrc)
;	---------------------------------
; Function ftp_copy
; ---------------------------------
_ftp_copy:
;ftpd.c:117: while (*psSrc)
	ld	iy, #4
	add	iy, sp
	ld	e, 0 (iy)
	ld	d, 1 (iy)
	dec	iy
	dec	iy
	ld	c, 0 (iy)
	ld	b, 1 (iy)
00101$:
	ld	a, (de)
	or	a, a
	jr	Z,00103$
;ftpd.c:119: *psDst = *psSrc;
	ld	(bc), a
;ftpd.c:120: ++psSrc;
	inc	de
;ftpd.c:121: ++psDst;
	inc	bc
	jr	00101$
00103$:
;ftpd.c:123: *psDst = '\0';
	xor	a, a
	ld	(bc), a
;ftpd.c:124: return psDst;
	ld	l, c
	ld	h, b
;ftpd.c:125: }
	ret
;ftpd.c:127: static void ftp_dgt (char **pps, word *pw, byte *pf, word d)
;	---------------------------------
; Function ftp_dgt
; ---------------------------------
_ftp_dgt:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;ftpd.c:130: while ( *pw >= d )
	ld	b, #0x30
00101$:
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	ld	e, (hl)
	inc	hl
	ld	c, (hl)
	dec	hl
	ld	a, e
	sub	a, 10 (ix)
	ld	a, c
	sbc	a, 11 (ix)
	jr	C,00116$
;ftpd.c:132: *pw -= d;
	ld	a, e
	sub	a, 10 (ix)
	ld	e, a
	ld	a, c
	sbc	a, 11 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), a
;ftpd.c:133: ++ch;
	inc	b
	jr	00101$
00116$:
	ld	c, b
;ftpd.c:135: if (( ch > '0' ) || ( *pf == 2 ))
	ld	a, 8 (ix)
	ld	-2 (ix), a
	ld	a, 9 (ix)
	ld	-1 (ix), a
;ftpd.c:137: **pps = ch;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
;ftpd.c:135: if (( ch > '0' ) || ( *pf == 2 ))
	ld	a, #0x30
	sub	a, b
	jr	C,00106$
	pop	hl
	push	hl
	ld	a, (hl)
	cp	a, #0x02
	jr	NZ,00107$
00106$:
;ftpd.c:137: **pps = ch;
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	(hl), c
;ftpd.c:138: ++(*pps);
	ld	l, e
	ld	h, d
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	ld	a, c
	ld	(de), a
	inc	de
	ld	a, b
	ld	(de), a
;ftpd.c:139: *pf = 2;
	pop	hl
	push	hl
	ld	(hl), #0x02
	jr	00110$
00107$:
;ftpd.c:141: else if ( *pf == 1 )
	dec	a
	jr	NZ,00110$
;ftpd.c:143: **pps = ' ';
	ld	l, e
	ld	h, d
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, #0x20
	ld	(bc), a
;ftpd.c:144: ++(*pps);
	ld	l, e
	ld	h, d
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	ld	a, c
	ld	(de), a
	inc	de
	ld	a, b
	ld	(de), a
00110$:
;ftpd.c:146: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:148: static char *ftp_uint (char *ps, word w)
;	---------------------------------
; Function ftp_uint
; ---------------------------------
_ftp_uint:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-9
	add	hl, sp
	ld	sp, hl
;ftpd.c:150: byte f = 0;
	xor	a, a
	ld	-9 (ix), a
;ftpd.c:151: ftp_dgt (&ps, &w, &f, 10000);
	ld	hl, #0
	add	hl, sp
	ld	-8 (ix), l
	ld	-7 (ix), h
	ex	de,hl
	ld	hl, #15
	add	hl, sp
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	c, l
	ld	b, h
	ld	hl, #13
	add	hl, sp
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	-1 (ix), a
	ld	hl, #0x2710
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:152: ftp_dgt (&ps, &w, &f, 1000);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x03e8
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:153: ftp_dgt (&ps, &w, &f, 100);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x0064
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:154: ftp_dgt (&ps, &w, &f, 10);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x000a
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:155: *ps = w + '0';
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, 6 (ix)
	add	a, #0x30
	ld	(bc), a
;ftpd.c:156: return ++ps;
	inc	4 (ix)
	jr	NZ,00103$
	inc	5 (ix)
00103$:
	ld	l, 4 (ix)
	ld	h, 5 (ix)
;ftpd.c:157: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:159: static char *ftp_uintp (char *ps, word w)
;	---------------------------------
; Function ftp_uintp
; ---------------------------------
_ftp_uintp:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-9
	add	hl, sp
	ld	sp, hl
;ftpd.c:161: byte f = 1;
	ld	-9 (ix), #0x01
;ftpd.c:162: ftp_dgt (&ps, &w, &f, 10000);
	ld	hl, #0
	add	hl, sp
	ld	-8 (ix), l
	ld	-7 (ix), h
	ex	de,hl
	ld	hl, #15
	add	hl, sp
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	c, l
	ld	b, h
	ld	hl, #13
	add	hl, sp
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	-1 (ix), a
	ld	hl, #0x2710
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:163: ftp_dgt (&ps, &w, &f, 1000);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x03e8
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:164: ftp_dgt (&ps, &w, &f, 100);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x0064
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:165: ftp_dgt (&ps, &w, &f, 10);
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x000a
	push	hl
	push	de
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_dgt
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:166: *ps = w + '0';
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, 6 (ix)
	add	a, #0x30
	ld	(bc), a
;ftpd.c:167: return ++ps;
	inc	4 (ix)
	jr	NZ,00103$
	inc	5 (ix)
00103$:
	ld	l, 4 (ix)
	ld	h, 5 (ix)
;ftpd.c:168: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:170: static BOOLEAN ftp_fname (const char *ps, FCB *pfcb)
;	---------------------------------
; Function ftp_fname
; ---------------------------------
_ftp_fname:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-11
	add	hl, sp
	ld	sp, hl
;ftpd.c:172: const char *ps0 = ps;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
;ftpd.c:173: int n = 0;
	xor	a, a
	ld	-7 (ix), a
	ld	-6 (ix), a
;ftpd.c:175: while ( *ps == ' ' ) ++ps;
	ld	-5 (ix), c
	ld	-4 (ix), b
00101$:
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	ld	a, (hl)
	ld	-3 (ix), a
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	inc	hl
	ld	a, -3 (ix)
	sub	a, #0x20
	jr	NZ,00175$
	ld	-5 (ix), l
	ld	-4 (ix), h
	jr	00101$
00175$:
	ld	a, -5 (ix)
	ld	4 (ix), a
	ld	a, -4 (ix)
	ld	5 (ix), a
;ftpd.c:176: if ( ps[1] == ':' )
	ld	e, (hl)
;ftpd.c:185: pfcb->drive = ch - 'A' + 1;
	ld	a, 6 (ix)
	ld	-2 (ix), a
	ld	a, 7 (ix)
	ld	-1 (ix), a
;ftpd.c:176: if ( ps[1] == ':' )
	ld	a, e
	sub	a, #0x3a
	jr	NZ,00111$
;ftpd.c:178: ch = *ps;
	ld	e, -3 (ix)
;ftpd.c:179: if (( ch >= 'a' ) && ( ch <= 'z' )) ch -= 0x20;
	ld	a, e
	sub	a, #0x61
	jr	C,00105$
	ld	a, #0x7a
	sub	a, e
	jr	C,00105$
	ld	a, e
	add	a, #0xe0
	ld	e, a
00105$:
;ftpd.c:180: if (( ch < 'A' ) || ( ch >= 'P' ))
	ld	a,e
	cp	a,#0x41
	jr	C,00107$
	sub	a, #0x50
	jr	C,00108$
00107$:
;ftpd.c:182: log_printf ("Invalid drive letter\r\n$");
	ld	hl, #___str_1
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:183: return FALSE;
	ld	hl, #0x0000
	jp	00147$
00108$:
;ftpd.c:185: pfcb->drive = ch - 'A' + 1;
	ld	a, e
	add	a, #0xc0
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), a
;ftpd.c:186: ps += 2;
	ld	a, -5 (ix)
	add	a, #0x02
	ld	4 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	5 (ix), a
	jr	00112$
00111$:
;ftpd.c:190: pfcb->drive = 0;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), #0x00
00112$:
;ftpd.c:192: if ( ( *ps == '/' ) || ( *ps == '\\' ) ) ++ps;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, (de)
	cp	a, #0x2f
	jr	Z,00113$
	sub	a, #0x5c
	jr	NZ,00162$
00113$:
	inc	4 (ix)
	jr	NZ,00289$
	inc	5 (ix)
00289$:
;ftpd.c:193: while ( n < 8 )
00162$:
	ld	a, -2 (ix)
	ld	-11 (ix), a
	ld	a, -1 (ix)
	ld	-10 (ix), a
	ld	a, -2 (ix)
	add	a, #0x01
	ld	-5 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-4 (ix), a
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00124$:
	ld	a, -2 (ix)
	sub	a, #0x08
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jp	NC, 00164$
;ftpd.c:195: ch = *ps;
	ld	a, (de)
	ld	-3 (ix), a
;ftpd.c:196: if (( ch <= ' ' ) || ( ch == '.' )) break;
	ld	a, #0x20
	sub	a, -3 (ix)
	jr	NC,00164$
	ld	a, -3 (ix)
	sub	a, #0x2e
	jr	Z,00164$
;ftpd.c:197: if ( strchr ("<>,.;:=?*[]", ch) != NULL )
	ld	l, -3 (ix)
	push	de
	ld	d, l
	ld	hl, #___str_2
00292$:
	ld	a, (hl)
	cp	a, d
	jr	Z,00291$
	or	a, a
	inc	hl
	jr	NZ, 00292$
	ld	l, a
	ld	h, a
00291$:
	ld	a, l
	ld	l, h
	pop	de
	or	a, l
	jr	Z,00120$
;ftpd.c:199: log_printf ("Invalid character in file name\r\n$");
	ld	hl, #___str_3
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:200: return FALSE;
	ld	hl, #0x0000
	jp	00147$
00120$:
;ftpd.c:202: if (( ch >= 'a' ) && ( ch <= 'z' )) ch -= 0x20;
	ld	a, -3 (ix)
	sub	a, #0x61
	jr	C,00122$
	ld	a, #0x7a
	sub	a, -3 (ix)
	jr	C,00122$
	ld	a, -3 (ix)
	add	a, #0xe0
	ld	-3 (ix), a
00122$:
;ftpd.c:203: pfcb->filename[n] = ch;
	ld	a, -5 (ix)
	add	a, -2 (ix)
	ld	l, a
	ld	a, -4 (ix)
	adc	a, -1 (ix)
	ld	h, a
	ld	a, -3 (ix)
	ld	(hl), a
;ftpd.c:204: ++ps;
	inc	de
	ld	4 (ix), e
	ld	5 (ix), d
;ftpd.c:205: ++n;
	inc	-2 (ix)
	jr	NZ,00293$
	inc	-1 (ix)
00293$:
	ld	a, -2 (ix)
	ld	-7 (ix), a
	ld	a, -1 (ix)
	ld	-6 (ix), a
	jp	00124$
;ftpd.c:212: while ( n < 8 )
00164$:
	ld	e, -5 (ix)
	ld	d, -4 (ix)
	ld	a, -7 (ix)
	ld	-2 (ix), a
	ld	a, -6 (ix)
	ld	-1 (ix), a
00127$:
	ld	a, -2 (ix)
	sub	a, #0x08
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	NC,00129$
;ftpd.c:214: pfcb->filename[n] = ' ';
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	ld	(hl), #0x20
;ftpd.c:215: ++n;
	inc	-2 (ix)
	jr	NZ,00127$
	inc	-1 (ix)
	jr	00127$
00129$:
;ftpd.c:217: n = 0;
	xor	a, a
	ld	-9 (ix), a
	ld	-8 (ix), a
;ftpd.c:218: if ( *ps == '.' )
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	e, (hl)
;ftpd.c:221: while ( n < 3 )
	ld	a, -11 (ix)
	add	a, #0x09
	ld	-7 (ix), a
	ld	a, -10 (ix)
	adc	a, #0x00
	ld	-6 (ix), a
;ftpd.c:218: if ( *ps == '.' )
	ld	a, e
	sub	a, #0x2e
	jp	NZ,00173$
;ftpd.c:220: ++ps;
	inc	hl
	ld	4 (ix), l
	ld	5 (ix), h
;ftpd.c:221: while ( n < 3 )
	ld	a, -7 (ix)
	ld	-5 (ix), a
	ld	a, -6 (ix)
	ld	-4 (ix), a
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00137$:
	ld	a, -2 (ix)
	sub	a, #0x03
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	NC,00173$
;ftpd.c:223: ch = *ps;
	ld	a, (de)
	ld	-3 (ix), a
;ftpd.c:224: if ( ch <= ' ' ) break;
	ld	a, #0x20
	sub	a, -3 (ix)
	jr	NC,00173$
;ftpd.c:225: if ( strchr ("<>,.;:=?*[]", ch) != NULL )
	ld	l, -3 (ix)
	push	de
	ld	d, l
	ld	hl, #___str_2
00298$:
	ld	a, (hl)
	cp	a, d
	jr	Z,00297$
	or	a, a
	inc	hl
	jr	NZ, 00298$
	ld	l, a
	ld	h, a
00297$:
	ld	a, l
	ld	l, h
	pop	de
	or	a, l
	jr	Z,00133$
;ftpd.c:227: log_printf ("Invalid character in file extension\r\n$");
	ld	hl, #___str_4
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:228: return FALSE;
	ld	hl, #0x0000
	jp	00147$
00133$:
;ftpd.c:230: if (( ch >= 'a' ) && ( ch <= 'z' )) ch -= 0x20;
	ld	a, -3 (ix)
	sub	a, #0x61
	jr	C,00135$
	ld	a, #0x7a
	sub	a, -3 (ix)
	jr	C,00135$
	ld	a, -3 (ix)
	add	a, #0xe0
	ld	-3 (ix), a
00135$:
;ftpd.c:231: pfcb->type[n] = ch;
	ld	a, -5 (ix)
	add	a, -2 (ix)
	ld	l, a
	ld	a, -4 (ix)
	adc	a, -1 (ix)
	ld	h, a
	ld	a, -3 (ix)
	ld	(hl), a
;ftpd.c:232: ++ps;
	inc	de
	ld	4 (ix), e
	ld	5 (ix), d
;ftpd.c:233: ++n;
	inc	-2 (ix)
	jr	NZ,00299$
	inc	-1 (ix)
00299$:
	ld	a, -2 (ix)
	ld	-9 (ix), a
	ld	a, -1 (ix)
	ld	-8 (ix), a
	jp	00137$
;ftpd.c:241: while ( n < 3 )
00173$:
	ld	a, -7 (ix)
	ld	-2 (ix), a
	ld	a, -6 (ix)
	ld	-1 (ix), a
	ld	e, -9 (ix)
	ld	d, -8 (ix)
00142$:
	ld	a, e
	sub	a, #0x03
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	NC,00144$
;ftpd.c:243: pfcb->type[n] = ' ';
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	ld	(hl), #0x20
;ftpd.c:244: ++n;
	inc	de
	jr	00142$
00144$:
;ftpd.c:246: if ( *ps > ' ' )
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	e, (hl)
	ld	a, #0x20
	sub	a, e
	jr	NC,00146$
;ftpd.c:248: log_printf ("File name too long: pos = $");
	ld	de, #___str_5+0
	push	hl
	push	bc
	push	de
	call	_log_printf
	pop	af
	pop	bc
	pop	hl
;ftpd.c:249: log_uint (ps - ps0);
	ld	a, l
	sub	a, c
	ld	c, a
	ld	a, h
	sbc	a, b
	ld	b, a
	push	hl
	push	bc
	call	_log_uint
	pop	af
	pop	hl
;ftpd.c:250: log_printf (", ch = $");
	ld	bc, #___str_6+0
	push	hl
	push	bc
	call	_log_printf
	pop	af
	pop	hl
;ftpd.c:251: log_byte (*ps);
	ld	a, (hl)
	push	af
	inc	sp
	call	_log_byte
	inc	sp
;ftpd.c:252: log_printf ("\r\n");
	ld	hl, #___str_7
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:253: return FALSE;
	ld	hl, #0x0000
	jr	00147$
00146$:
;ftpd.c:255: pfcb->ex = 0;
	ld	a, -11 (ix)
	add	a, #0x0c
	ld	c, a
	ld	a, -10 (ix)
	adc	a, #0x00
	ld	b, a
	xor	a, a
	ld	(bc), a
;ftpd.c:256: pfcb->s1 = 0;
	ld	a, -11 (ix)
	add	a, #0x0d
	ld	c, a
	ld	a, -10 (ix)
	adc	a, #0x00
	ld	b, a
	xor	a, a
	ld	(bc), a
;ftpd.c:257: pfcb->s2 = 0;
	ld	a, -11 (ix)
	add	a, #0x0e
	ld	c, a
	ld	a, -10 (ix)
	adc	a, #0x00
	ld	b, a
	xor	a, a
	ld	(bc), a
;ftpd.c:258: return TRUE;
	ld	hl, #0x0001
00147$:
;ftpd.c:259: }
	ld	sp, ix
	pop	ix
	ret
___str_1:
	.ascii "Invalid drive letter"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_2:
	.ascii "<>,.;:=?*[]"
	.db 0x00
___str_3:
	.ascii "Invalid character in file name"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_4:
	.ascii "Invalid character in file extension"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_5:
	.ascii "File name too long: pos = $"
	.db 0x00
___str_6:
	.ascii ", ch = $"
	.db 0x00
___str_7:
	.db 0x0d
	.db 0x0a
	.db 0x00
;ftpd.c:261: static BOOLEAN ftp_match (const char *psSrch, const char *psTest)
;	---------------------------------
; Function ftp_match
; ---------------------------------
_ftp_match:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;ftpd.c:264: for (i = 0; i < 11; ++i)
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	ld	c, (hl)
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	ld	de, #0x0000
00105$:
;ftpd.c:266: if (( *psSrch != '?' ) && ( *psSrch != (*psTest) & 0x7F )) return FALSE;
	pop	hl
	push	hl
	ld	b, (hl)
	ld	a, b
	sub	a, #0x3f
	jr	Z,00106$
	ld	a, c
	sub	a, b
	jr	Z,00106$
	ld	hl, #0x0000
	jr	00107$
00106$:
;ftpd.c:264: for (i = 0; i < 11; ++i)
	inc	de
	ld	a, e
	sub	a, #0x0b
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00105$
;ftpd.c:268: return TRUE;
	ld	hl, #0x0001
00107$:
;ftpd.c:269: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:271: static void ftp_dlist (void)
;	---------------------------------
; Function ftp_dlist
; ---------------------------------
_ftp_dlist:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-16
	add	hl, sp
	ld	sp, hl
;ftpd.c:280: log_printf ("Generating file list ... $");
	ld	hl, #___str_8
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:281: user = bdos_get_user ();
	call	_bdos_get_user
	ld	-16 (ix), l
;ftpd.c:282: pdpb = bdos_disk_parameters ();
	call	_bdos_disk_parameters
;ftpd.c:283: kbshft = pdpb->block_shift - 3;
	ld	c,l
	ld	b,h
	inc	hl
	inc	hl
	ld	a, (hl)
	add	a, #0xfd
	ld	-15 (ix), a
;ftpd.c:284: a16 = pdpb->alloc_max > 255;
	ld	l, c
	ld	h, b
	ld	de, #0x0005
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, #0xff
	cp	a, c
	ld	a, #0x00
	sbc	a, b
	ld	a, #0x00
	rla
	ld	-14 (ix), a
	xor	a, a
	ld	-13 (ix), a
;ftpd.c:285: nlist = 0;
	ld	hl, #0x0000
	ld	(_nlist), hl
;ftpd.c:286: strcpy (&fcb.drive, "????????????");
	ld	de, #_ftp_dlist_fcb_65536_136
	ld	hl, #___str_9
	xor	a, a
00213$:
	cp	a, (hl)
	ldi
	jr	NZ, 00213$
;ftpd.c:287: bdos_set_dma_address (dir);
	ld	hl, #_ftp_dlist_dir_65536_136
	push	hl
	call	_bdos_set_dma_address
;ftpd.c:288: idx = bdos_search_for_first (&fcb);
	ld	hl, #_ftp_dlist_fcb_65536_136
	ex	(sp),hl
	call	_bdos_search_for_first
	pop	af
	ld	c, l
	ld	b, #0x00
;ftpd.c:289: while ( idx < 4 )
00120$:
	ld	a, c
	sub	a, #0x04
	ld	a, b
	rla
	ccf
	rra
	sbc	a, #0x80
	jp	NC, 00122$
;ftpd.c:291: DIRENT *pdir = &dir[idx];
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #_ftp_dlist_dir_65536_136
	add	hl, de
;ftpd.c:292: if ( pdir->drive == user )
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	a,-16 (ix)
	sub	a,(hl)
	jp	NZ,00119$
;ftpd.c:294: DITEM *plist = dlist;
	ld	-10 (ix), #<(_dlist)
	ld	-9 (ix), #>(_dlist)
;ftpd.c:295: DITEM *pitem = NULL;
	xor	a, a
	ld	-8 (ix), a
	ld	-7 (ix), a
;ftpd.c:302: for (i = 0; i < nlist; ++i )
	ld	a, -12 (ix)
	add	a, #0x01
	ld	-6 (ix), a
	ld	a, -11 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	c, -10 (ix)
	ld	b, -9 (ix)
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00124$:
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #_nlist
	ld	a, e
	sub	a, (hl)
	ld	a, d
	inc	hl
	sbc	a, (hl)
	jr	NC,00103$
;ftpd.c:304: if ( memcmp (pdir->filename, plist->name, 11) == 0 )
	ld	e, c
	ld	d, b
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	e, -6 (ix)
	ld	d, -5 (ix)
	push	bc
	ld	hl, #0x000b
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	call	_memcmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00102$
;ftpd.c:306: pitem = plist;
	ld	a, -10 (ix)
	ld	-8 (ix), a
	ld	a, -9 (ix)
	ld	-7 (ix), a
;ftpd.c:307: break;
	jr	00103$
00102$:
;ftpd.c:309: ++plist;
	ld	hl, #0x000d
	add	hl, bc
	ld	c, l
	ld	b, h
	ld	-10 (ix), c
	ld	-9 (ix), b
;ftpd.c:302: for (i = 0; i < nlist; ++i )
	inc	-2 (ix)
	jr	NZ,00124$
	inc	-1 (ix)
	jr	00124$
00103$:
;ftpd.c:311: if (( pitem == NULL ) && ( nlist < DIRMAX ))
	ld	a, -7 (ix)
	or	a, -8 (ix)
	jr	NZ,00105$
	ld	a,(#_nlist + 1)
	sub	a, #0x02
	jr	NC,00105$
;ftpd.c:313: pitem = &dlist[nlist];
	ld	bc, (_nlist)
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, bc
	ld	de, #_dlist
	add	hl, de
;ftpd.c:314: memcpy (pitem->name, pdir->filename, 11);
	ld	-8 (ix), l
	ld	-7 (ix), h
	ex	de,hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	bc, #0x000b
	ldir
;ftpd.c:315: pitem->nkb = 0;
	ld	a, -8 (ix)
	add	a, #0x0b
	ld	c, a
	ld	a, -7 (ix)
	adc	a, #0x00
	ld	b, a
	xor	a, a
	ld	(bc), a
	inc	bc
	ld	(bc), a
;ftpd.c:316: ++nlist;
	ld	hl, (_nlist)
	inc	hl
	ld	(_nlist), hl
00105$:
;ftpd.c:322: if ( pitem != NULL )
	ld	a, -7 (ix)
	or	a, -8 (ix)
	jp	Z, 00119$
;ftpd.c:330: if ( pdir->alw[i] > 0 ) ++nblk;
	ld	a, -12 (ix)
	add	a, #0x10
	ld	-6 (ix), a
	ld	a, -11 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
;ftpd.c:326: if ( a16 )
	ld	a, -13 (ix)
	or	a, -14 (ix)
	jr	Z,00145$
;ftpd.c:328: for (i = 0; i < 8; ++i)
	xor	a, a
	ld	-4 (ix), a
	ld	-3 (ix), a
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00126$:
;ftpd.c:330: if ( pdir->alw[i] > 0 ) ++nblk;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, hl
	ld	e, -6 (ix)
	ld	d, -5 (ix)
	add	hl, de
	ld	a, (hl)
	ld	-10 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-9 (ix), a
	or	a, -10 (ix)
	jr	Z,00127$
	inc	-4 (ix)
	jr	NZ,00217$
	inc	-3 (ix)
00217$:
00127$:
;ftpd.c:328: for (i = 0; i < 8; ++i)
	inc	-2 (ix)
	jr	NZ,00218$
	inc	-1 (ix)
00218$:
	ld	a, -2 (ix)
	sub	a, #0x08
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00126$
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	jr	00115$
;ftpd.c:335: for (i = 0; i < 16; ++i)
00145$:
	xor	a, a
	ld	-4 (ix), a
	ld	-3 (ix), a
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00128$:
;ftpd.c:337: if ( pdir->alb[i] > 0 ) ++nblk;
	ld	a, -6 (ix)
	add	a, -2 (ix)
	ld	-10 (ix), a
	ld	a, -5 (ix)
	adc	a, -1 (ix)
	ld	-9 (ix), a
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	ld	a, (hl)
	or	a, a
	jr	Z,00129$
	inc	-4 (ix)
	jr	NZ,00219$
	inc	-3 (ix)
00219$:
00129$:
;ftpd.c:335: for (i = 0; i < 16; ++i)
	inc	-2 (ix)
	jr	NZ,00220$
	inc	-1 (ix)
00220$:
	ld	a, -2 (ix)
	sub	a, #0x10
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00128$
	ld	c, -4 (ix)
	ld	b, -3 (ix)
00115$:
;ftpd.c:340: pitem->nkb += nblk << kbshft;
	ld	a, -8 (ix)
	add	a, #0x0b
	ld	l, a
	ld	a, -7 (ix)
	adc	a, #0x00
	ld	h, a
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	dec	hl
	ld	a, -15 (ix)
	inc	a
	jr	00222$
00221$:
	sla	c
	rl	b
00222$:
	dec	a
	jr	NZ,00221$
	ld	a, c
	add	a, e
	ld	c, a
	ld	a, b
	adc	a, d
	ld	(hl), c
	inc	hl
	ld	(hl), a
00119$:
;ftpd.c:352: idx = bdos_search_for_next (&fcb);
	ld	hl, #_ftp_dlist_fcb_65536_136
	push	hl
	call	_bdos_search_for_next
	pop	af
	ld	c, l
	ld	b, #0x00
	jp	00120$
00122$:
;ftpd.c:354: log_printf ("done\r\n");
	ld	hl, #___str_10
	push	hl
	call	_log_printf
;ftpd.c:360: }
	ld	sp,ix
	pop	ix
	ret
___str_8:
	.ascii "Generating file list ... $"
	.db 0x00
___str_9:
	.ascii "????????????"
	.db 0x00
___str_10:
	.ascii "done"
	.db 0x0d
	.db 0x0a
	.db 0x00
;ftpd.c:362: static void ftp_null(FTP *pftp)
;	---------------------------------
; Function ftp_null
; ---------------------------------
_ftp_null:
;ftpd.c:364: pftp = pftp;
;ftpd.c:365: }
	ret
;ftpd.c:367: static void ftpc_reply (FTP *pftp)
;	---------------------------------
; Function ftpc_reply
; ---------------------------------
_ftpc_reply:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;ftpd.c:372: log_printf ("ftpc_reply: $");
	ld	hl, #___str_11
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:373: log_line (pftp->psta);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	hl, #0x0069
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	dec	hl
	push	hl
	push	de
	push	bc
	call	_log_line
	pop	af
	pop	de
	pop	hl
;ftpd.c:374: net_send (pftp->sacmd.socket, pftp->psta, strlen (pftp->psta), (NF) ftpc_read, pftp);
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	-2 (ix), #<(_ftpc_read)
	ld	-1 (ix), #>(_ftpc_read)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	dec	hl
	push	hl
	push	bc
	call	_strlen
	ex	(sp),hl
	pop	iy
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ex	de,hl
	ld	de, #0x000e
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	iy
	push	bc
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:375: }
	ld	sp, ix
	pop	ix
	ret
___str_11:
	.ascii "ftpc_reply: $"
	.db 0x00
;ftpd.c:377: static void ftpd_closed (FTP *pftp)
;	---------------------------------
; Function ftpd_closed
; ---------------------------------
_ftpd_closed:
;ftpd.c:383: pftp->md = mdIdle;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0077
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:384: pftp->pasv = 0;
	ld	hl, #0x0075
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;ftpd.c:385: pftp->dcon = 0;
	ld	hl, #0x0078
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:392: ftpc_reply (pftp);
	push	bc
	call	_ftpc_reply
	pop	af
;ftpd.c:394: }
	ret
;ftpd.c:396: static void ftpd_close (FTP *pftp)
;	---------------------------------
; Function ftpd_close
; ---------------------------------
_ftpd_close:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:402: net_disconnect (pftp->sadat.socket, (NF) ftpd_closed, pftp);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	bc, #_ftpd_closed
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	bc
	ld	bc, #0x0017
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	push	bc
	push	hl
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;ftpd.c:403: }
	pop	ix
	ret
;ftpd.c:405: static void ftpd_done (FTP *pftp)
;	---------------------------------
; Function ftpd_done
; ---------------------------------
_ftpd_done:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;ftpd.c:412: net_send (pftp->sacmd.socket, pftp->psta, strlen (pftp->psta), (NF) ftpd_close, pftp);
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	-2 (ix), #<(_ftpd_close)
	ld	-1 (ix), #>(_ftpd_close)
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	hl, #0x0069
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	dec	hl
	push	hl
	push	bc
	call	_strlen
	ex	(sp),hl
	pop	iy
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ex	de,hl
	ld	de, #0x000e
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	iy
	push	bc
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:413: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:415: static void ftpd_send (FTP *pftp)
;	---------------------------------
; Function ftpd_send
; ---------------------------------
_ftpd_send:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-7
	add	hl, sp
	ld	sp, hl
;ftpd.c:421: bdos_set_dma_address (pftp->dat);
	ld	a, 4 (ix)
	ld	-7 (ix), a
	ld	a, 5 (ix)
	ld	-6 (ix), a
	ld	a, -7 (ix)
	add	a, #0x9f
	ld	-5 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-4 (ix), a
	pop	de
	pop	bc
	push	bc
	push	de
	push	bc
	call	_bdos_set_dma_address
	pop	af
;ftpd.c:422: if ( bdos_read_file (&pftp->fcb) == 0 )
	ld	a, -7 (ix)
	add	a, #0x7b
	ld	-3 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_read_file
	pop	af
	ld	-1 (ix), l
	ld	a, l
	or	a, a
	jr	NZ,00102$
;ftpd.c:424: net_send (pftp->sadat.socket, pftp->dat, FTPD_BLEN, (NF) ftpd_send, pftp);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	bc, #_ftpd_send
	pop	hl
	push	hl
	push	bc
	ld	bc, #0x0017
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	push	bc
	ld	bc, #0x0080
	push	bc
	ld	c, -5 (ix)
	ld	b, -4 (ix)
	push	bc
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
	jr	00104$
00102$:
;ftpd.c:428: bdos_close_file (&pftp->fcb);
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_close_file
	pop	af
;ftpd.c:429: pftp->md = 0;
	ld	a, -7 (ix)
	add	a, #0x77
	ld	-2 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), #0x00
;ftpd.c:430: pftp->psta = sta226;
	ld	a, -7 (ix)
	add	a, #0x69
	ld	-2 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), #<(_sta226)
	inc	hl
	ld	(hl), #>(_sta226)
;ftpd.c:431: ftpd_close (pftp);
	pop	hl
	push	hl
	push	hl
	call	_ftpd_close
	pop	af
00104$:
;ftpd.c:434: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:436: static void ftpd_list (FTP *pftp)
;	---------------------------------
; Function ftpd_list
; ---------------------------------
_ftpd_list:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-17
	add	hl, sp
	ld	sp, hl
;ftpd.c:439: char *ps = (char *) pftp->dat;
	ld	a, 4 (ix)
	ld	-15 (ix), a
	ld	a, 5 (ix)
	ld	-14 (ix), a
	ld	a, -15 (ix)
	add	a, #0x9f
	ld	-13 (ix), a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	-12 (ix), a
	ld	a, -13 (ix)
	ld	-2 (ix), a
	ld	a, -12 (ix)
	ld	-1 (ix), a
;ftpd.c:442: int n = 8;
	ld	bc, #0x0008
;ftpd.c:450: if ( pftp->md & mdLDir ) n = 2;
	ld	a, -15 (ix)
	add	a, #0x77
	ld	-11 (ix), a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	-10 (ix), a
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	ld	a, (hl)
	bit	2, a
	jr	Z,00104$
	ld	bc, #0x0002
	jr	00152$
00104$:
;ftpd.c:451: else if ( pftp->md & mdMLst ) n = 3;
	bit	3, a
	jr	Z,00152$
	ld	bc, #0x0003
;ftpd.c:452: while (( n > 0 ) && ( pftp->iFind < nlist ))
00152$:
	ld	-4 (ix), c
	ld	-3 (ix), b
00123$:
	ld	a, -15 (ix)
	add	a, #0x79
	ld	-7 (ix), a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	-6 (ix), a
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	e, c
	ld	d, b
	ld	hl, #_nlist
	ld	a, e
	sub	a, (hl)
	ld	a, d
	inc	hl
	sbc	a, (hl)
	ld	a, #0x00
	rla
	ld	-5 (ix), a
	xor	a, a
	cp	a, -4 (ix)
	sbc	a, -3 (ix)
	jp	PO, 00228$
	xor	a, #0x80
00228$:
	jp	P, 00125$
	ld	a, -7 (ix)
	ld	-9 (ix), a
	ld	a, -6 (ix)
	ld	-8 (ix), a
	ld	a, -5 (ix)
	or	a, a
	jp	Z, 00125$
;ftpd.c:454: DITEM *pitem = &dlist[pftp->iFind];
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, bc
	ld	de, #_dlist
	add	hl, de
	ld	-7 (ix), l
	ld	-6 (ix), h
;ftpd.c:461: if ( ftp_match (pftp->fcb.filename, pitem->name) )
	ld	a, -15 (ix)
	add	a, #0x7c
	ld	c, a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	b, a
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	push	bc
	call	_ftp_match
	pop	af
	pop	af
	ld	c, l
	ld	a, h
	or	a, c
	jp	Z, 00121$
;ftpd.c:465: int iSize = pitem->nkb;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	de, #0x000b
	add	hl, de
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
;ftpd.c:471: if ( pftp->md & mdMLst )
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	ld	c, (hl)
;ftpd.c:474: ps = ftp_uint (ps, iSize);
	ld	-17 (ix), b
	ld	-16 (ix), e
;ftpd.c:471: if ( pftp->md & mdMLst )
	bit	3, c
	jr	Z,00112$
;ftpd.c:473: ps = ftp_copy (ps, "type=file;size=");
	ld	hl, #___str_12
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
;ftpd.c:474: ps = ftp_uint (ps, iSize);
	pop	bc
	push	bc
	push	bc
	push	hl
	call	_ftp_uint
	pop	af
	pop	af
;ftpd.c:475: ps = ftp_copy (ps, "000; ");
	ld	bc, #___str_13
	push	bc
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	jr	00113$
00112$:
;ftpd.c:477: else if ( pftp->md & mdLDir )
	bit	2, c
	jr	Z,00113$
;ftpd.c:479: if ( pitem->name[8] & 0x80 ) ps = ftp_copy (ps, "-r--r--r--");
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	de, #0x0008
	add	hl, de
	ld	a, (hl)
	rlca
	jr	NC,00107$
	ld	hl, #___str_14
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
	jr	00108$
00107$:
;ftpd.c:480: else ps = ftp_copy (ps, "-rw-rw-rw-");
	ld	hl, #___str_15
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
00108$:
;ftpd.c:481: ps = ftp_copy (ps, " 1 0    0    ");
	ld	bc, #___str_16
	push	bc
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
;ftpd.c:482: ps = ftp_uint (ps, iSize);
	pop	bc
	push	bc
	push	bc
	push	hl
	call	_ftp_uint
	pop	af
	pop	af
;ftpd.c:483: ps = ftp_copy (ps, "000 Jan  1  0:00 ");
	ld	bc, #___str_17
	push	bc
	push	hl
	call	_ftp_copy
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
00113$:
;ftpd.c:485: ps1 = ps;
	ld	c, -2 (ix)
	ld	b, -1 (ix)
;ftpd.c:486: for (j = 0; j < 8; ++j)
	ld	de, #0x0000
00132$:
;ftpd.c:488: ch = pitem->name[j] & 0x7F;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	add	hl, de
	ld	a, (hl)
	and	a, #0x7f
	ld	-5 (ix), a
;ftpd.c:489: *(ps++) = ch;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -5 (ix)
	ld	(hl), a
	inc	-2 (ix)
	jr	NZ,00232$
	inc	-1 (ix)
00232$:
;ftpd.c:490: if ( ch > ' ' ) ps1 = ps;
	ld	a, #0x20
	sub	a, -5 (ix)
	jr	NC,00133$
	ld	c, -2 (ix)
	ld	b, -1 (ix)
00133$:
;ftpd.c:486: for (j = 0; j < 8; ++j)
	inc	de
	ld	a, e
	sub	a, #0x08
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00132$
;ftpd.c:492: *(ps1++) = '.';
	ld	a, #0x2e
	ld	(bc), a
	inc	bc
;ftpd.c:494: for (j = 8; j < 11; ++j)
	ld	de, #0x0008
	ld	-2 (ix), c
	ld	-1 (ix), b
00134$:
;ftpd.c:496: ch = pitem->name[j] & 0x7F;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	add	hl, de
	ld	a, (hl)
	and	a, #0x7f
	ld	-5 (ix), a
;ftpd.c:497: *(ps++) = ch;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -5 (ix)
	ld	(hl), a
	inc	-2 (ix)
	jr	NZ,00233$
	inc	-1 (ix)
00233$:
;ftpd.c:498: if ( ch > ' ' ) ps1 = ps;
	ld	a, #0x20
	sub	a, -5 (ix)
	jr	NC,00135$
	ld	c, -2 (ix)
	ld	b, -1 (ix)
00135$:
;ftpd.c:494: for (j = 8; j < 11; ++j)
	inc	de
	ld	a, e
	sub	a, #0x0b
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00134$
;ftpd.c:500: *(ps1++) = '\r';
	ld	a, #0x0d
	ld	(bc), a
	inc	bc
;ftpd.c:501: *(ps1++) = '\n';
	ld	a, #0x0a
	ld	(bc), a
	inc	bc
	ld	-2 (ix), c
	ld	-1 (ix), b
;ftpd.c:506: --n;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	dec	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
00121$:
;ftpd.c:508: ++pftp->iFind;
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
	jp	00123$
00125$:
;ftpd.c:518: if ( ps > pftp->dat ) net_send (pftp->sadat.socket, pftp->dat, ps - pftp->dat, (NF) ftpd_close, pftp);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, -2 (ix)
	sub	a, -13 (ix)
	ld	c, a
	ld	a, -1 (ix)
	sbc	a, -12 (ix)
	ld	b, a
	ld	a, -15 (ix)
	add	a, #0x17
	ld	-4 (ix), a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
;ftpd.c:513: if ( pftp->iFind >= nlist )
	bit	0,-5 (ix)
	jr	NZ,00130$
;ftpd.c:516: pftp->md = 0;
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	ld	(hl), #0x00
;ftpd.c:517: pftp->psta = sta226;
	ld	a, -15 (ix)
	add	a, #0x69
	ld	-6 (ix), a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	(hl), #<(_sta226)
	inc	hl
	ld	(hl), #>(_sta226)
;ftpd.c:518: if ( ps > pftp->dat ) net_send (pftp->sadat.socket, pftp->dat, ps - pftp->dat, (NF) ftpd_close, pftp);
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	ld	a, l
	sub	a, -2 (ix)
	ld	a, h
	sbc	a, -1 (ix)
	jr	NC,00127$
	ld	-2 (ix), #<(_ftpd_close)
	ld	-1 (ix), #>(_ftpd_close)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	de
	push	bc
	ld	c, -13 (ix)
	ld	b, -12 (ix)
	push	bc
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
	jr	00136$
00127$:
;ftpd.c:519: else ftpd_close (pftp);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_ftpd_close
	pop	af
	jr	00136$
00130$:
;ftpd.c:523: net_send (pftp->sadat.socket, pftp->dat, ps - pftp->dat, (NF) ftpd_list, pftp);
	ld	-2 (ix), #<(_ftpd_list)
	ld	-1 (ix), #>(_ftpd_list)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	de
	push	bc
	ld	c, -13 (ix)
	ld	b, -12 (ix)
	push	bc
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00136$:
;ftpd.c:525: }
	ld	sp, ix
	pop	ix
	ret
___str_12:
	.ascii "type=file;size="
	.db 0x00
___str_13:
	.ascii "000; "
	.db 0x00
___str_14:
	.ascii "-r--r--r--"
	.db 0x00
___str_15:
	.ascii "-rw-rw-rw-"
	.db 0x00
___str_16:
	.ascii " 1 0    0    "
	.db 0x00
___str_17:
	.ascii "000 Jan  1  0:00 "
	.db 0x00
;ftpd.c:527: static void ftpd_read (FTP *pftp)
;	---------------------------------
; Function ftpd_read
; ---------------------------------
_ftpd_read:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-12
	add	hl, sp
	ld	sp, hl
;ftpd.c:529: BOOLEAN bClose = TRUE;
	ld	hl, #0x0001
	ex	(sp), hl
;ftpd.c:538: pftp->psta = sta226;
	ld	a, 4 (ix)
	ld	-10 (ix), a
	ld	a, 5 (ix)
	ld	-9 (ix), a
	ld	a, -10 (ix)
	add	a, #0x69
	ld	-8 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-7 (ix), a
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	(hl), #<(_sta226)
	inc	hl
	ld	(hl), #>(_sta226)
;ftpd.c:539: if ( pftp->sadat.socket->state != SS_ERROR )
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	de, #0x0017
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	de, #0x000e
	add	hl, de
	ld	c, (hl)
;ftpd.c:541: pftp->ndat += pftp->sadat.socket->actual;
	ld	a, -10 (ix)
	add	a, #0x1f
	ld	-6 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x01
	ld	-5 (ix), a
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;ftpd.c:539: if ( pftp->sadat.socket->state != SS_ERROR )
	ld	a, c
	sub	a, #0x07
	jr	Z,00105$
;ftpd.c:541: pftp->ndat += pftp->sadat.socket->actual;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	de, #0x001e
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, bc
	ex	de, hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
;ftpd.c:543: bClose = FALSE;
	ld	hl, #0x0000
	ex	(sp), hl
	jr	00106$
00105$:
;ftpd.c:549: if ( pftp->ndat > 0 )
	ld	a, -6 (ix)
	ld	-4 (ix), a
	ld	a, -5 (ix)
	ld	-3 (ix), a
	xor	a, a
	cp	a, -2 (ix)
	sbc	a, -1 (ix)
	jp	PO, 00156$
	xor	a, #0x80
00156$:
	jp	P, 00106$
;ftpd.c:552: for (i = pftp->ndat; i < FTPD_BLEN; ++i) pftp->dat[i] = 0x1A;
	ld	a, -10 (ix)
	add	a, #0x9f
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
00115$:
	ld	a, -2 (ix)
	sub	a, #0x80
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	NC,00101$
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, bc
	ld	(hl), #0x1a
	inc	-2 (ix)
	jr	NZ,00115$
	inc	-1 (ix)
	jr	00115$
00101$:
;ftpd.c:553: pftp->ndat = FTPD_BLEN;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	(hl), #0x80
	inc	hl
	ld	(hl), #0x00
00106$:
;ftpd.c:557: if ( pftp->ndat >= FTPD_BLEN )
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;ftpd.c:563: if ( bdos_write_file (&pftp->fcb) != 0 )
	ld	a, -10 (ix)
	add	a, #0x7b
	ld	-3 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
;ftpd.c:557: if ( pftp->ndat >= FTPD_BLEN )
	ld	a, c
	sub	a, #0x80
	ld	a, b
	rla
	ccf
	rra
	sbc	a, #0x80
	jp	C, 00110$
;ftpd.c:562: bdos_set_dma_address (pftp->dat);
	ld	a, -10 (ix)
	add	a, #0x9f
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
	push	bc
	call	_bdos_set_dma_address
	pop	af
;ftpd.c:563: if ( bdos_write_file (&pftp->fcb) != 0 )
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_write_file
	pop	af
	ld	-1 (ix), l
	ld	a, l
	or	a, a
	jp	Z, 00108$
;ftpd.c:565: log_printf ("Save failed\r\n$");
	ld	hl, #___str_18
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:566: bdos_close_file (&pftp->fcb);
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_close_file
	pop	af
;ftpd.c:567: pftp->fcb.ex = 0;
	ld	a, -10 (ix)
	add	a, #0x87
	ld	-12 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-11 (ix), a
	pop	hl
	push	hl
	ld	(hl), #0x00
;ftpd.c:568: pftp->fcb.s1 = 0;
	ld	a, -10 (ix)
	add	a, #0x88
	ld	-12 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-11 (ix), a
	pop	hl
	push	hl
	ld	(hl), #0x00
;ftpd.c:569: pftp->fcb.s2 = 0;
	ld	a, -10 (ix)
	add	a, #0x89
	ld	-12 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-11 (ix), a
	pop	hl
	push	hl
	ld	(hl), #0x00
;ftpd.c:570: pftp->fcb.cr = 0;
	ld	a, -10 (ix)
	add	a, #0x9b
	ld	-12 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-11 (ix), a
	pop	hl
	push	hl
	ld	(hl), #0x00
;ftpd.c:571: bdos_delete_files (&pftp->fcb);
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_delete_files
	pop	af
;ftpd.c:572: bClose = TRUE;
	ld	hl, #0x0001
	ex	(sp), hl
;ftpd.c:573: pftp->psta = sta552;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	(hl), #<(_sta552)
	inc	hl
	ld	(hl), #>(_sta552)
00108$:
;ftpd.c:575: pftp->ndat = 0;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
00110$:
;ftpd.c:577: if ( bClose )
	ld	a, -11 (ix)
	or	a, -12 (ix)
	jr	Z,00112$
;ftpd.c:582: bdos_close_file (&pftp->fcb);
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	call	_bdos_close_file
	pop	af
;ftpd.c:583: pftp->md = 0;
	ld	a, -10 (ix)
	add	a, #0x77
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
	xor	a, a
	ld	(bc), a
;ftpd.c:584: ftpd_close (pftp);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_ftpd_close
	pop	af
	jr	00117$
00112$:
;ftpd.c:586: else ftpd_recv (pftp);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_ftpd_recv
	pop	af
00117$:
;ftpd.c:587: }
	ld	sp, ix
	pop	ix
	ret
___str_18:
	.ascii "Save failed"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:589: static void ftpd_recv (FTP *pftp)
;	---------------------------------
; Function ftpd_recv
; ---------------------------------
_ftpd_recv:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;ftpd.c:595: net_recv (pftp->sadat.socket, &pftp->dat[pftp->ndat], FTPD_BLEN - pftp->ndat, (NF) ftpd_read, pftp);
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	-4 (ix), #<(_ftpd_read)
	ld	-3 (ix), #>(_ftpd_read)
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x011f
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, #0x80
	sub	a, e
	ld	-2 (ix), a
	ld	a, #0x00
	sbc	a, d
	ld	-1 (ix), a
	ld	hl, #0x009f
	add	hl, bc
	add	hl, de
	ex	de, hl
	ld	l, c
	ld	h, b
	ld	bc, #0x0017
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:596: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:598: static void ftpd_connect (FTP *pftp)
;	---------------------------------
; Function ftpd_connect
; ---------------------------------
_ftpd_connect:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:603: log_printf ("ftpd_connect: $");
	ld	hl, #___str_19
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:604: pftp->dcon = 1;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0078
	add	hl, bc
	ld	(hl), #0x01
;ftpd.c:605: switch (pftp->md & mdCmnd)
	ld	l, c
	ld	h, b
	ld	de, #0x0077
	add	hl, de
	ld	a, (hl)
	and	a, #0xf0
	ld	e, a
	ld	d, #0x00
	ld	a, e
	sub	a, #0x10
	or	a, d
	jr	Z,00101$
	ld	a, e
	sub	a, #0x20
	or	a, d
	jr	Z,00102$
	ld	a, e
	sub	a, #0x30
	or	a, d
	jr	Z,00103$
	jr	00104$
;ftpd.c:607: case mdSend:
00101$:
;ftpd.c:608: log_printf ("Send\r\n$");
	push	bc
	ld	hl, #___str_20
	push	hl
	call	_log_printf
	pop	af
	call	_ftpd_send
	pop	af
;ftpd.c:610: break;
	jr	00106$
;ftpd.c:611: case mdRecv:
00102$:
;ftpd.c:612: log_printf ("Receive\r\n$");
	push	bc
	ld	hl, #___str_21
	push	hl
	call	_log_printf
	pop	af
	call	_ftpd_recv
	pop	af
;ftpd.c:614: break;
	jr	00106$
;ftpd.c:615: case mdList:
00103$:
;ftpd.c:616: log_printf ("List\r\n$");
	push	bc
	ld	hl, #___str_22
	push	hl
	call	_log_printf
	pop	af
	call	_ftpd_list
	pop	af
;ftpd.c:618: break;
	jr	00106$
;ftpd.c:619: default:
00104$:
;ftpd.c:620: log_printf ("Unknown\r\n$");
	ld	hl, #___str_23
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:622: }
00106$:
;ftpd.c:623: }
	pop	ix
	ret
___str_19:
	.ascii "ftpd_connect: $"
	.db 0x00
___str_20:
	.ascii "Send"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_21:
	.ascii "Receive"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_22:
	.ascii "List"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_23:
	.ascii "Unknown"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:625: static void ftpd_open (FTP *pftp)
;	---------------------------------
; Function ftpd_open
; ---------------------------------
_ftpd_open:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;ftpd.c:627: word port = ( (word) pftp->daddr[4] << 8 ) | pftp->daddr[5];
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0073
	add	hl, de
	ld	d, (hl)
	ld	e, #0x00
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x0074
	add	hl, bc
	pop	bc
	ld	l, (hl)
	ld	h, #0x00
	ld	a, e
	or	a, l
	ld	e, a
	ld	a, d
	or	a, h
	ld	d, a
;ftpd.c:632: net_connect (pftp->sadat.socket, pftp->daddr, port, (NF) ftpd_connect, pftp);
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	-4 (ix), #<(_ftpd_connect)
	ld	-3 (ix), #>(_ftpd_connect)
	ld	hl, #0x006f
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	l, c
	ld	h, b
	ld	bc, #0x0017
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	bc
	call	_net_connect
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:633: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:635: static void ftpd_start (FTP *pftp)
;	---------------------------------
; Function ftpd_start
; ---------------------------------
_ftpd_start:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;ftpd.c:641: pftp->psta = sta150;
	ld	a, 4 (ix)
	ld	-10 (ix), a
	ld	a, 5 (ix)
	ld	-9 (ix), a
	ld	a, -10 (ix)
	add	a, #0x69
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, #<(_sta150)
	ld	(bc), a
	inc	bc
	ld	a, #>(_sta150)
	ld	(bc), a
;ftpd.c:642: if ( pftp->pasv == 0 )
	pop	hl
	push	hl
	ld	de, #0x0075
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;ftpd.c:647: pftp->fbr.nf = (NF) ftpd_open;
	ld	a, -10 (ix)
	add	a, #0x02
	ld	-8 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-7 (ix), a
;ftpd.c:648: pftp->fbr.nfp = pftp;
	ld	a, -10 (ix)
	add	a, #0x04
	ld	-6 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
;ftpd.c:642: if ( pftp->pasv == 0 )
	ld	a, b
	or	a, c
	jr	NZ,00104$
;ftpd.c:647: pftp->fbr.nf = (NF) ftpd_open;
	ld	bc, #_ftpd_open
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), c
	inc	hl
	ld	(hl), b
;ftpd.c:648: pftp->fbr.nfp = pftp;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -3 (ix)
	ld	(hl), a
;ftpd.c:649: fiber_enqueue (&(pftp->fbr));
	pop	hl
	push	hl
	push	hl
	call	_fiber_enqueue
	pop	af
	jr	00106$
00104$:
;ftpd.c:651: else if ( pftp->dcon )
	ld	a, -10 (ix)
	ld	-2 (ix), a
	ld	a, -9 (ix)
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	de, #0x0078
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	Z,00106$
;ftpd.c:656: pftp->fbr.nf = (NF) ftpd_connect;
	ld	bc, #_ftpd_connect
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), c
	inc	hl
	ld	(hl), b
;ftpd.c:657: pftp->fbr.nfp = pftp;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -3 (ix)
	ld	(hl), a
;ftpd.c:658: fiber_enqueue (&(pftp->fbr));
	pop	hl
	push	hl
	push	hl
	call	_fiber_enqueue
	pop	af
00106$:
;ftpd.c:672: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:674: static void ftpc_close(FTP *pftp)
;	---------------------------------
; Function ftpc_close
; ---------------------------------
_ftpc_close:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:680: net_disconnect (pftp->sacmd.socket, (NF) ftpc_listen, pftp);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	bc, #_ftpc_listen
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	push	bc
	push	hl
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;ftpd.c:681: }
	pop	ix
	ret
;ftpd.c:683: static void ftpc_quit (FTP *pftp)
;	---------------------------------
; Function ftpc_quit
; ---------------------------------
_ftpc_quit:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;ftpd.c:688: log_printf ("ftpc_quit: $");
	ld	hl, #___str_24
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:689: log_line (pftp->psta);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	hl, #0x0069
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	dec	hl
	push	hl
	push	de
	push	bc
	call	_log_line
	pop	af
	pop	de
	pop	hl
;ftpd.c:690: net_send (pftp->sacmd.socket, pftp->psta, strlen (pftp->psta), (NF) ftpc_close, pftp);
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	-2 (ix), #<(_ftpc_close)
	ld	-1 (ix), #>(_ftpc_close)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	dec	hl
	push	hl
	push	bc
	call	_strlen
	ex	(sp),hl
	pop	iy
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ex	de,hl
	ld	de, #0x000e
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	iy
	push	bc
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:691: }
	ld	sp, ix
	pop	ix
	ret
___str_24:
	.ascii "ftpc_quit: $"
	.db 0x00
;ftpd.c:693: int strncasecmp (const char *ps1, const char *ps2, int n)
;	---------------------------------
; Function strncasecmp
; ---------------------------------
_strncasecmp::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;ftpd.c:695: while (n > 0)
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	e, 6 (ix)
	ld	d, 7 (ix)
	ld	a, 8 (ix)
	ld	-2 (ix), a
	ld	a, 9 (ix)
	ld	-1 (ix), a
00109$:
	xor	a, a
	cp	a, -2 (ix)
	sbc	a, -1 (ix)
	jp	PO, 00149$
	xor	a, #0x80
00149$:
	jp	P, 00111$
;ftpd.c:697: char ch1 = *ps1;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	ld	-5 (ix), a
;ftpd.c:698: char ch2 = *ps2;
	ld	a, (de)
	ld	c, a
;ftpd.c:699: if ((ch1 >= 'a') && (ch1 <= 'z')) ch1 -= 0x20;
	ld	a, -5 (ix)
	sub	a, #0x61
	jr	C,00102$
	ld	a, #0x7a
	sub	a, -5 (ix)
	jr	C,00102$
	ld	a, -5 (ix)
	add	a, #0xe0
	ld	-5 (ix), a
00102$:
;ftpd.c:700: if ((ch2 >= 'a') && (ch2 <= 'z')) ch2 -= 0x20;
	ld	a, c
	sub	a, #0x61
	jr	C,00105$
	ld	a, #0x7a
	sub	a, c
	jr	C,00105$
	ld	a, c
	add	a, #0xe0
	ld	c, a
00105$:
;ftpd.c:701: ch2 -= ch1;
	ld	a, c
	sub	a, -5 (ix)
;ftpd.c:702: if ( ch2 != 0 ) return (int) ch2;
	or	a, a
	jr	Z,00108$
	ld	l, a
	ld	h, #0x00
	jr	00112$
00108$:
;ftpd.c:703: ++ps1;
	inc	-4 (ix)
	jr	NZ,00150$
	inc	-3 (ix)
00150$:
;ftpd.c:704: ++ps2;
	inc	de
;ftpd.c:705: --n;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
	jr	00109$
00111$:
;ftpd.c:707: return 0;
	ld	hl, #0x0000
00112$:
;ftpd.c:708: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:710: static void ftpc_cmnd(FTP *pftp)
;	---------------------------------
; Function ftpc_cmnd
; ---------------------------------
_ftpc_cmnd:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-24
	add	hl, sp
	ld	sp, hl
;ftpd.c:712: const char *pcmd = pftp->buf + pftp->rptr;
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	ld	a, -2 (ix)
	add	a, #0x19
	ld	-6 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, -2 (ix)
	ld	-4 (ix), a
	ld	a, -1 (ix)
	ld	-3 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	de, #0x006b
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	ld	a, -6 (ix)
	add	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, -5 (ix)
	adc	a, -3 (ix)
	ld	-7 (ix), a
;ftpd.c:716: log_printf ("ftpc_cmnd: $");
	ld	hl, #___str_25
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:717: log_line (pcmd);
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_log_line
;ftpd.c:718: if ( ! strncasecmp (pcmd, "user", 4) )
	ld	hl, #0x0004
	ex	(sp),hl
	ld	hl, #___str_26
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
;ftpd.c:720: pftp->psta = sta230;
	ld	a, -2 (ix)
	add	a, #0x69
	ld	-18 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-17 (ix), a
;ftpd.c:718: if ( ! strncasecmp (pcmd, "user", 4) )
	ld	a, -3 (ix)
	or	a, -4 (ix)
	jr	NZ,00267$
;ftpd.c:720: pftp->psta = sta230;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta230)
	inc	hl
	ld	(hl), #>(_sta230)
	jp	00268$
00267$:
;ftpd.c:722: else if ( ! strncasecmp (pcmd, "quit", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_27
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, h
	or	a, -4 (ix)
	jr	NZ,00264$
;ftpd.c:724: pftp->psta = sta221;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta221)
	inc	hl
	ld	(hl), #>(_sta221)
;ftpd.c:725: ftpc_quit (pftp);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftpc_quit
	pop	af
;ftpd.c:726: return;
	jp	00271$
00264$:
;ftpd.c:728: else if ( ! strncasecmp (pcmd, "port", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_28
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
;ftpd.c:733: pcmd += 4;
	ld	a, -8 (ix)
	add	a, #0x04
	ld	-4 (ix), a
	ld	a, -7 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
;ftpd.c:763: if ( pftp->pasv != 0 )
	ld	a, -2 (ix)
	add	a, #0x75
	ld	-16 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-15 (ix), a
;ftpd.c:765: net_disconnect (pftp->sadat.socket, (NF) ftp_null, pftp);
	ld	a, 4 (ix)
	ld	-14 (ix), a
	ld	a, 5 (ix)
	ld	-13 (ix), a
	ld	a, -2 (ix)
	add	a, #0x17
	ld	-12 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-11 (ix), a
;ftpd.c:728: else if ( ! strncasecmp (pcmd, "port", 4) )
	ld	a, -5 (ix)
	or	a, -6 (ix)
	jp	NZ, 00261$
;ftpd.c:730: int n = 0;
	xor	a, a
	ld	-10 (ix), a
	ld	-9 (ix), a
;ftpd.c:731: word b = 0;
	xor	a, a
	ld	-8 (ix), a
	ld	-7 (ix), a
;ftpd.c:732: BOOLEAN bValid = TRUE;
	ld	-6 (ix), #0x01
	xor	a, a
	ld	-5 (ix), a
;ftpd.c:733: pcmd += 4;
	ld	e, -4 (ix)
	ld	d, -3 (ix)
;ftpd.c:734: while ( *pcmd == ' ' ) ++pcmd;
00101$:
	ld	a, (de)
	sub	a, #0x20
	jr	NZ,00283$
	inc	de
	jr	00101$
;ftpd.c:735: while (TRUE)
00283$:
	ld	a, -2 (ix)
	add	a, #0x6f
	ld	-4 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
	ld	bc, #0x0000
	ld	-2 (ix), e
	ld	-1 (ix), d
00116$:
;ftpd.c:737: char ch = *pcmd;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	e, (hl)
;ftpd.c:738: if ((ch >= '0') && (ch <= '9'))
	ld	a, e
	sub	a, #0x30
	jr	C,00112$
	ld	a, #0x39
	sub	a, e
	jr	C,00112$
;ftpd.c:740: b = 10 * b + ( ch - '0' );
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	de
	ld	e, l
	ld	d, h
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	pop	de
	ld	d, #0x00
	ld	a, e
	add	a, #0xd0
	ld	e, a
	ld	a, d
	adc	a, #0xff
	ld	d, a
	add	hl, de
;ftpd.c:741: if ( b > 255 ) bValid = FALSE;
	ld	-8 (ix), l
	ld	-7 (ix), h
	ex	de,hl
	ld	a, #0xff
	cp	a, e
	ld	a, #0x00
	sbc	a, d
	jr	NC,00113$
	xor	a, a
	ld	-6 (ix), a
	ld	-5 (ix), a
	jr	00113$
00112$:
;ftpd.c:743: else if (ch == ',')
	ld	a, e
	sub	a, #0x2c
	jr	NZ,00117$
;ftpd.c:745: pftp->daddr[n] = (byte) b;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	add	hl, bc
	ld	a, -8 (ix)
	ld	(hl), a
;ftpd.c:746: b = 0;
	xor	a, a
	ld	-8 (ix), a
	ld	-7 (ix), a
;ftpd.c:747: if ( ++n >= 6 )
	inc	bc
	ld	-10 (ix), c
	ld	-9 (ix), b
	ld	a, c
	sub	a, #0x06
	ld	a, b
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00113$
;ftpd.c:749: bValid = FALSE;
	xor	a, a
	ld	-6 (ix), a
	ld	-5 (ix), a
;ftpd.c:750: break;
	jr	00117$
;ftpd.c:755: break;
00113$:
;ftpd.c:757: ++pcmd;
	inc	-2 (ix)
	jr	NZ,00116$
	inc	-1 (ix)
	jp	00116$
00117$:
;ftpd.c:759: if ( n == 5 ) pftp->daddr[n] = (byte) b;
	ld	a, -10 (ix)
	sub	a, #0x05
	or	a, -9 (ix)
	jr	NZ,00119$
	ld	a, -4 (ix)
	add	a, -10 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	adc	a, -9 (ix)
	ld	-1 (ix), a
	ld	a, -8 (ix)
	ld	-3 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -3 (ix)
	ld	(hl), a
	jr	00120$
00119$:
;ftpd.c:760: else bValid = FALSE;
	xor	a, a
	ld	-6 (ix), a
	ld	-5 (ix), a
00120$:
;ftpd.c:761: if ( bValid )
	ld	a, -5 (ix)
	or	a, -6 (ix)
	jr	Z,00124$
;ftpd.c:763: if ( pftp->pasv != 0 )
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	jr	Z,00122$
;ftpd.c:765: net_disconnect (pftp->sadat.socket, (NF) ftp_null, pftp);
	ld	de, #_ftp_null
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	push	hl
	push	de
	push	bc
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;ftpd.c:766: pftp->pasv = 0;
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
00122$:
;ftpd.c:768: pftp->psta = sta200;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta200)
	inc	hl
	ld	(hl), #>(_sta200)
	jp	00268$
00124$:
;ftpd.c:772: pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00261$:
;ftpd.c:775: else if ( ! strncasecmp (pcmd, "pasv", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_29
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	a, h
	or	a, -6 (ix)
	jp	NZ, 00258$
;ftpd.c:780: if ( pftp->pasv == 0 )
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	or	a, -2 (ix)
	jr	NZ,00127$
;ftpd.c:782: pftp->pasv = net_next_ephemeral_port ();
	call	_net_next_ephemeral_port
	ex	de,hl
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
;ftpd.c:783: net_listen (pftp->sadat.socket, pftp->pasv, (NF) ftpd_connect, pftp);
	ld	-2 (ix), #<(_ftpd_connect)
	ld	-1 (ix), #>(_ftpd_connect)
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_net_listen
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
00127$:
;ftpd.c:785: wiz_read_n (W5100_ADDR_REG_SIPR0, addr, 4);
	ld	hl, #0
	add	hl, sp
	ld	c, l
	ld	b, h
	ld	e, c
	ld	d, b
	push	bc
	ld	hl, #0x0004
	push	hl
	push	de
	ld	l, #0x0f
	push	hl
	call	_wiz_read_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;ftpd.c:786: addr[4] = pftp->pasv >> 8;
	ld	hl, #0x0004
	add	hl, bc
	ex	de, hl
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	inc	hl
	ld	a, (hl)
	ld	(de), a
;ftpd.c:787: addr[5] = pftp->pasv & 0xFF;
	ld	hl, #0x0005
	add	hl, bc
	ex	de, hl
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	ld	a, (hl)
	ld	(de), a
;ftpd.c:792: pftp->psta = sta227;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta227)
	inc	hl
	ld	(hl), #>(_sta227)
;ftpd.c:793: prep = sta227 + 17;
	ld	de, #_sta227 + 17
;ftpd.c:794: *(prep++) = '(';
	ld	a, #0x28
	ld	(de), a
	inc	de
;ftpd.c:795: prep = ftp_uint (prep, addr[0]);
	ld	a, (bc)
	ld	l, a
	ld	h, #0x00
	push	bc
	push	hl
	push	de
	call	_ftp_uint
	pop	af
	pop	af
	pop	bc
;ftpd.c:796: for (i = 1; i < 6; ++i)
	ld	de, #0x0001
00269$:
;ftpd.c:798: *(prep++) = ',';
	ld	(hl), #0x2c
	inc	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
;ftpd.c:799: prep = ftp_uint (prep, addr[i]);
	ld	l, c
	ld	h, b
	add	hl, de
	ld	l, (hl)
	ld	h, #0x00
	push	bc
	push	de
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftp_uint
	pop	af
	pop	af
	pop	de
	pop	bc
;ftpd.c:796: for (i = 1; i < 6; ++i)
	inc	de
	ld	a, e
	sub	a, #0x06
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00269$
;ftpd.c:808: *(prep++) = ')';
	ld	(hl), #0x29
	inc	hl
;ftpd.c:809: *(prep++) = '\r';
	ld	(hl), #0x0d
	inc	hl
;ftpd.c:810: *(prep++) = '\n';
	ld	(hl), #0x0a
	inc	hl
;ftpd.c:811: *(prep++) = '\0';
	ld	(hl), #0x00
	jp	00268$
00258$:
;ftpd.c:813: else if ( ! strncasecmp (pcmd, "retr", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_30
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
;ftpd.c:815: if ( ftp_fname (pcmd + 4, &pftp->fcb) )
	ld	a, -2 (ix)
	add	a, #0x7b
	ld	-6 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
;ftpd.c:817: pftp->fcb.cr = 0;
	ld	a, -2 (ix)
	add	a, #0x9b
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
;ftpd.c:820: pftp->md = mdSend;
	ld	a, -2 (ix)
	add	a, #0x77
	ld	c, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	b, a
;ftpd.c:813: else if ( ! strncasecmp (pcmd, "retr", 4) )
	ld	a, h
	or	a, l
	jr	NZ,00255$
;ftpd.c:815: if ( ftp_fname (pcmd + 4, &pftp->fcb) )
	push	bc
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00133$
;ftpd.c:817: pftp->fcb.cr = 0;
	xor	a, a
	ld	(de), a
;ftpd.c:818: if ( bdos_open_file (&pftp->fcb) < 4 )
	push	bc
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_bdos_open_file
	pop	af
	ld	a, l
	pop	bc
	sub	a, #0x04
	jr	NC,00130$
;ftpd.c:820: pftp->md = mdSend;
	ld	a, #0x10
	ld	(bc), a
;ftpd.c:821: ftpd_start (pftp);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftpd_start
	pop	af
	jp	00268$
00130$:
;ftpd.c:825: pftp->psta = sta550;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta550)
	inc	hl
	ld	(hl), #>(_sta550)
	jp	00268$
00133$:
;ftpd.c:828: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00255$:
;ftpd.c:830: else if ( ! strncasecmp (pcmd, "stor", 4) )
	push	bc
	push	de
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_31
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00252$
;ftpd.c:832: if (ftp_fname (pcmd + 4, &pftp->fcb) )
	push	bc
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00139$
;ftpd.c:834: pftp->fcb.cr = 0;
	xor	a, a
	ld	(de), a
;ftpd.c:835: bdos_delete_files (&pftp->fcb);
	push	bc
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_bdos_delete_files
	pop	af
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_bdos_create_file
	pop	af
	ld	a, l
	pop	bc
	sub	a, #0x04
	jr	NC,00136$
;ftpd.c:838: pftp->md = mdRecv;
	ld	a, #0x20
	ld	(bc), a
;ftpd.c:839: pftp->ndat = 0;
	ld	a, -2 (ix)
	add	a, #0x1f
	ld	c, a
	ld	a, -1 (ix)
	adc	a, #0x01
	ld	b, a
	xor	a, a
	ld	(bc), a
	inc	bc
	ld	(bc), a
;ftpd.c:840: ftpd_start (pftp);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftpd_start
	pop	af
	jp	00268$
00136$:
;ftpd.c:844: pftp->psta = sta550;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta550)
	inc	hl
	ld	(hl), #>(_sta550)
	jp	00268$
00139$:
;ftpd.c:847: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00252$:
;ftpd.c:849: else if ( ! strncasecmp (pcmd, "dele", 4) )
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_32
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00249$
;ftpd.c:851: if (ftp_fname (pcmd + 4, &pftp->fcb) )
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	Z,00145$
;ftpd.c:853: if ( bdos_delete_files (&pftp->fcb) < 4 ) pftp->psta = sta250;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_bdos_delete_files
	pop	af
	ld	a, l
	sub	a, #0x04
	jr	NC,00142$
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta250)
	inc	hl
	ld	(hl), #>(_sta250)
	jp	00268$
00142$:
;ftpd.c:854: else pftp->psta = sta550;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta550)
	inc	hl
	ld	(hl), #>(_sta550)
	jp	00268$
00145$:
;ftpd.c:856: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00249$:
;ftpd.c:858: else if ( ! strncasecmp (pcmd, "rnfr", 4) )
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_33
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00246$
;ftpd.c:860: if (ftp_fname (pcmd + 4, &pftp->fcb) ) pftp->psta = sta350;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	Z,00148$
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta350)
	inc	hl
	ld	(hl), #>(_sta350)
	jp	00268$
00148$:
;ftpd.c:861: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00246$:
;ftpd.c:863: else if ( ! strncasecmp (pcmd, "rnto", 4) )
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_34
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00243$
;ftpd.c:865: if ( ftp_fname (pcmd + 4, (FCB *) pftp->fcb.alb) )
	ld	a, -2 (ix)
	add	a, #0x8b
	ld	c, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	b, a
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	Z,00154$
;ftpd.c:867: if ( bdos_rename_file (&pftp->fcb) ) pftp->psta = sta250;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_bdos_rename_file
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00151$
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta250)
	inc	hl
	ld	(hl), #>(_sta250)
	jp	00268$
00151$:
;ftpd.c:868: else pftp->psta = sta550;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta550)
	inc	hl
	ld	(hl), #>(_sta550)
	jp	00268$
00154$:
;ftpd.c:870: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00243$:
;ftpd.c:872: else if (( ! strncasecmp (pcmd, "nlst", 4) ) || ( ! strncasecmp (pcmd, "list", 4) )
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_35
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00237$
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_36
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00237$
;ftpd.c:873: || ( ! strncasecmp (pcmd, "mlsd", 4) ))
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_37
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jp	NZ, 00238$
00237$:
;ftpd.c:876: if ( pcmd[4] == ' ' )
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00157$
;ftpd.c:878: bValid = ftp_fname (pcmd + 4, &pftp->fcb);
	push	bc
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_ftp_fname
	pop	af
	pop	af
	pop	bc
	jr	00158$
00157$:
;ftpd.c:882: pftp->fcb.drive = 0;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	(hl), #0x00
;ftpd.c:883: strcpy (pftp->fcb.filename, "????????");
	ld	a, -2 (ix)
	add	a, #0x7c
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
	push	bc
	ld	hl, #___str_38
	xor	a, a
00634$:
	cp	a, (hl)
	ldi
	jr	NZ, 00634$
	pop	bc
;ftpd.c:884: strcpy (pftp->fcb.type, "???");
	ld	a, -2 (ix)
	add	a, #0x84
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
	push	bc
	ld	hl, #___str_39
	xor	a, a
00635$:
	cp	a, (hl)
	ldi
	jr	NZ, 00635$
	pop	bc
;ftpd.c:885: bValid = TRUE;
	ld	hl, #0x0001
00158$:
;ftpd.c:887: if ( bValid )
	ld	a, h
	or	a, l
	jr	Z,00167$
;ftpd.c:889: ftp_dlist ();
	push	bc
	call	_ftp_dlist
	pop	bc
;ftpd.c:890: pftp->md = mdList;
	ld	a, #0x30
	ld	(bc), a
;ftpd.c:891: pftp->iFind = 0;
	ld	a, -2 (ix)
	add	a, #0x79
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
	xor	a, a
	ld	(de), a
	inc	de
	ld	(de), a
;ftpd.c:892: if (( *pcmd == 'L' ) || ( *pcmd == 'l' )) pftp->md |= mdLDir;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	ld	-3 (ix), a
	sub	a, #0x4c
	jr	Z,00162$
	ld	a, -3 (ix)
	sub	a, #0x6c
	jr	NZ,00163$
00162$:
	ld	a, (bc)
	set	2, a
	ld	(bc), a
	jr	00164$
00163$:
;ftpd.c:893: else if (( *pcmd == 'M' ) || ( *pcmd == 'm' )) pftp->md |= mdMLst;
	ld	a, -3 (ix)
	sub	a, #0x4d
	jr	Z,00159$
	ld	a, -3 (ix)
	sub	a, #0x6d
	jr	NZ,00164$
00159$:
	ld	a, (bc)
	set	3, a
	ld	(bc), a
00164$:
;ftpd.c:894: ftpd_start (pftp);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_ftpd_start
	pop	af
	jp	00268$
00167$:
;ftpd.c:896: else pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jp	00268$
00238$:
;ftpd.c:898: else if ( ! strncasecmp (pcmd, "type", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_40
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	NZ,00235$
;ftpd.c:900: const char *ps = pcmd + 4;
	ld	e, -4 (ix)
	ld	d, -3 (ix)
;ftpd.c:901: pftp->psta = sta200;
	ld	c, -18 (ix)
	ld	b, -17 (ix)
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta200)
	inc	hl
	ld	(hl), #>(_sta200)
;ftpd.c:902: while (*ps == ' ') ++ps;
00169$:
	ld	a, (de)
	ld	-1 (ix), a
	inc	de
	ld	a, -1 (ix)
	sub	a, #0x20
	jr	Z,00169$
	jr	00171$
	jr	00169$
00171$:
;ftpd.c:903: if ( strchr ("AaIi", *ps) == NULL )
	ld	h, -1 (ix)
	push	de
	ld	d, h
	ld	hl, #___str_41
00645$:
	ld	a, (hl)
	cp	a, d
	jr	Z,00644$
	or	a, a
	inc	hl
	jr	NZ, 00645$
	ld	l, a
	ld	h, a
00644$:
	pop	de
	ld	a, h
	or	a, l
	jr	NZ,00178$
;ftpd.c:905: pftp->psta = sta504;
	ld	a, #<(_sta504)
	ld	(bc), a
	inc	bc
	ld	a, #>(_sta504)
	ld	(bc), a
	jp	00268$
00178$:
;ftpd.c:909: ++ps;
	ex	de,hl
;ftpd.c:910: while (*ps == ' ') ++ps;
00172$:
	ld	e, (hl)
	ld	a, e
	sub	a, #0x20
	jr	NZ,00174$
	inc	hl
	jr	00172$
00174$:
;ftpd.c:911: if ( strchr ("NnTt\r", *ps) == NULL ) pftp->psta = sta504;
	ld	hl, #___str_42
	ld	d, #0x00
00649$:
	ld	a, (hl)
	cp	a, e
	jr	Z,00648$
	or	a, a
	inc	hl
	jr	NZ, 00649$
	ld	l, a
	ld	h, a
00648$:
	ex	de, hl
	ld	a, d
	or	a, e
	jp	NZ, 00268$
	ld	a, #<(_sta504)
	ld	(bc), a
	inc	bc
	ld	a, #>(_sta504)
	ld	(bc), a
	jp	00268$
00235$:
;ftpd.c:914: else if ( ! strncasecmp (pcmd, "mode", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_43
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	NZ,00232$
;ftpd.c:916: const char *ps = pcmd + 4;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
;ftpd.c:917: while (*ps == ' ') ++ps;
00180$:
	ld	e, (hl)
	ld	a, e
	sub	a, #0x20
	jr	NZ,00182$
	inc	hl
	jr	00180$
00182$:
;ftpd.c:918: if ( strchr ("Ss", *ps) != NULL ) pftp->psta = sta200;
	ld	bc, #___str_44
00653$:
	ld	a, (bc)
	cp	a, e
	jr	Z,00652$
	or	a, a
	inc	bc
	jr	NZ, 00653$
	ld	c, a
	ld	b, a
00652$:
	ld	a, b
	or	a, c
	jr	Z,00184$
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta200)
	inc	hl
	ld	(hl), #>(_sta200)
	jp	00268$
00184$:
;ftpd.c:919: else pftp->psta = sta504;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta504)
	inc	hl
	ld	(hl), #>(_sta504)
	jp	00268$
00232$:
;ftpd.c:921: else if ( ! strncasecmp (pcmd, "stru", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_45
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	NZ,00229$
;ftpd.c:923: const char *ps = pcmd + 4;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
;ftpd.c:924: while (*ps == ' ') ++ps;
00186$:
	ld	e, (hl)
	ld	a, e
	sub	a, #0x20
	jr	NZ,00188$
	inc	hl
	jr	00186$
00188$:
;ftpd.c:925: if ( strchr ("Ff", *ps) != NULL ) pftp->psta = sta200;
	ld	bc, #___str_46
00657$:
	ld	a, (bc)
	cp	a, e
	jr	Z,00656$
	or	a, a
	inc	bc
	jr	NZ, 00657$
	ld	c, a
	ld	b, a
00656$:
	ld	a, b
	or	a, c
	jr	Z,00190$
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta200)
	inc	hl
	ld	(hl), #>(_sta200)
	jp	00268$
00190$:
;ftpd.c:926: else pftp->psta = sta504;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta504)
	inc	hl
	ld	(hl), #>(_sta504)
	jp	00268$
00229$:
;ftpd.c:928: else if (( ! strncasecmp (pcmd, "pwd", 3) ) || ( ! strncasecmp (pcmd, "xpwd", 4) ))
	ld	hl, #0x0003
	push	hl
	ld	hl, #___str_47
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	Z,00224$
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_48
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	NZ,00225$
00224$:
;ftpd.c:930: sta257[5] = 'A' + bdos_current_drive ();
	call	_bdos_current_drive
	ld	a, l
	add	a, #0x41
	ld	(#(_sta257 + 0x0005)),a
;ftpd.c:931: pftp->psta = sta257;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta257)
	inc	hl
	ld	(hl), #>(_sta257)
	jp	00268$
00225$:
;ftpd.c:933: else if ( ! strncasecmp (pcmd, "cwd", 3) )
	ld	hl, #0x0003
	push	hl
	ld	hl, #___str_49
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jp	NZ, 00222$
;ftpd.c:935: const char *ps = pcmd + 4;
	ld	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	-1 (ix), a
;ftpd.c:936: while (*ps == ' ') ++ps;
00192$:
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
	ld	-3 (ix), a
	ld	a, -2 (ix)
	add	a, #0x01
	ld	-8 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-7 (ix), a
	ld	a, -3 (ix)
	sub	a, #0x20
	jr	NZ,00348$
	ld	a, -8 (ix)
	ld	-2 (ix), a
	ld	a, -7 (ix)
	ld	-1 (ix), a
	jr	00192$
00348$:
	ld	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, -1 (ix)
	ld	-5 (ix), a
;ftpd.c:937: pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
;ftpd.c:938: if ( ( ps[1] == ':' )
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	ld	-4 (ix), a
;ftpd.c:942: char ch = *ps;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, (hl)
	ld	-3 (ix), a
;ftpd.c:938: if ( ( ps[1] == ':' )
	ld	a, -4 (ix)
	sub	a, #0x3a
	jp	NZ,00207$
;ftpd.c:939: && ( ( ps[2] == '/' ) || ( ps[2] == '\\' ) )
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	sub	a, #0x2f
	jr	Z,00211$
	ld	a, -1 (ix)
	sub	a, #0x5c
	jp	NZ,00207$
00211$:
;ftpd.c:940: && ( ps[3] == '\r' ) )
	ld	a, -6 (ix)
	ld	-2 (ix), a
	ld	a, -5 (ix)
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	sub	a, #0x0d
	jp	NZ,00207$
;ftpd.c:942: char ch = *ps;
	ld	a, -3 (ix)
;ftpd.c:943: if ( ( ch >= 'a' ) && ( ch <= 'z' ) ) ch -= 0x20;
	ld	-1 (ix), a
	sub	a, #0x61
	jr	C,00196$
	ld	a, #0x7a
	sub	a, -1 (ix)
	jr	C,00196$
	ld	a, -1 (ix)
	add	a, #0xe0
	ld	-1 (ix), a
00196$:
;ftpd.c:944: ch -= 'A';
	ld	a, -1 (ix)
	add	a, #0xbf
;ftpd.c:945: if ( ch < 16 )
	ld	-7 (ix), a
	sub	a, #0x10
	jp	NC, 00268$
;ftpd.c:947: word drvs = bdos_logged_drives ();
	call	_bdos_logged_drives
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, -2 (ix)
	ld	-4 (ix), a
	ld	a, -1 (ix)
	ld	-3 (ix), a
;ftpd.c:948: if ( drvs & ( 1 << ch ) )
	ld	b, -7 (ix)
	ld	-2 (ix), #0x01
	xor	a, a
	ld	-1 (ix), a
	inc	b
	jr	00668$
00667$:
	sla	-2 (ix)
	rl	-1 (ix)
00668$:
	djnz	00667$
	ld	a, -4 (ix)
	ld	-6 (ix), a
	ld	a, -3 (ix)
	ld	-5 (ix), a
	ld	a, -2 (ix)
	ld	-4 (ix), a
	ld	a, -1 (ix)
	ld	-3 (ix), a
	ld	a, -6 (ix)
	and	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -5 (ix)
	and	a, -3 (ix)
	ld	-1 (ix), a
	or	a, -2 (ix)
	jp	Z, 00268$
;ftpd.c:950: bdos_select_drive (ch);
	ld	a, -7 (ix)
	push	af
	inc	sp
	call	_bdos_select_drive
	inc	sp
;ftpd.c:951: pftp->psta = sta250;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta250)
	inc	hl
	ld	(hl), #>(_sta250)
	jp	00268$
00207$:
;ftpd.c:955: else if ( ( ( ps[0] == '/' ) || ( ps[0] == '\\' ) )
	ld	a, -3 (ix)
	sub	a, #0x2f
	jr	Z,00205$
	ld	a, -3 (ix)
	sub	a, #0x5c
	jp	NZ,00268$
00205$:
;ftpd.c:956: && ( ps[1] == '\r' ) )
	ld	a, -4 (ix)
	sub	a, #0x0d
	jp	NZ,00268$
;ftpd.c:958: pftp->psta = sta250;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta250)
	inc	hl
	ld	(hl), #>(_sta250)
	jp	00268$
00222$:
;ftpd.c:961: else if ( ! strncasecmp (pcmd, "feat", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_50
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, h
	or	a, -2 (ix)
	jr	NZ,00219$
;ftpd.c:963: pftp->psta = sta211;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta211)
	inc	hl
	ld	(hl), #>(_sta211)
	jr	00268$
00219$:
;ftpd.c:965: else if ( ! strncasecmp (pcmd, "opts", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_51
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, h
	or	a, -2 (ix)
	jr	NZ,00216$
;ftpd.c:967: pftp->psta = sta501;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta501)
	inc	hl
	ld	(hl), #>(_sta501)
	jr	00268$
00216$:
;ftpd.c:969: else if ( ! strncasecmp (pcmd, "syst", 4) )
	ld	hl, #0x0004
	push	hl
	ld	hl, #___str_52
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_strncasecmp
	pop	af
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, h
	or	a, -2 (ix)
	jr	NZ,00213$
;ftpd.c:971: pftp->psta = sta215;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta215)
	inc	hl
	ld	(hl), #>(_sta215)
	jr	00268$
00213$:
;ftpd.c:975: pftp->psta = sta500;
	ld	l, -18 (ix)
	ld	h, -17 (ix)
	ld	(hl), #<(_sta500)
	inc	hl
	ld	(hl), #>(_sta500)
00268$:
;ftpd.c:977: ftpc_reply (pftp);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_ftpc_reply
	pop	af
00271$:
;ftpd.c:978: }
	ld	sp, ix
	pop	ix
	ret
___str_25:
	.ascii "ftpc_cmnd: $"
	.db 0x00
___str_26:
	.ascii "user"
	.db 0x00
___str_27:
	.ascii "quit"
	.db 0x00
___str_28:
	.ascii "port"
	.db 0x00
___str_29:
	.ascii "pasv"
	.db 0x00
___str_30:
	.ascii "retr"
	.db 0x00
___str_31:
	.ascii "stor"
	.db 0x00
___str_32:
	.ascii "dele"
	.db 0x00
___str_33:
	.ascii "rnfr"
	.db 0x00
___str_34:
	.ascii "rnto"
	.db 0x00
___str_35:
	.ascii "nlst"
	.db 0x00
___str_36:
	.ascii "list"
	.db 0x00
___str_37:
	.ascii "mlsd"
	.db 0x00
___str_38:
	.ascii "????????"
	.db 0x00
___str_39:
	.ascii "???"
	.db 0x00
___str_40:
	.ascii "type"
	.db 0x00
___str_41:
	.ascii "AaIi"
	.db 0x00
___str_42:
	.ascii "NnTt"
	.db 0x0d
	.db 0x00
___str_43:
	.ascii "mode"
	.db 0x00
___str_44:
	.ascii "Ss"
	.db 0x00
___str_45:
	.ascii "stru"
	.db 0x00
___str_46:
	.ascii "Ff"
	.db 0x00
___str_47:
	.ascii "pwd"
	.db 0x00
___str_48:
	.ascii "xpwd"
	.db 0x00
___str_49:
	.ascii "cwd"
	.db 0x00
___str_50:
	.ascii "feat"
	.db 0x00
___str_51:
	.ascii "opts"
	.db 0x00
___str_52:
	.ascii "syst"
	.db 0x00
;ftpd.c:980: static void ftpc_read(FTP *pftp)
;	---------------------------------
; Function ftpc_read
; ---------------------------------
_ftpc_read:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;ftpd.c:983: pftp->buf[pftp->wptr] = '\0';
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0019
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x006d
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	ld	(hl), #0x00
;ftpd.c:984: pend = strstr (&pftp->buf[pftp->rptr], "\r\n");
	ld	hl, #0x006b
	add	hl, bc
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	push	bc
	ld	de, #___str_53
	push	de
	push	hl
	call	_strstr
	pop	af
	pop	af
	ex	de,hl
	pop	bc
	ld	l, e
;ftpd.c:995: if ( pend != NULL )
	ld	a,d
	ld	h,a
	or	a, e
	jr	Z,00104$
;ftpd.c:997: ftpc_cmnd(pftp);
	push	hl
	push	bc
	call	_ftpc_cmnd
	pop	af
	pop	hl
;ftpd.c:998: pftp->rptr = pend + 2 - pftp->buf;
	inc	hl
	inc	hl
	ld	a, l
	sub	a, -2 (ix)
	ld	c, a
	ld	a, h
	sbc	a, -1 (ix)
	ld	b, a
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), c
	inc	hl
	ld	(hl), b
	jr	00106$
00104$:
;ftpd.c:1002: if ( pftp->wptr > pftp->rptr ) memcpy (pftp->buf, &pftp->buf[pftp->rptr], pftp->wptr - pftp->rptr);
	pop	hl
	push	hl
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	sub	a, -4 (ix)
	ld	a, d
	sbc	a, -3 (ix)
	jp	PO, 00118$
	xor	a, #0x80
00118$:
	jp	P, 00102$
	ld	hl, #0x0019
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	add	hl, de
	ld	a, -4 (ix)
	sub	a, e
	ld	e, a
	ld	a, -3 (ix)
	sbc	a, d
	ld	d, a
	push	bc
	push	de
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	___memcpy
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
00102$:
;ftpd.c:1003: pftp->wptr -= pftp->rptr;
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	a, e
	sub	a, l
	ld	e, a
	ld	a, d
	sbc	a, h
	ld	d, a
	pop	hl
	push	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
;ftpd.c:1004: pftp->rptr = 0;
	pop	de
	pop	hl
	push	hl
	push	de
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;ftpd.c:1005: ftpc_recv (pftp);
	push	bc
	call	_ftpc_recv
	pop	af
00106$:
;ftpd.c:1007: }
	ld	sp, ix
	pop	ix
	ret
___str_53:
	.db 0x0d
	.db 0x0a
	.db 0x00
;ftpd.c:1009: static void ftpc_recvd(FTP *pftp)
;	---------------------------------
; Function ftpc_recvd
; ---------------------------------
_ftpc_recvd:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;ftpd.c:1011: SOCKET *socket = pftp->sacmd.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;ftpd.c:1017: if ( socket->state == SS_ESTABLISHED )
	pop	hl
	push	hl
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	sub	a, #0x04
	jr	NZ,00102$
;ftpd.c:1019: pftp->wptr += socket->actual;
	ld	hl, #0x006d
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	push	bc
	ld	bc, #0x001e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, de
	ex	de, hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
;ftpd.c:1020: pftp->buf[pftp->wptr] = '\0';
	ld	hl, #0x0019
	add	hl, bc
	add	hl, de
	ld	(hl), #0x00
;ftpd.c:1021: ftpc_read (pftp);
	push	bc
	call	_ftpc_read
	pop	af
	jr	00104$
00102$:
;ftpd.c:1025: ftpc_close (pftp);
	push	bc
	call	_ftpc_close
	pop	af
00104$:
;ftpd.c:1027: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:1029: static void ftpc_recv(FTP *pftp)
;	---------------------------------
; Function ftpc_recv
; ---------------------------------
_ftpc_recv:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;ftpd.c:1036: net_recv(pftp->sacmd.socket, pftp->buf + pftp->wptr, FTPC_BLEN - pftp->wptr, (NF)ftpc_recvd, pftp);
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	-4 (ix), #<(_ftpc_recvd)
	ld	-3 (ix), #>(_ftpc_recvd)
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x006d
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, #0x50
	sub	a, e
	ld	-2 (ix), a
	ld	a, #0x00
	sbc	a, d
	ld	-1 (ix), a
	ld	hl, #0x0019
	add	hl, bc
	add	hl, de
	ex	de, hl
	ld	l, c
	ld	h, b
	ld	bc, #0x000e
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	hl
	push	hl
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;ftpd.c:1037: }
	ld	sp, ix
	pop	ix
	ret
;ftpd.c:1039: static void ftpc_open(FTP *pftp)
;	---------------------------------
; Function ftpc_open
; ---------------------------------
_ftpc_open:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;ftpd.c:1041: word sra = pftp->sacmd.socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;ftpd.c:1045: log_printf ("ftpc_open:\r\n$");
	push	bc
	push	de
	ld	hl, #___str_54
	push	hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;ftpd.c:1046: wiz_read_n (sra + W5100_OFFSET_SOCKET_DIPR0, pftp->daddr, 4);
	ld	hl, #0x006f
	add	hl, bc
	ex	(sp), hl
	ld	hl, #0x000c
	add	hl, de
	push	bc
	ld	de, #0x0004
	push	de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	de
	push	hl
	call	_wiz_read_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;ftpd.c:1047: pftp->daddr[4] = 0;
	ld	hl, #0x0073
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1048: pftp->daddr[5] = PORT_FTPD;
	ld	hl, #0x0074
	add	hl, bc
	ld	(hl), #0x14
;ftpd.c:1049: pftp->psta = sta220;
	ld	hl, #0x0069
	add	hl, bc
	ex	de, hl
	ld	a, #<(_sta220)
	ld	(de), a
	inc	de
	ld	a, #>(_sta220)
	ld	(de), a
;ftpd.c:1050: ftpc_reply(pftp);
	push	bc
	call	_ftpc_reply
;ftpd.c:1051: }
	ld	sp,ix
	pop	ix
	ret
___str_54:
	.ascii "ftpc_open:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:1053: static void ftpc_listen(FTP *pftp)
;	---------------------------------
; Function ftpc_listen
; ---------------------------------
_ftpc_listen:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:1059: net_listen(pftp->sacmd.socket, PORT_FTPC, (NF)ftpc_open, pftp);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	bc, #_ftpc_open
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	push	bc
	ld	bc, #0x0015
	push	bc
	push	hl
	call	_net_listen
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;ftpd.c:1060: }
	pop	ix
	ret
;ftpd.c:1062: static void ftpd_alloc (FTP *pftp)
;	---------------------------------
; Function ftpd_alloc
; ---------------------------------
_ftpd_alloc:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:1067: net_alloc(&pftp->sadat, (NF) ftpc_listen, pftp);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_ftpc_listen
	ld	a, 4 (ix)
	ld	b, 5 (ix)
	add	a, #0x10
	ld	c, a
	jr	NC,00103$
	inc	b
00103$:
	push	hl
	push	de
	push	bc
	call	_net_alloc
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;ftpd.c:1068: }
	pop	ix
	ret
;ftpd.c:1070: static void ftp_start(FTP *pftp)
;	---------------------------------
; Function ftp_start
; ---------------------------------
_ftp_start:
	push	ix
	ld	ix,#0
	add	ix,sp
;ftpd.c:1072: log_printf("ftpc_start:\r\n$");
	ld	hl, #___str_55
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:1073: pftp->rptr = 0;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x006b
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;ftpd.c:1074: pftp->wptr = 0;
	ld	hl, #0x006d
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;ftpd.c:1075: pftp->pasv = 0;
	ld	hl, #0x0075
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;ftpd.c:1076: pftp->dcon = 0;
	ld	hl, #0x0078
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1077: pftp->md = mdIdle;
	ld	hl, #0x0077
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1078: pftp->sacmd.fiber.queued = 0;
	ld	hl, #0x000d
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1079: pftp->sadat.fiber.queued = 0;
	ld	hl, #0x0016
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1080: pftp->fbr.queued = 0;
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x00
;ftpd.c:1081: net_alloc(&pftp->sacmd, (NF) ftpd_alloc, pftp);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_ftpd_alloc
	ld	a, c
	add	a, #0x07
	ld	c, a
	jr	NC,00103$
	inc	b
00103$:
	push	hl
	push	de
	push	bc
	call	_net_alloc
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;ftpd.c:1082: }
	pop	ix
	ret
___str_55:
	.ascii "ftpc_start:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:1084: static void first(void *nfp)
;	---------------------------------
; Function first
; ---------------------------------
_first:
;ftpd.c:1087: ftp_start (&ftp1);
	ld	hl, #_ftp1
	push	hl
	call	_ftp_start
;ftpd.c:1088: ftp_start (&ftp2);
	ld	hl, #_ftp2
	ex	(sp),hl
	call	_ftp_start
	pop	af
;ftpd.c:1089: }
	ret
;ftpd.c:1093: void quit(void)
;	---------------------------------
; Function quit
; ---------------------------------
_quit::
;ftpd.c:1095: log_printf ("Exiting due to keyboard request\r\n$");
	ld	hl, #___str_56
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:1096: log_close();
	call	_log_close
;ftpd.c:1097: bdos_exit();
;ftpd.c:1098: }
	jp	_bdos_exit
___str_56:
	.ascii "Exiting due to keyboard request"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:1100: void parse(void)
;	---------------------------------
; Function parse
; ---------------------------------
_parse::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;ftpd.c:1103: const char *cend = ctail + ctail[0] + 1;
	ld	hl,#0x0080
	ld	c,(hl)
	ld	b, #0x00
	add	hl, bc
	inc	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
;ftpd.c:1104: const char *ps = ctail + 1;
	ld	-2 (ix), #0x81
	xor	a, a
	ld	-1 (ix), a
;ftpd.c:1105: while ( ps < cend )
00111$:
	ld	a, -2 (ix)
	sub	a, -4 (ix)
	ld	a, -1 (ix)
	sbc	a, -3 (ix)
	jp	NC, 00114$
;ftpd.c:1107: if ( *ps == ' ' )
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
;ftpd.c:1109: ++ps;
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	inc	bc
;ftpd.c:1107: if ( *ps == ' ' )
	cp	a, #0x20
	jr	NZ,00109$
;ftpd.c:1109: ++ps;
	ld	-2 (ix), c
	ld	-1 (ix), b
	jr	00111$
00109$:
;ftpd.c:1111: else if ( *ps == '-' )
	sub	a, #0x2d
	jr	NZ,00106$
;ftpd.c:1113: ++ps;
;ftpd.c:1114: switch (*ps)
	ld	-2 (ix), c
	ld	-1 (ix), b
	ld	l, c
	ld	h, b
	ld	a, (hl)
	ld	-5 (ix), a
	sub	a, #0x4c
	jr	Z,00102$
	ld	a, -5 (ix)
	sub	a, #0x6c
	jr	NZ,00103$
;ftpd.c:1117: case 'l':
00102$:
;ftpd.c:1118: ++ps;
	ld	a, -2 (ix)
	add	a, #0x01
	ld	-6 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
;ftpd.c:1119: ps = log_open (ps, cend);
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	c, l
	ld	b, h
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_log_open
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
;ftpd.c:1120: break;
	jr	00111$
;ftpd.c:1121: default:
00103$:
;ftpd.c:1122: log_fatal ("Invalid parameter\r\n$");
	ld	hl, #___str_57
	push	hl
	call	_log_fatal
	pop	af
;ftpd.c:1123: }
	jr	00111$
00106$:
;ftpd.c:1127: ps = log_open (ps, cend);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_log_open
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	jp	00111$
00114$:
;ftpd.c:1130: }
	ld	sp, ix
	pop	ix
	ret
___str_57:
	.ascii "Invalid parameter"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;ftpd.c:1132: int main(void)
;	---------------------------------
; Function main
; ---------------------------------
_main::
;ftpd.c:1135: parse();
	call	_parse
;ftpd.c:1136: log_printf("File Transfer Protocol Daemon " VERSION "\r\n$");
	ld	hl, #___str_58
	push	hl
	call	_log_printf
	pop	af
;ftpd.c:1137: fiber_init();
	call	_fiber_init
;ftpd.c:1139: net_init();
	call	_net_init
;ftpd.c:1140: fiber_enqueue(&first_fiber);
	ld	hl, #_first_fiber
	push	hl
	call	_fiber_enqueue
	pop	af
00105$:
;ftpd.c:1143: ++nLoop;
	ld	hl, (_nLoop)
	inc	hl
	ld	(_nLoop), hl
;ftpd.c:1151: if ( bdos_inkey() == 'q' ) quit();
	call	_bdos_inkey
	ld	a, l
	sub	a, #0x71
	jr	NZ,00102$
	call	_quit
00102$:
;ftpd.c:1152: net_handle_interrupts();
	call	_net_handle_interrupts
;ftpd.c:1153: fiber_drain();
	call	_fiber_drain
;ftpd.c:1155: }
	jr	00105$
___str_58:
	.ascii "File Transfer Protocol Daemon v230307"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _CODE
___str_93:
	.ascii " SS_FREE"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_94:
	.ascii " SS_ALLOCATED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_95:
	.ascii " SS_CONNECT"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_96:
	.ascii " SS_LISTEN"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_97:
	.ascii " SS_ESTABLISHED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_98:
	.ascii " SS_SEND"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_99:
	.ascii " SS_RECV"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_100:
	.ascii " SS_ERROR"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_101:
	.ascii " SS_DISCONNECT"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _INITIALIZER
__xinit__nlist:
	.dw #0x0000
__xinit__nLoop:
	.dw #0x0000
__xinit__sta150:
	.ascii "150 Starting transfer"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta200:
	.ascii "200 OK"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta211:
	.ascii "211- Features"
	.db 0x0d
	.db 0x0a
	.ascii " MLST type*;size*;"
	.db 0x0d
	.db 0x0a
	.ascii "211 End"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta215:
	.ascii "215 CPM 2.2 Memotech MTX"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta220:
	.ascii "220 Ready"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta221:
	.ascii "221 Logoff"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta226:
	.ascii "226 Success / Closing"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta227:
	.ascii "227 Passive mode .???,???,???,???,???,???."
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta230:
	.ascii "230 Logon"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta250:
	.ascii "250 File OK"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta257:
	.ascii "257 "
	.db 0x22
	.ascii "?:/"
	.db 0x22
	.ascii " Current drive"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta350:
	.ascii "350 More info"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta500:
	.ascii "500 Unrecognised command"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta501:
	.ascii "501 Invalid parameters"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta504:
	.ascii "504 Option not implemented"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta550:
	.ascii "550 File not found"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__sta552:
	.ascii "552 No space"
	.db 0x0d
	.db 0x0a
	.db 0x00
__xinit__psStatus:
	.dw ___str_93
	.dw ___str_94
	.dw ___str_95
	.dw ___str_96
	.dw ___str_97
	.dw ___str_98
	.dw ___str_99
	.dw ___str_100
	.dw ___str_101
__xinit__first_fiber:
	.dw #0x0000
	.dw _first
	.dw #0x0000
	.db #0x00	; 0
	.area _CABS (ABS)
