;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module log
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _bdos_delete_files
	.globl _bdos_close_file
	.globl _bdos_write_file
	.globl _bdos_create_file
	.globl _bdos_set_dma_address
	.globl _bdos_printf
	.globl _bdos_exit
	.globl _log_nshow
	.globl _log_fatal
	.globl _log_open
	.globl _log_printf
	.globl _log_line
	.globl _log_str
	.globl _log_strn
	.globl _log_bin
	.globl _log_byte
	.globl _log_word
	.globl _log_uint
	.globl _log_int
	.globl _log_close
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_log_fcb:
	.ds 36
_log_buf:
	.ds 129
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_log_pos:
	.ds 2
_log_ptr:
	.ds 2
_log_fil:
	.ds 1
_log_nshow::
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;log.c:15: void log_fatal(const char *err)
;	---------------------------------
; Function log_fatal
; ---------------------------------
_log_fatal::
;log.c:17: bdos_printf(err);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_bdos_printf
	pop	af
;log.c:18: bdos_exit();
;log.c:19: }
	jp	_bdos_exit
;log.c:21: const char * log_open(const char *ps, const char *cend)
;	---------------------------------
; Function log_open
; ---------------------------------
_log_open::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;log.c:23: char *pd = log_fcb.filename;
	ld	bc, #_log_fcb + 1
	inc	sp
	inc	sp
	push	bc
;log.c:24: byte n = 8;
	ld	-3 (ix), #0x08
;log.c:25: log_fcb.drive = 0;
	ld	hl, #_log_fcb
	ld	(hl), #0x00
;log.c:26: log_fcb.filename[0] = ' ';
	ld	a, #0x20
	ld	(bc), a
;log.c:27: log_fcb.filename[1] = ' ';
	ld	hl, #(_log_fcb + 0x0002)
	ld	(hl), #0x20
;log.c:28: log_fcb.filename[2] = ' ';
	ld	hl, #(_log_fcb + 0x0003)
	ld	(hl), #0x20
;log.c:29: log_fcb.filename[3] = ' ';
	ld	hl, #(_log_fcb + 0x0004)
	ld	(hl), #0x20
;log.c:30: log_fcb.filename[4] = ' ';
	ld	hl, #(_log_fcb + 0x0005)
	ld	(hl), #0x20
;log.c:31: log_fcb.filename[5] = ' ';
	ld	hl, #(_log_fcb + 0x0006)
	ld	(hl), #0x20
;log.c:32: log_fcb.filename[6] = ' ';
	ld	hl, #(_log_fcb + 0x0007)
	ld	(hl), #0x20
;log.c:33: log_fcb.filename[7] = ' ';
	ld	hl, #(_log_fcb + 0x0008)
	ld	(hl), #0x20
;log.c:34: log_fcb.type[0] = ' ';
	ld	hl, #(_log_fcb + 0x0009)
	ld	(hl), #0x20
;log.c:35: log_fcb.type[1] = ' ';
	ld	hl, #(_log_fcb + 0x000a)
	ld	(hl), #0x20
;log.c:36: log_fcb.type[2] = ' ';
	ld	hl, #(_log_fcb + 0x000b)
	ld	(hl), #0x20
;log.c:37: log_fcb.ex = 0;
	ld	hl, #(_log_fcb + 0x000c)
	ld	(hl), #0x00
;log.c:38: log_fcb.s1 = 0;
	ld	hl, #(_log_fcb + 0x000d)
	ld	(hl), #0x00
;log.c:39: log_fcb.s2 = 0;
	ld	hl, #(_log_fcb + 0x000e)
	ld	(hl), #0x00
;log.c:40: log_fcb.cr = 0;
	ld	hl, #(_log_fcb + 0x0020)
	ld	(hl), #0x00
;log.c:41: while ((ps < cend) && (*ps == ' ')) ++ps;
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
00102$:
	ld	a, -2 (ix)
	sub	a, 6 (ix)
	ld	a, -1 (ix)
	sbc	a, 7 (ix)
	jr	NC,00131$
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00131$
	inc	-2 (ix)
	jr	NZ,00102$
	inc	-1 (ix)
	jr	00102$
;log.c:42: while ((ps < cend) && (n > 0))
00131$:
00115$:
	ld	a, -2 (ix)
	sub	a, 6 (ix)
	ld	a, -1 (ix)
	sbc	a, 7 (ix)
	jr	NC,00117$
	ld	a, -3 (ix)
	or	a, a
	jr	Z,00117$
;log.c:44: char c = *(ps++);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	c, (hl)
	inc	-2 (ix)
	jr	NZ,00195$
	inc	-1 (ix)
00195$:
;log.c:45: if ( c == '.' )
	ld	a, c
	sub	a, #0x2e
	jr	NZ,00112$
;log.c:47: pd = log_fcb.type;
	ld	-5 (ix), #<((_log_fcb + 0x0009))
	ld	-4 (ix), #>((_log_fcb + 0x0009))
;log.c:48: n = 3;
	ld	-3 (ix), #0x03
	jr	00115$
00112$:
;log.c:50: else if ( c <= ' ' )
	ld	a, #0x20
	sub	a, c
	jr	NC,00117$
;log.c:56: if ((c >= 'a') && (c <= 'z')) c -= 0x20;
	ld	a, c
	sub	a, #0x61
	jr	C,00106$
	ld	a, #0x7a
	sub	a, c
	jr	C,00106$
	ld	a, c
	add	a, #0xe0
	ld	c, a
00106$:
;log.c:57: *(pd++) = c;
	pop	hl
	push	hl
	ld	(hl), c
	inc	-5 (ix)
	jr	NZ,00198$
	inc	-4 (ix)
00198$:
;log.c:58: --n;
	dec	-3 (ix)
	jr	00115$
00117$:
;log.c:61: if ((ps != cend) && (*ps > ' ')) log_fatal("Invalid log file name\r\n$");
	ld	a, -2 (ix)
	sub	a, 6 (ix)
	jr	NZ,00199$
	ld	a, -1 (ix)
	sub	a, 7 (ix)
	jr	Z,00119$
00199$:
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	c, (hl)
	ld	a, #0x20
	sub	a, c
	jr	NC,00119$
	ld	hl, #___str_0
	push	hl
	call	_log_fatal
	pop	af
00119$:
;log.c:62: bdos_delete_files(&log_fcb);
	ld	hl, #_log_fcb
	push	hl
	call	_bdos_delete_files
	pop	af
;log.c:63: log_fcb.ex = 0;
	ld	hl, #(_log_fcb + 0x000c)
	ld	(hl), #0x00
;log.c:64: log_fcb.s1 = 0;
	ld	hl, #(_log_fcb + 0x000d)
	ld	(hl), #0x00
;log.c:65: log_fcb.s2 = 0;
	ld	hl, #(_log_fcb + 0x000e)
	ld	(hl), #0x00
;log.c:66: log_fcb.cr = 0;
	ld	hl, #(_log_fcb + 0x0020)
	ld	(hl), #0x00
;log.c:67: if ( bdos_create_file(&log_fcb) == 255 ) log_fatal("Unable to create log file\r\n$");
	ld	hl, #_log_fcb
	push	hl
	call	_bdos_create_file
	pop	af
	inc	l
	jr	NZ,00122$
	ld	hl, #___str_1
	push	hl
	call	_log_fatal
	pop	af
00122$:
;log.c:68: log_fil = 1;
	ld	hl,#_log_fil + 0
	ld	(hl), #0x01
;log.c:69: log_pos = 0;
	ld	hl, #0x0000
	ld	(_log_pos), hl
;log.c:70: log_ptr = log_buf;
	ld	hl, #_log_buf+0
	ld	(_log_ptr), hl
;log.c:71: return ps;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
;log.c:72: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "Invalid log file name"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_1:
	.ascii "Unable to create log file"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;log.c:74: static void log_show(void)
;	---------------------------------
; Function log_show
; ---------------------------------
_log_show:
;log.c:76: if (log_pos > 0)
	ld	iy, #_log_pos
	ld	a, 1 (iy)
	or	a, 0 (iy)
	ret	Z
;log.c:79: ++log_nshow;
	ld	hl, (_log_nshow)
	inc	hl
	ld	(_log_nshow), hl
;log.c:80: log_buf[log_pos] = '$';
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(hl), #0x24
;log.c:81: bdos_printf(log_ptr);
	ld	hl, (_log_ptr)
	push	hl
	call	_bdos_printf
	pop	af
;log.c:90: }
	ret
;log.c:92: static void log_flush(void)
;	---------------------------------
; Function log_flush
; ---------------------------------
_log_flush:
;log.c:94: log_show();
	call	_log_show
;log.c:95: if ( log_fil )
	ld	a,(#_log_fil + 0)
	or	a, a
	jr	Z,00104$
;log.c:97: bdos_set_dma_address(log_buf);
	ld	hl, #_log_buf
	push	hl
	call	_bdos_set_dma_address
;log.c:98: if ( bdos_write_file(&log_fcb) != 0 ) log_fatal("Error writing log file\r\n$");
	ld	hl, #_log_fcb
	ex	(sp),hl
	call	_bdos_write_file
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00104$
	ld	hl, #___str_2
	push	hl
	call	_log_fatal
	pop	af
00104$:
;log.c:100: log_pos = 0;
	ld	hl, #0x0000
	ld	(_log_pos), hl
;log.c:101: log_ptr = log_buf;
	ld	hl, #_log_buf+0
	ld	(_log_ptr), hl
;log.c:102: }
	ret
___str_2:
	.ascii "Error writing log file"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;log.c:104: static void log_chr(char c)
;	---------------------------------
; Function log_chr
; ---------------------------------
_log_chr:
;log.c:106: log_buf[log_pos] = c;
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	iy, #2
	add	iy, sp
	ld	a, 0 (iy)
	ld	(hl), a
;log.c:107: if ( ++log_pos == LOG_LEN ) log_flush();
	ld	hl, (_log_pos)
	inc	hl
	ld	(_log_pos), hl
	ld	a, l
	sub	a, #0x80
	or	a, h
	jp	Z,_log_flush
	ret
;log.c:108: }
	jp	_log_flush
;log.c:110: void log_printf(const char *ps)
;	---------------------------------
; Function log_printf
; ---------------------------------
_log_printf::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;log.c:112: log_ptr = &log_buf[log_pos];
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	c, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	b, a
	ld	(_log_ptr), bc
;log.c:113: while ( ( *ps ) && ( *ps != '$' ) )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
00104$:
	ld	a, (bc)
	ld	-1 (ix), a
	or	a, a
	jr	Z,00106$
	ld	a, -1 (ix)
	sub	a, #0x24
	jr	Z,00106$
;log.c:115: log_buf[log_pos] = *(ps++);
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	e, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	d, a
	ld	a, -1 (ix)
	inc	bc
	ld	(de), a
;log.c:116: if ( ++log_pos == LOG_LEN ) log_flush();
	ld	hl, (_log_pos)
	inc	hl
	ld	(_log_pos), hl
	ld	a, l
	sub	a, #0x80
	or	a, h
	jr	NZ,00104$
	push	bc
	call	_log_flush
	pop	bc
	jr	00104$
00106$:
;log.c:118: log_show();
	call	_log_show
;log.c:119: }
	inc	sp
	pop	ix
	ret
;log.c:121: void log_line(const char *ps)
;	---------------------------------
; Function log_line
; ---------------------------------
_log_line::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;log.c:123: log_ptr = &log_buf[log_pos];
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	c, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	b, a
	ld	(_log_ptr), bc
;log.c:124: while (*ps)
	ld	e, 4 (ix)
	ld	d, 5 (ix)
00105$:
	ld	a, (de)
	ld	-1 (ix), a
	or	a, a
	jr	Z,00107$
;log.c:126: log_buf[log_pos] = *ps;
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	c, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	b, a
	ld	a, -1 (ix)
	ld	(bc), a
;log.c:127: if ( ++log_pos == LOG_LEN ) log_flush();
	ld	hl, (_log_pos)
	inc	hl
	ld	(_log_pos), hl
	ld	a, l
	sub	a, #0x80
	or	a, h
	jr	NZ,00102$
	push	de
	call	_log_flush
	pop	de
00102$:
;log.c:128: if ( *ps == '\n' ) break;
	ld	a, (de)
	sub	a, #0x0a
	jr	Z,00107$
;log.c:129: ++ps;
	inc	de
	jr	00105$
00107$:
;log.c:131: log_show();
	call	_log_show
;log.c:132: }
	inc	sp
	pop	ix
	ret
;log.c:134: void log_str(const char *ps)
;	---------------------------------
; Function log_str
; ---------------------------------
_log_str::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;log.c:136: log_ptr = &log_buf[log_pos];
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	c, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	b, a
	ld	(_log_ptr), bc
;log.c:137: while ( *ps )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
00103$:
	ld	a, (bc)
	ld	-1 (ix), a
	or	a, a
	jr	Z,00105$
;log.c:139: log_buf[log_pos] = *(ps++);
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	e, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	d, a
	ld	a, -1 (ix)
	inc	bc
	ld	(de), a
;log.c:140: if ( ++log_pos == LOG_LEN ) log_flush();
	ld	hl, (_log_pos)
	inc	hl
	ld	(_log_pos), hl
	ld	a, l
	sub	a, #0x80
	or	a, h
	jr	NZ,00103$
	push	bc
	call	_log_flush
	pop	bc
	jr	00103$
00105$:
;log.c:142: log_show();
	call	_log_show
;log.c:143: }
	inc	sp
	pop	ix
	ret
;log.c:145: void log_strn(const char *ps, word n)
;	---------------------------------
; Function log_strn
; ---------------------------------
_log_strn::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;log.c:147: log_ptr = &log_buf[log_pos];
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	c, a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	b, a
	ld	(_log_ptr), bc
;log.c:148: while ( ( *ps ) && ( n > 0 ) )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	e, 6 (ix)
	ld	d, 7 (ix)
00104$:
	ld	a, (bc)
	ld	-3 (ix), a
	or	a, a
	jr	Z,00106$
	ld	a, d
	or	a, e
	jr	Z,00106$
;log.c:150: log_buf[log_pos] = *(ps++);
	ld	a, #<(_log_buf)
	ld	hl, #_log_pos
	add	a, (hl)
	ld	-2 (ix), a
	ld	a, #>(_log_buf)
	inc	hl
	adc	a, (hl)
	ld	-1 (ix), a
	ld	a, -3 (ix)
	inc	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), a
;log.c:151: if ( ++log_pos == LOG_LEN ) log_flush();
	ld	hl, (_log_pos)
	inc	hl
	ld	(_log_pos), hl
	ld	a, l
	sub	a, #0x80
	or	a, h
	jr	NZ,00102$
	push	bc
	push	de
	call	_log_flush
	pop	de
	pop	bc
00102$:
;log.c:152: --n;
	dec	de
	jr	00104$
00106$:
;log.c:154: log_show();
	call	_log_show
;log.c:155: }
	ld	sp, ix
	pop	ix
	ret
;log.c:157: static void log_hex(byte b)
;	---------------------------------
; Function log_hex
; ---------------------------------
_log_hex:
;log.c:159: byte h = b >> 4;
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
;log.c:160: log_chr((h < 10) ? h + '0' : h - 10 + 'A');
	ld	c, a
	sub	a, #0x0a
	jr	NC,00103$
	ld	a, c
	add	a, #0x30
	jr	00104$
00103$:
	ld	a, c
	add	a, #0x37
00104$:
	push	af
	inc	sp
	call	_log_chr
	inc	sp
;log.c:161: h = b & 0x0F;
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	and	a, #0x0f
;log.c:160: log_chr((h < 10) ? h + '0' : h - 10 + 'A');
	ld	c, a
;log.c:162: log_chr((h < 10) ? h + '0' : h - 10 + 'A');
	sub	a, #0x0a
	jr	NC,00105$
	ld	a, c
	add	a, #0x30
	jr	00106$
00105$:
	ld	a, c
	add	a, #0x37
00106$:
	push	af
	inc	sp
	call	_log_chr
	inc	sp
;log.c:163: }
	ret
;log.c:165: void log_bin(const char *ps, word n)
;	---------------------------------
; Function log_bin
; ---------------------------------
_log_bin::
;log.c:167: log_ptr = &log_buf[log_pos];
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(_log_ptr), hl
;log.c:168: do
	ld	iy, #4
	add	iy, sp
	ld	c, 0 (iy)
	ld	b, 1 (iy)
	dec	iy
	dec	iy
	ld	e, 0 (iy)
	ld	d, 1 (iy)
00105$:
;log.c:170: char c = *(ps++);
	ld	a, (de)
	ld	h, a
	inc	de
;log.c:171: if (( c >= ' ' ) && ( c < 0x7F ))
	ld	a,h
	cp	a,#0x20
	jr	C,00102$
	sub	a, #0x7f
	jr	NC,00102$
;log.c:173: log_chr (c);
	push	bc
	push	de
	push	hl
	inc	sp
	call	_log_chr
	inc	sp
	pop	de
	pop	bc
	jr	00106$
00102$:
;log.c:177: log_chr ('\\');
	push	hl
	push	bc
	push	de
	ld	a, #0x5c
	push	af
	inc	sp
	call	_log_chr
	inc	sp
	pop	de
	pop	bc
	pop	hl
;log.c:178: log_hex (c);
	push	bc
	push	de
	push	hl
	inc	sp
	call	_log_hex
	inc	sp
	pop	de
	pop	bc
00106$:
;log.c:181: while ( --n );
	dec	bc
	ld	a, b
	or	a, c
	jr	NZ,00105$
;log.c:182: log_show();
;log.c:183: }
	jp	_log_show
;log.c:185: void log_byte(byte b)
;	---------------------------------
; Function log_byte
; ---------------------------------
_log_byte::
;log.c:187: log_ptr = &log_buf[log_pos];
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(_log_ptr), hl
;log.c:188: log_hex(b);
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	_log_hex
	inc	sp
;log.c:189: log_show();
;log.c:190: }
	jp	_log_show
;log.c:192: void log_word(word w)
;	---------------------------------
; Function log_word
; ---------------------------------
_log_word::
;log.c:194: log_ptr = &log_buf[log_pos];
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(_log_ptr), hl
;log.c:195: log_hex(w >> 8);
	ld	hl, #2+1
	add	hl, sp
	ld	b, (hl)
	ld	c, #0x00
	push	bc
	inc	sp
	call	_log_hex
	inc	sp
;log.c:196: log_hex(w & 0xFF);
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	_log_hex
	inc	sp
;log.c:197: log_show();
;log.c:198: }
	jp	_log_show
;log.c:200: static void log_udgt(word *w, byte *f, word d)
;	---------------------------------
; Function log_udgt
; ---------------------------------
_log_udgt:
	push	ix
	ld	ix,#0
	add	ix,sp
;log.c:203: while ( *w >= d )
	ld	c, #0x30
00101$:
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	dec	hl
	ld	a, e
	sub	a, 8 (ix)
	ld	a, d
	sbc	a, 9 (ix)
	jr	C,00112$
;log.c:205: *w -= d;
	ld	a, e
	sub	a, 8 (ix)
	ld	b, a
	ld	a, d
	sbc	a, 9 (ix)
	ld	(hl), b
	inc	hl
	ld	(hl), a
;log.c:206: ++c;
	inc	c
	jr	00101$
00112$:
	ld	b, c
;log.c:208: if (( c > '0' ) || ( *f ))
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	ld	a, #0x30
	sub	a, c
	jr	C,00104$
	ld	a, (hl)
	or	a, a
	jr	Z,00107$
00104$:
;log.c:210: log_chr(c);
	push	hl
	push	bc
	inc	sp
	call	_log_chr
	inc	sp
	pop	hl
;log.c:211: *f = 1;
	ld	(hl), #0x01
00107$:
;log.c:213: }
	pop	ix
	ret
;log.c:215: static void log_udec(word w)
;	---------------------------------
; Function log_udec
; ---------------------------------
_log_udec:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;log.c:217: byte f = 0;
	xor	a, a
	ld	-5 (ix), a
;log.c:218: log_udgt(&w, &f, 10000);
	ld	hl, #0
	add	hl, sp
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	c, l
	ld	b, h
	ld	hl, #9
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ex	de,hl
	ld	hl, #0x2710
	push	hl
	push	bc
	push	de
	call	_log_udgt
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;log.c:219: log_udgt(&w, &f, 1000);
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x03e8
	push	hl
	push	bc
	push	de
	call	_log_udgt
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;log.c:220: log_udgt(&w, &f, 100);
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x0064
	push	hl
	push	bc
	push	de
	call	_log_udgt
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;log.c:221: log_udgt(&w, &f, 10);
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	ld	hl, #0x000a
	push	hl
	push	bc
	push	de
	call	_log_udgt
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;log.c:222: log_chr(w + '0');
	ld	a, 4 (ix)
	add	a, #0x30
	push	af
	inc	sp
	call	_log_chr
;log.c:223: }
	ld	sp,ix
	pop	ix
	ret
;log.c:225: void log_uint(word w)
;	---------------------------------
; Function log_uint
; ---------------------------------
_log_uint::
;log.c:227: log_ptr = &log_buf[log_pos];
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(_log_ptr), hl
;log.c:228: log_udec(w);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_log_udec
	pop	af
;log.c:229: log_show();
;log.c:230: }
	jp	_log_show
;log.c:232: void log_int(int i)
;	---------------------------------
; Function log_int
; ---------------------------------
_log_int::
;log.c:234: log_ptr = &log_buf[log_pos];
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(_log_ptr), hl
;log.c:235: if ( i < 0 )
	ld	hl, #2+1
	add	hl, sp
	bit	7, (hl)
	jr	Z,00102$
;log.c:237: log_chr('-');
	ld	a, #0x2d
	push	af
	inc	sp
	call	_log_chr
	inc	sp
;log.c:238: i = -i;
	ld	hl, #2
	add	hl, sp
	xor	a, a
	sub	a, (hl)
	ld	(hl), a
	ld	a, #0x00
	inc	hl
	sbc	a, (hl)
	ld	(hl), a
00102$:
;log.c:240: log_udec(i);
	pop	de
	pop	bc
	push	bc
	push	de
	push	bc
	call	_log_udec
	pop	af
;log.c:241: log_show();
;log.c:242: }
	jp	_log_show
;log.c:244: void log_close(void)
;	---------------------------------
; Function log_close
; ---------------------------------
_log_close::
;log.c:246: if ( log_fil )
	ld	a,(#_log_fil + 0)
	or	a, a
	ret	Z
;log.c:248: if ( log_pos > 0 )
	ld	iy, #_log_pos
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00102$
;log.c:250: log_buf[log_pos] = 0x1A;
	ld	bc, #_log_buf+0
	ld	hl, (_log_pos)
	add	hl, bc
	ld	(hl), #0x1a
;log.c:251: log_pos = 0;
	ld	hl, #0x0000
	ld	(_log_pos), hl
;log.c:252: log_flush();
	call	_log_flush
00102$:
;log.c:254: bdos_close_file(&log_fcb);
	ld	hl, #_log_fcb
	push	hl
	call	_bdos_close_file
	pop	af
;log.c:256: }
	ret
	.area _CODE
	.area _INITIALIZER
__xinit__log_pos:
	.dw #0x0000
__xinit__log_ptr:
	.dw _log_buf
__xinit__log_fil:
	.db #0x00	; 0
__xinit__log_nshow:
	.dw #0x0000
	.area _CABS (ABS)
