;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module net
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _log_close
	.globl _log_uint
	.globl _log_byte
	.globl _log_printf
	.globl _wiz_read_n
	.globl _wiz_read_word
	.globl _wiz_read
	.globl _wiz_write_n
	.globl _wiz_write_word
	.globl _wiz_write
	.globl _wiz_reset
	.globl _wiz_config
	.globl _bdos_read_file
	.globl _bdos_open_file
	.globl _bdos_set_dma_address
	.globl _bdos_exit
	.globl _fiber_dequeue
	.globl _fiber_enqueue
	.globl _list_remove_first
	.globl _list_add_last
	.globl _list_add_first
	.globl _list_init
	.globl _net_alloc
	.globl _net_free
	.globl _net_next_ephemeral_port
	.globl _net_connect
	.globl _net_listen
	.globl _net_disconnect
	.globl _net_send
	.globl _net_recv
	.globl _net_handle_interrupts
	.globl _net_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_net_fcb:
	.ds 36
_net_dma:
	.ds 128
_net_sockets:
	.ds 136
_net_sockets_free:
	.ds 4
_net_sockets_waiters:
	.ds 4
_show_reg_hex_65536_203:
	.ds 8
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_ip_subnet:
	.ds 4
_ip:
	.ds 4
_ip_gateway:
	.ds 4
_mac:
	.ds 6
_net_pch:
	.ds 2
_net_ephemeral:
	.ds 2
_psStatus:
	.ds 18
_nibble:
	.ds 3
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;net.c:623: static char hex[] = "????\r\n$";
	ld	hl, #_show_reg_hex_65536_203
	ld	(hl), #0x3f
	ld	hl, #(_show_reg_hex_65536_203 + 0x0001)
	ld	(hl), #0x3f
	ld	hl, #(_show_reg_hex_65536_203 + 0x0002)
	ld	(hl), #0x3f
	ld	hl, #(_show_reg_hex_65536_203 + 0x0003)
	ld	(hl), #0x3f
	ld	hl, #(_show_reg_hex_65536_203 + 0x0004)
	ld	(hl), #0x0d
	ld	hl, #(_show_reg_hex_65536_203 + 0x0005)
	ld	(hl), #0x0a
	ld	hl, #(_show_reg_hex_65536_203 + 0x0006)
	ld	(hl), #0x24
	ld	hl, #(_show_reg_hex_65536_203 + 0x0007)
	ld	(hl), #0x00
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;net.c:63: static void net_fatal(SOCKET *socket, char *error)
;	---------------------------------
; Function net_fatal
; ---------------------------------
_net_fatal:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:69: *ps = '0' + ((socket->sra - W5100_ADDR_SOCKET) >> 8);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0007
	add	hl, bc
	ex	de, hl
;net.c:65: if ( socket != NULL )
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	Z,00105$
;net.c:67: char *ps = strchr (error, '?');
	push	de
	ld	d, #0x3f
	ld	l, 6 (ix)
	ld	h, 7 (ix)
00119$:
	ld	a, (hl)
	cp	a, d
	jr	Z,00118$
	or	a, a
	inc	hl
	jr	NZ, 00119$
	ld	l, a
	ld	h, a
00118$:
	pop	de
	inc	sp
	inc	sp
	push	hl
;net.c:68: if ( ps != NULL )
	ld	a, h
	or	a, l
	jr	Z,00105$
;net.c:69: *ps = '0' + ((socket->sra - W5100_ADDR_SOCKET) >> 8);
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	add	a, #0x00
	ld	a, h
	adc	a, #0xfc
	add	a, #0x30
	pop	hl
	push	hl
	ld	(hl), a
;net.c:71: interrupts_disable();
00105$:
;net.c:72: log_printf(error);
	push	bc
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	_log_printf
	ld	hl, #___str_0
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;net.c:74: log_uint ((socket->sra - W5100_ADDR_SOCKET) >> 8);
	ex	de,hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	add	a, #0x00
	ld	a, d
	adc	a, #0xfc
	ld	h, a
	ld	d, #0x00
	ld	e, h
	push	bc
	push	de
	call	_log_uint
	pop	af
	pop	bc
;net.c:75: log_printf (psStatus[socket->state]);
	ld	de, #_psStatus+0
	ld	l, c
	ld	h, b
	ld	bc, #0x000e
	add	hl, bc
	ld	l, (hl)
	ld	h, #0x00
	add	hl, hl
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_log_printf
	pop	af
;net.c:76: log_close();
	call	_log_close
;net.c:77: bdos_exit();
	call	_bdos_exit
;net.c:78: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "Socket $"
	.db 0x00
;net.c:81: static char *byte_dec(char *p, byte b)
;	---------------------------------
; Function byte_dec
; ---------------------------------
_byte_dec:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:85: while (b >= 100)
	ld	b, #0x30
00101$:
	ld	a, 6 (ix)
	sub	a, #0x64
	jr	C,00103$
;net.c:87: ++c1;
	inc	b
;net.c:88: b -= 100;
	ld	a, 6 (ix)
	add	a, #0x9c
	ld	6 (ix), a
	jr	00101$
00103$:
;net.c:90: if (c1 > '0') *(p++) = c1;
	ld	a, #0x30
	sub	a, b
	ld	a, #0x00
	rla
	ld	c, a
	or	a, a
	jr	Z,00118$
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	(hl), b
	inc	hl
	ld	4 (ix), l
	ld	5 (ix), h
;net.c:91: while (b >= 10)
00118$:
	ld	b, #0x30
00106$:
;net.c:88: b -= 100;
	ld	e, 6 (ix)
;net.c:91: while (b >= 10)
	ld	a, 6 (ix)
	sub	a, #0x0a
	jr	C,00121$
;net.c:93: ++c2;
	inc	b
;net.c:94: b -= 10;
	ld	a, e
	add	a, #0xf6
	ld	6 (ix), a
	jr	00106$
00121$:
	ld	d, b
;net.c:96: if ((c1 > '0') || (c2 > '0'))  *(p++) = c2;
	ld	a, c
	or	a, a
	jr	NZ,00109$
	ld	a, #0x30
	sub	a, b
	jr	NC,00110$
00109$:
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	(hl), d
	inc	hl
	ld	4 (ix), l
	ld	5 (ix), h
00110$:
;net.c:97: *(p++) = b + '0';
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, e
	add	a, #0x30
	ld	(bc), a
	inc	bc
;net.c:98: return p;
	ld	4 (ix), c
	ld	5 (ix), b
	ld	l, c
	ld	h, b
;net.c:99: }
	pop	ix
	ret
;net.c:101: static void cfg_err(const char *err, byte c, byte n)
;	---------------------------------
; Function cfg_err
; ---------------------------------
_cfg_err:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-26
	add	hl, sp
	ld	sp, hl
;net.c:103: char info[] = "'?' (??h) at ?  \r\n$";
	ld	hl, #0
	add	hl, sp
	ld	c,l
	ld	b,h
	ld	(hl),#0x27
	ld	hl, #0x0001
	add	hl, bc
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	(hl), #0x3f
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	(hl), #0x27
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	(hl), #0x20
	ld	hl, #0x0004
	add	hl, bc
	ld	(hl), #0x28
	ld	hl, #0x0005
	add	hl, bc
	ex	de, hl
	ld	a, #0x3f
	ld	(de), a
	ld	hl, #0x0006
	add	hl, bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	(hl), #0x3f
	ld	hl, #0x0007
	add	hl, bc
	ld	(hl), #0x68
	ld	hl, #0x0008
	add	hl, bc
	ld	(hl), #0x29
	ld	hl, #0x0009
	add	hl, bc
	ld	(hl), #0x20
	ld	hl, #0x000a
	add	hl, bc
	ld	(hl), #0x61
	ld	hl, #0x000b
	add	hl, bc
	ld	(hl), #0x74
	ld	hl, #0x000c
	add	hl, bc
	ld	(hl), #0x20
	ld	hl, #0x000d
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	(hl), #0x3f
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x20
	ld	hl, #0x000f
	add	hl, bc
	ld	(hl), #0x20
	ld	hl, #0x0010
	add	hl, bc
	ld	(hl), #0x0d
	ld	hl, #0x0011
	add	hl, bc
	ld	(hl), #0x0a
	ld	hl, #0x0012
	add	hl, bc
	ld	(hl), #0x24
	ld	hl, #0x0013
	add	hl, bc
	ld	(hl), #0x00
;net.c:105: log_printf(err);
	push	bc
	push	de
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;net.c:106: info[1] = c;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, 6 (ix)
	ld	(hl), a
;net.c:107: h = c >> 4;
	ld	a, 6 (ix)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
;net.c:108: info[5] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	l, a
	sub	a, #0x0a
	jr	NC,00103$
	ld	a, l
	add	a, #0x30
	jr	00104$
00103$:
	ld	a, l
	add	a, #0x37
00104$:
	ld	(de), a
;net.c:109: h = c & 0x0F;
	ld	a, 6 (ix)
	and	a, #0x0f
	ld	d, a
;net.c:110: info[6] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	l, -4 (ix)
	ld	h, -3 (ix)
;net.c:108: info[5] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	e, d
;net.c:110: info[6] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	a, d
	sub	a, #0x0a
	jr	NC,00105$
	ld	a, e
	add	a, #0x30
	jr	00106$
00105$:
	ld	a, e
	add	a, #0x37
00106$:
	ld	(hl), a
;net.c:111: byte_dec(info + 13, n);
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	bc
	ld	a, 7 (ix)
	push	af
	inc	sp
	push	de
	call	_byte_dec
	inc	sp
	ld	hl,#0x0000
	ex	(sp),hl
	call	_net_fatal
;net.c:113: }
	ld	sp,ix
	pop	ix
	ret
;net.c:115: static byte net_ch(void)
;	---------------------------------
; Function net_ch
; ---------------------------------
_net_ch:
;net.c:118: if ( net_pch == NULL ) return 0x1A;
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	NZ,00102$
	ld	l, #0x1a
	ret
00102$:
;net.c:119: if ( net_pch >= net_dma + 128 )
	ld	bc, #(_net_dma + 0x0080)
	ld	hl, (_net_pch)
	xor	a, a
	sbc	hl, bc
	jr	C,00106$
;net.c:121: if ( bdos_read_file (&net_fcb) != 0 )
	ld	hl, #_net_fcb
	push	hl
	call	_bdos_read_file
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00104$
;net.c:123: net_pch = NULL;
	ld	hl, #0x0000
	ld	(_net_pch), hl
;net.c:124: return 0x1A;
	ld	l, #0x1a
	ret
00104$:
;net.c:126: net_pch = net_dma;
	ld	hl, #_net_dma
	ld	(_net_pch), hl
00106$:
;net.c:128: b = *(net_pch++);
	ld	hl, (_net_pch)
	ld	c, (hl)
	ld	hl, (_net_pch)
	inc	hl
	ld	(_net_pch), hl
;net.c:129: if ( b == 0x1A ) net_pch = NULL;
	ld	a, c
	sub	a, #0x1a
	jr	NZ,00108$
	ld	hl, #0x0000
	ld	(_net_pch), hl
00108$:
;net.c:130: return b;
	ld	l, c
;net.c:131: }
	ret
;net.c:133: static void net_parse_ip (byte *ip)
;	---------------------------------
; Function net_parse_ip
; ---------------------------------
_net_parse_ip:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;net.c:136: word b = 0;
	ld	hl, #0x0000
	ex	(sp), hl
;net.c:137: byte c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:138: byte n = 1;
	ld	-1 (ix), #0x01
;net.c:139: byte d = 0;
	xor	a, a
	ld	-4 (ix), a
;net.c:140: while ((c == ' ') || (c == '\t'))
	ld	-2 (ix), #0x01
00104$:
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00105$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	NZ,00157$
00105$:
;net.c:142: if ( c == 0x1A ) return;
	ld	a, -8 (ix)
	sub	a, #0x1a
	jp	Z,00141$
	jr	00102$
	jp	00141$
00102$:
;net.c:143: c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:144: ++n;
	inc	-2 (ix)
	ld	a, -2 (ix)
	ld	-1 (ix), a
	jr	00104$
;net.c:146: while (TRUE)
00157$:
	xor	a, a
	ld	-3 (ix), a
	ld	-2 (ix), a
00128$:
;net.c:148: if (( c >= '0' ) && ( c <= '9' ))
	ld	a, -8 (ix)
	sub	a, #0x30
	jr	C,00124$
	ld	a, #0x39
	sub	a, -8 (ix)
	jr	C,00124$
;net.c:150: b = 10 * b + ( c - '0' );
	pop	bc
	push	bc
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	a, -8 (ix)
	ld	b, #0x00
	add	a, #0xd0
	ld	c, a
	ld	a, b
	adc	a, #0xff
	ld	b, a
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;net.c:151: ++d;
	inc	-4 (ix)
;net.c:152: if ( b > 255 ) cfg_err("Byte overflow: $", c, n);
	pop	bc
	push	bc
	ld	a, #0xff
	cp	a, c
	ld	a, #0x00
	sbc	a, b
	jp	NC, 00125$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_2
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	jp	00125$
00124$:
;net.c:158: ip[i] = b;
	ld	a, 4 (ix)
	add	a, -3 (ix)
	ld	-7 (ix), a
	ld	a, 5 (ix)
	adc	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, -10 (ix)
	ld	-5 (ix), a
;net.c:154: else if ( c == '.' )
	ld	a, -8 (ix)
	sub	a, #0x2e
	jr	NZ,00121$
;net.c:156: if ( i > 2 ) cfg_err("Too many parts: $", c, n);
	ld	a, #0x02
	cp	a, -3 (ix)
	ld	a, #0x00
	sbc	a, -2 (ix)
	jp	PO, 00262$
	xor	a, #0x80
00262$:
	jp	P, 00110$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_3
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00110$:
;net.c:157: if ( d == 0 ) cfg_err("Missing digits: $", c, n);
	ld	a, -4 (ix)
	or	a, a
	jr	NZ,00112$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_4
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00112$:
;net.c:158: ip[i] = b;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	a, -5 (ix)
	ld	(hl), a
;net.c:159: b = 0;
	ld	hl, #0x0000
	ex	(sp), hl
;net.c:160: d = 0;
	xor	a, a
	ld	-4 (ix), a
;net.c:161: ++i;
	inc	-3 (ix)
	jr	NZ,00125$
	inc	-2 (ix)
	jr	00125$
00121$:
;net.c:163: else if ((c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') || (c == 0x1A))
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00165$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	Z,00165$
	ld	a, -8 (ix)
	sub	a, #0x0d
	jr	Z,00165$
	ld	a, -8 (ix)
	sub	a, #0x0a
	jr	Z,00165$
	ld	a, -8 (ix)
	sub	a, #0x1a
	jr	Z,00165$
;net.c:169: cfg_err("Invalid character: $", c, n);
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_5
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00125$:
;net.c:171: c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:172: ++n;
	inc	-1 (ix)
	jp	00128$
00165$:
	ld	a, -1 (ix)
	ld	-4 (ix), a
;net.c:174: if ( i == 3 ) ip[i] = b;
	ld	a, -3 (ix)
	sub	a, #0x03
	or	a, -2 (ix)
	jr	NZ,00131$
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	a, -5 (ix)
	ld	(hl), a
	jr	00164$
00131$:
;net.c:175: else cfg_err("Missing parts: $", c, n);
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_6
	push	hl
	call	_cfg_err
	pop	af
	pop	af
;net.c:176: while ((c != '\n') && (c != 0x1A))
00164$:
	ld	b, -4 (ix)
00138$:
	ld	a, -8 (ix)
	sub	a, #0x0a
	jr	Z,00141$
	ld	a, -8 (ix)
	sub	a, #0x1a
	jr	Z,00141$
;net.c:178: if ((c != ' ') && (c != '\t') && (c != '\r')) cfg_err("Invalid character: $", c, n);
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00134$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	Z,00134$
	ld	a, -8 (ix)
	sub	a, #0x0d
	jr	Z,00134$
	push	bc
	push	bc
	inc	sp
	ld	a, -8 (ix)
	push	af
	inc	sp
	ld	hl, #___str_5
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	pop	bc
00134$:
;net.c:179: c = net_ch();
	push	bc
	call	_net_ch
	pop	bc
	ld	-8 (ix), l
;net.c:180: ++n;
	inc	b
	jr	00138$
00141$:
;net.c:182: }
	ld	sp, ix
	pop	ix
	ret
___str_2:
	.ascii "Byte overflow: $"
	.db 0x00
___str_3:
	.ascii "Too many parts: $"
	.db 0x00
___str_4:
	.ascii "Missing digits: $"
	.db 0x00
___str_5:
	.ascii "Invalid character: $"
	.db 0x00
___str_6:
	.ascii "Missing parts: $"
	.db 0x00
;net.c:184: static void net_parse_mac (byte *mac)
;	---------------------------------
; Function net_parse_mac
; ---------------------------------
_net_parse_mac:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;net.c:186: word b = 0;
	ld	hl, #0x0000
	ex	(sp), hl
;net.c:187: byte c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:189: byte n = 1;
	ld	-1 (ix), #0x01
;net.c:190: byte d = 0;
	xor	a, a
	ld	-7 (ix), a
;net.c:191: while ((c == ' ') || (c == '\t'))
	ld	-2 (ix), #0x01
00104$:
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00105$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	NZ,00170$
00105$:
;net.c:193: if ( c == 0x1A ) return;
	ld	a, -8 (ix)
	sub	a, #0x1a
	jp	Z,00150$
	jr	00102$
	jp	00150$
00102$:
;net.c:194: c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:195: ++n;
	inc	-2 (ix)
	ld	a, -2 (ix)
	ld	-1 (ix), a
	jr	00104$
;net.c:197: while (TRUE)
00170$:
	xor	a, a
	ld	-3 (ix), a
	ld	-2 (ix), a
00137$:
;net.c:201: b = 16 * b + ( c - '0' );
	pop	hl
	push	hl
	ld	a, -8 (ix)
	ld	-6 (ix), a
	xor	a, a
	ld	-5 (ix), a
;net.c:202: ++d;
	ld	a, -7 (ix)
	inc	a
	ld	-4 (ix), a
;net.c:201: b = 16 * b + ( c - '0' );
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
;net.c:199: if (( c >= '0' ) && ( c <= '9' ))
	ld	a, -8 (ix)
	sub	a, #0x30
	jr	C,00131$
	ld	a, #0x39
	sub	a, -8 (ix)
	jr	C,00131$
;net.c:201: b = 16 * b + ( c - '0' );
	ld	a, -6 (ix)
	add	a, #0xd0
	ld	c, a
	ld	a, -5 (ix)
	adc	a, #0xff
	ld	b, a
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;net.c:202: ++d;
	ld	a, -4 (ix)
	ld	-7 (ix), a
	jp	00132$
00131$:
;net.c:204: else if (( c >= 'A' ) && ( c <= 'F' ))
	ld	a, -8 (ix)
	sub	a, #0x41
	jr	C,00127$
	ld	a, #0x46
	sub	a, -8 (ix)
	jr	C,00127$
;net.c:206: b = 16 * b + ( c - 'A' + 10 );
	ld	a, -6 (ix)
	add	a, #0xc9
	ld	c, a
	ld	a, -5 (ix)
	adc	a, #0xff
	ld	b, a
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;net.c:207: ++d;
	ld	a, -4 (ix)
	ld	-7 (ix), a
	jp	00132$
00127$:
;net.c:209: else if (( c >= 'a' ) && ( c <= 'f' ))
	ld	a, -8 (ix)
	sub	a, #0x61
	jr	C,00123$
	ld	a, #0x66
	sub	a, -8 (ix)
	jr	C,00123$
;net.c:211: b = 16 * b + ( c - 'a' + 10 );
	ld	a, -6 (ix)
	add	a, #0xa9
	ld	c, a
	ld	a, -5 (ix)
	adc	a, #0xff
	ld	b, a
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;net.c:212: ++d;
	ld	a, -4 (ix)
	ld	-7 (ix), a
	jp	00132$
00123$:
;net.c:218: mac[i] = b;
	ld	a, 4 (ix)
	add	a, -3 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	adc	a, -2 (ix)
	ld	-5 (ix), a
	ld	a, -10 (ix)
	ld	-4 (ix), a
;net.c:214: else if (( c == ':' ) || (c == '-'))
	ld	a, -8 (ix)
	sub	a, #0x3a
	jr	Z,00118$
	ld	a, -8 (ix)
	sub	a, #0x2d
	jr	NZ,00119$
00118$:
;net.c:216: if ( i > 4 ) cfg_err("Too many parts: $", c, n);
	ld	a, #0x04
	cp	a, -3 (ix)
	ld	a, #0x00
	sbc	a, -2 (ix)
	jp	PO, 00292$
	xor	a, #0x80
00292$:
	jp	P, 00108$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_7
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00108$:
;net.c:217: if ( d == 0 ) cfg_err("Missing digits: $", c, n);
	ld	a, -7 (ix)
	or	a, a
	jr	NZ,00110$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_8
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00110$:
;net.c:218: mac[i] = b;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
;net.c:219: b = 0;
	ld	hl, #0x0000
	ex	(sp), hl
;net.c:220: d = 0;
	xor	a, a
	ld	-7 (ix), a
;net.c:221: ++i;
	inc	-3 (ix)
	jr	NZ,00132$
	inc	-2 (ix)
	jr	00132$
00119$:
;net.c:223: else if ((c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') || (c == 0x1A))
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00178$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	Z,00178$
	ld	a, -8 (ix)
	sub	a, #0x0d
	jr	Z,00178$
	ld	a, -8 (ix)
	sub	a, #0x0a
	jr	Z,00178$
	ld	a, -8 (ix)
	sub	a, #0x1a
	jr	Z,00178$
;net.c:229: cfg_err("Invalid character: $", c, n);
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_9
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00132$:
;net.c:231: if ( b > 255 ) cfg_err("Byte overflow: $", c, n);
	pop	bc
	push	bc
	ld	a, #0xff
	cp	a, c
	ld	a, #0x00
	sbc	a, b
	jr	NC,00135$
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_10
	push	hl
	call	_cfg_err
	pop	af
	pop	af
00135$:
;net.c:232: c = net_ch();
	call	_net_ch
	ld	-8 (ix), l
;net.c:233: ++n;
	inc	-1 (ix)
	jp	00137$
00178$:
	ld	a, -1 (ix)
	ld	-7 (ix), a
;net.c:235: if ( i == 5 ) mac[i] = b;
	ld	a, -3 (ix)
	sub	a, #0x05
	or	a, -2 (ix)
	jr	NZ,00140$
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
	jr	00177$
00140$:
;net.c:236: else cfg_err("Missing parts: $", c, n);
	ld	h, -1 (ix)
	ld	l, -8 (ix)
	push	hl
	ld	hl, #___str_11
	push	hl
	call	_cfg_err
	pop	af
	pop	af
;net.c:237: while ((c != '\n') && (c != 0x1A))
00177$:
	ld	b, -7 (ix)
00147$:
	ld	a, -8 (ix)
	sub	a, #0x0a
	jr	Z,00150$
	ld	a, -8 (ix)
	sub	a, #0x1a
	jr	Z,00150$
;net.c:239: if ((c != ' ') && (c != '\t') && (c != '\r')) cfg_err("Invalid character: $", c, n);
	ld	a, -8 (ix)
	sub	a, #0x20
	jr	Z,00143$
	ld	a, -8 (ix)
	sub	a, #0x09
	jr	Z,00143$
	ld	a, -8 (ix)
	sub	a, #0x0d
	jr	Z,00143$
	push	bc
	push	bc
	inc	sp
	ld	a, -8 (ix)
	push	af
	inc	sp
	ld	hl, #___str_9
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	pop	bc
00143$:
;net.c:240: c = net_ch();
	push	bc
	call	_net_ch
	pop	bc
	ld	-8 (ix), l
;net.c:241: ++n;
	inc	b
	jr	00147$
00150$:
;net.c:243: }
	ld	sp, ix
	pop	ix
	ret
___str_7:
	.ascii "Too many parts: $"
	.db 0x00
___str_8:
	.ascii "Missing digits: $"
	.db 0x00
___str_9:
	.ascii "Invalid character: $"
	.db 0x00
___str_10:
	.ascii "Byte overflow: $"
	.db 0x00
___str_11:
	.ascii "Missing parts: $"
	.db 0x00
;net.c:246: static void net_parse_port (byte *port)
;	---------------------------------
; Function net_parse_port
; ---------------------------------
_net_parse_port:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;net.c:248: word b = 0;
	ld	hl, #0x0000
	ex	(sp), hl
;net.c:249: byte c = net_ch();
	call	_net_ch
	ld	c, l
;net.c:250: byte n = 1;
	ld	e, #0x01
;net.c:251: byte d = 0;
	xor	a, a
	ld	-4 (ix), a
;net.c:252: while ((c == ' ') || (c == '\t'))
	ld	l, #0x01
00104$:
	ld	a,c
	cp	a,#0x20
	jr	Z,00105$
	sub	a, #0x09
	jr	NZ,00158$
00105$:
;net.c:254: if ( c == 0x1A ) return;
	ld	a, c
	sub	a, #0x1a
	jp	Z,00141$
	jr	00102$
	jp	00141$
00102$:
;net.c:255: c = net_ch();
	push	hl
	call	_net_ch
	ld	a, l
	pop	hl
	ld	c, a
;net.c:256: ++n;
	inc	l
	ld	e, l
	jr	00104$
;net.c:258: while (TRUE)
00158$:
	ld	b, e
00129$:
;net.c:262: b = 16 * b + ( c - '0' );
	pop	hl
	push	hl
	ld	e, c
	ld	d, #0x00
;net.c:263: ++d;
	ld	a, -4 (ix)
	inc	a
	ld	-3 (ix), a
;net.c:262: b = 16 * b + ( c - '0' );
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	-2 (ix), l
	ld	-1 (ix), h
;net.c:260: if (( c >= '0' ) && ( c <= '9' ))
	ld	a, c
	sub	a, #0x30
	jr	C,00123$
	ld	a, #0x39
	sub	a, c
	jr	C,00123$
;net.c:262: b = 16 * b + ( c - '0' );
	ld	a, e
	add	a, #0xd0
	ld	e, a
	ld	a, d
	adc	a, #0xff
	ld	d, a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	inc	sp
	inc	sp
	push	hl
;net.c:263: ++d;
	ld	a, -3 (ix)
	ld	-4 (ix), a
	jr	00124$
00123$:
;net.c:265: else if (( c >= 'A' ) && ( c <= 'F' ))
	ld	a, c
	sub	a, #0x41
	jr	C,00119$
	ld	a, #0x46
	sub	a, c
	jr	C,00119$
;net.c:267: b = 16 * b + ( c - 'A' + 10 );
	ld	hl, #0xffc9
	add	hl, de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	add	hl, de
	inc	sp
	inc	sp
	push	hl
;net.c:268: ++d;
	ld	a, -3 (ix)
	ld	-4 (ix), a
	jr	00124$
00119$:
;net.c:270: else if (( c >= 'a' ) && ( c <= 'f' ))
	ld	a, c
	sub	a, #0x61
	jr	C,00115$
	ld	a, #0x66
	sub	a, c
	jr	C,00115$
;net.c:272: b = 16 * b + ( c - 'a' + 10 );
	ld	hl, #0xffa9
	add	hl, de
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	add	hl, de
	inc	sp
	inc	sp
	push	hl
;net.c:273: ++d;
	ld	a, -3 (ix)
	ld	-4 (ix), a
	jr	00124$
00115$:
;net.c:275: else if ((c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') || (c == 0x1A))
	ld	a,c
	cp	a,#0x20
	jr	Z,00166$
	cp	a,#0x09
	jr	Z,00166$
	cp	a,#0x0d
	jr	Z,00166$
	cp	a,#0x0a
	jr	Z,00166$
	sub	a, #0x1a
	jr	Z,00166$
;net.c:281: cfg_err("Invalid character: $", c, n);
	push	bc
	push	bc
	inc	sp
	ld	a, c
	push	af
	inc	sp
	ld	hl, #___str_12
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	pop	bc
00124$:
;net.c:283: if ( b > 255 ) cfg_err("Byte overflow: $", c, n);
	pop	de
	push	de
	ld	a, #0xff
	cp	a, e
	ld	a, #0x00
	sbc	a, d
	jr	NC,00127$
	push	bc
	push	bc
	inc	sp
	ld	a, c
	push	af
	inc	sp
	ld	hl, #___str_13
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	pop	bc
00127$:
;net.c:284: c = net_ch();
	push	bc
	call	_net_ch
	ld	a, l
	pop	bc
	ld	c, a
;net.c:285: ++n;
	inc	b
	jp	00129$
00166$:
;net.c:287: if ( d > 0 ) *port = b;
	ld	a, -4 (ix)
	or	a, a
	jr	Z,00165$
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, -6 (ix)
	ld	(de), a
;net.c:288: while ((c != '\n') && (c != 0x1A))
00165$:
00138$:
	ld	a,c
	cp	a,#0x0a
	jr	Z,00141$
;net.c:290: if ((c != ' ') && (c != '\t') && (c != '\r')) cfg_err("Invalid character: $", c, n);
	cp	a,#0x1a
	jr	Z,00141$
	cp	a,#0x20
	jr	Z,00134$
	cp	a,#0x09
	jr	Z,00134$
	sub	a, #0x0d
	jr	Z,00134$
	push	bc
	push	bc
	inc	sp
	ld	a, c
	push	af
	inc	sp
	ld	hl, #___str_12
	push	hl
	call	_cfg_err
	pop	af
	pop	af
	pop	bc
00134$:
;net.c:291: c = net_ch();
	push	bc
	call	_net_ch
	ld	a, l
	pop	bc
	ld	c, a
;net.c:292: ++n;
	inc	b
	jr	00138$
00141$:
;net.c:294: }
	ld	sp, ix
	pop	ix
	ret
___str_12:
	.ascii "Invalid character: $"
	.db 0x00
___str_13:
	.ascii "Byte overflow: $"
	.db 0x00
;net.c:297: static void show_ip(byte *ip)
;	---------------------------------
; Function show_ip
; ---------------------------------
_show_ip:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-22
	add	hl, sp
	ld	sp, hl
;net.c:300: char *p = addr;
	ld	hl, #0
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	c, l
	ld	b, h
;net.c:301: p = byte_dec(p, ip[0]);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, (de)
	push	de
	push	af
	inc	sp
	push	bc
	call	_byte_dec
	pop	af
	inc	sp
	pop	de
;net.c:302: *(p++) = '.';
	ld	(hl), #0x2e
	inc	hl
	ld	c,l
	ld	b,h
;net.c:303: p = byte_dec(p, ip[1]);
	ld	l, e
	ld	h, d
	inc	hl
	ld	a, (hl)
	push	de
	push	af
	inc	sp
	push	bc
	call	_byte_dec
	pop	af
	inc	sp
	pop	de
;net.c:304: *(p++) = '.';
	ld	(hl), #0x2e
	inc	hl
	ld	c,l
	ld	b,h
;net.c:305: p = byte_dec(p, ip[2]);
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	a, (hl)
	push	de
	push	af
	inc	sp
	push	bc
	call	_byte_dec
	pop	af
	inc	sp
	pop	de
;net.c:306: *(p++) = '.';
	ld	(hl), #0x2e
	inc	hl
	ld	c,l
	ld	b,h
;net.c:307: p = byte_dec(p, ip[3]);
	ex	de,hl
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	push	af
	inc	sp
	push	bc
	call	_byte_dec
	pop	af
	inc	sp
;net.c:308: *(p++) = '\r';
	ld	(hl), #0x0d
	inc	hl
;net.c:309: *(p++) = '\n';
	ld	(hl), #0x0a
	inc	hl
;net.c:310: *(p++) = '$';
	ld	(hl), #0x24
;net.c:311: log_printf(addr);
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	push	bc
	call	_log_printf
;net.c:312: }
	ld	sp,ix
	pop	ix
	ret
;net.c:314: static void show_mac(byte *mac)
;	---------------------------------
; Function show_mac
; ---------------------------------
_show_mac:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-33
	add	hl, sp
	ld	sp, hl
;net.c:317: char *p = addr;
	ld	hl, #0
	add	hl, sp
	ld	-9 (ix), l
	ld	-8 (ix), h
	ld	a, -9 (ix)
	ld	-7 (ix), a
	ld	a, -8 (ix)
	ld	-6 (ix), a
;net.c:320: for (i = 0; i < 6; ++i)
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00102$:
;net.c:322: b = mac[i] >> 4;
	ld	a, 4 (ix)
	add	a, -2 (ix)
	ld	c, a
	ld	a, 5 (ix)
	adc	a, -1 (ix)
	ld	b, a
	ld	a, (bc)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	ld	h, a
;net.c:323: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	a, -7 (ix)
	ld	-4 (ix), a
	ld	a, -6 (ix)
	ld	-3 (ix), a
	ld	e, -7 (ix)
	ld	d, -6 (ix)
	inc	de
	ld	l, h
	ld	a, h
	sub	a, #0x0a
	jr	NC,00106$
	ld	a, l
	add	a, #0x30
	jr	00107$
00106$:
	ld	a, l
	add	a, #0x37
00107$:
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	(hl), a
;net.c:324: b = mac[i] & 0x0F;
	ld	a, (bc)
	and	a, #0x0f
	ld	c, a
;net.c:325: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	-7 (ix), e
	ld	-6 (ix), d
	inc	de
	ld	-5 (ix), e
	ld	-4 (ix), d
;net.c:323: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	-3 (ix), c
;net.c:325: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	a, c
	sub	a, #0x0a
	jr	NC,00108$
	ld	a, -3 (ix)
	add	a, #0x30
	jr	00109$
00108$:
	ld	a, -3 (ix)
	add	a, #0x37
00109$:
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	ld	(hl), a
;net.c:326: *(p++) = ':';
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	ld	(hl), #0x3a
	ld	a, -5 (ix)
	add	a, #0x01
	ld	-7 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-6 (ix), a
;net.c:320: for (i = 0; i < 6; ++i)
	inc	-2 (ix)
	jr	NZ,00131$
	inc	-1 (ix)
00131$:
	ld	a, -2 (ix)
	sub	a, #0x06
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jp	C, 00102$
;net.c:328: --p;
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	dec	hl
;net.c:329: *(p++) = '\r';
	ld	(hl), #0x0d
	inc	hl
;net.c:330: *(p++) = '\n';
	ld	(hl), #0x0a
	inc	hl
;net.c:331: *(p++) = '$';
	ld	(hl), #0x24
;net.c:332: log_printf(addr);
	ld	c, -9 (ix)
	ld	b, -8 (ix)
	push	bc
	call	_log_printf
;net.c:333: }
	ld	sp,ix
	pop	ix
	ret
;net.c:336: static void show_port(byte port)
;	---------------------------------
; Function show_port
; ---------------------------------
_show_port:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;net.c:339: char *p = addr;
	ld	hl, #0
	add	hl, sp
	ld	c,l
	ld	b,h
;net.c:341: b = port >> 4;
	ld	a, 4 (ix)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
;net.c:342: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	-2 (ix), l
	ld	-1 (ix), h
	ex	de,hl
	inc	de
	ld	l, a
	sub	a, #0x0a
	jr	NC,00103$
	ld	a, l
	add	a, #0x30
	jr	00104$
00103$:
	ld	a, l
	add	a, #0x37
00104$:
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), a
;net.c:343: b = port & 0x0F;
	ld	a, 4 (ix)
	and	a, #0x0f
	ld	h, a
;net.c:344: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	-2 (ix), e
	ld	-1 (ix), d
	inc	de
;net.c:342: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	l, h
;net.c:344: *(p++) = ( b < 10 ) ? b + '0' : b - 10 + 'A';
	ld	a, h
	sub	a, #0x0a
	jr	NC,00105$
	ld	a, l
	add	a, #0x30
	jr	00106$
00105$:
	ld	a, l
	add	a, #0x37
00106$:
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), a
;net.c:345: *(p++) = '\r';
	ld	a, #0x0d
	ld	(de), a
	inc	de
;net.c:346: *(p++) = '\n';
	ld	a, #0x0a
	ld	(de), a
	inc	de
;net.c:347: *(p++) = '$';
	ld	a, #0x24
	ld	(de), a
;net.c:348: log_printf(addr);
	push	bc
	call	_log_printf
;net.c:349: }
	ld	sp,ix
	pop	ix
	ret
;net.c:352: static void net_config (void)
;	---------------------------------
; Function net_config
; ---------------------------------
_net_config:
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;net.c:354: byte wnaddr = 0x90;
	ld	-1 (ix), #0x90
;net.c:355: net_fcb.drive = 0;
	ld	hl, #_net_fcb
	ld	(hl), #0x00
;net.c:356: net_fcb.filename[0] = 'N';
	ld	hl, #(_net_fcb + 0x0001)
	ld	(hl), #0x4e
;net.c:357: net_fcb.filename[1] = 'F';
	ld	hl, #(_net_fcb + 0x0002)
	ld	(hl), #0x46
;net.c:358: net_fcb.filename[2] = 'X';
	ld	hl, #(_net_fcb + 0x0003)
	ld	(hl), #0x58
;net.c:359: net_fcb.filename[3] = ' ';
	ld	hl, #(_net_fcb + 0x0004)
	ld	(hl), #0x20
;net.c:360: net_fcb.filename[4] = ' ';
	ld	hl, #(_net_fcb + 0x0005)
	ld	(hl), #0x20
;net.c:361: net_fcb.filename[5] = ' ';
	ld	hl, #(_net_fcb + 0x0006)
	ld	(hl), #0x20
;net.c:362: net_fcb.filename[6] = ' ';
	ld	hl, #(_net_fcb + 0x0007)
	ld	(hl), #0x20
;net.c:363: net_fcb.filename[7] = ' ';
	ld	hl, #(_net_fcb + 0x0008)
	ld	(hl), #0x20
;net.c:364: net_fcb.type[0] = 'C';
	ld	hl, #(_net_fcb + 0x0009)
	ld	(hl), #0x43
;net.c:365: net_fcb.type[1] = 'F';
	ld	hl, #(_net_fcb + 0x000a)
	ld	(hl), #0x46
;net.c:366: net_fcb.type[2] = 'G';
	ld	hl, #(_net_fcb + 0x000b)
	ld	(hl), #0x47
;net.c:367: net_fcb.ex = 0;
	ld	bc, #_net_fcb + 12
	xor	a, a
	ld	(bc), a
;net.c:368: net_fcb.s1 = 0;
	ld	hl, #(_net_fcb + 0x000d)
	ld	(hl), #0x00
;net.c:369: net_fcb.s2 = 0;
	ld	hl, #(_net_fcb + 0x000e)
	ld	(hl), #0x00
;net.c:370: net_fcb.cr = 0;
	ld	de, #_net_fcb + 32
	xor	a, a
	ld	(de), a
;net.c:371: if ( bdos_open_file (&net_fcb) != 255 )
	push	bc
	push	de
	ld	hl, #_net_fcb
	push	hl
	call	_bdos_open_file
	pop	af
	pop	de
	pop	bc
	inc	l
	jr	Z,00102$
;net.c:373: net_fcb.ex = 0;
	xor	a, a
	ld	(bc), a
;net.c:374: net_fcb.cr = 0;
	xor	a, a
	ld	(de), a
;net.c:375: bdos_set_dma_address (net_dma);
	ld	hl, #_net_dma
	push	hl
	call	_bdos_set_dma_address
	pop	af
;net.c:376: net_pch = net_dma + 128;
	ld	hl, #_net_dma + 128
	ld	(_net_pch), hl
00102$:
;net.c:378: log_printf("IP address:  $");
	ld	hl, #___str_14
	push	hl
	call	_log_printf
	pop	af
;net.c:379: if ( net_pch != NULL ) net_parse_ip (ip);
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00104$
	ld	hl, #_ip
	push	hl
	call	_net_parse_ip
	pop	af
00104$:
;net.c:380: show_ip(ip);
	ld	hl, #_ip
	push	hl
	call	_show_ip
;net.c:381: log_printf("Net mask:    $");
	ld	hl, #___str_15
	ex	(sp),hl
	call	_log_printf
	pop	af
;net.c:382: if ( net_pch != NULL ) net_parse_ip (ip_subnet);
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00106$
	ld	hl, #_ip_subnet
	push	hl
	call	_net_parse_ip
	pop	af
00106$:
;net.c:383: show_ip(ip_subnet);
	ld	hl, #_ip_subnet
	push	hl
	call	_show_ip
;net.c:384: log_printf("Gateway:     $");
	ld	hl, #___str_16
	ex	(sp),hl
	call	_log_printf
	pop	af
;net.c:385: if ( net_pch != NULL ) net_parse_ip (ip_gateway);
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00108$
	ld	hl, #_ip_gateway
	push	hl
	call	_net_parse_ip
	pop	af
00108$:
;net.c:386: show_ip(ip_gateway);
	ld	hl, #_ip_gateway
	push	hl
	call	_show_ip
;net.c:387: log_printf("MAC address: $");
	ld	hl, #___str_17
	ex	(sp),hl
	call	_log_printf
	pop	af
;net.c:388: if ( net_pch != NULL ) net_parse_mac (mac);
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00110$
	ld	hl, #_mac
	push	hl
	call	_net_parse_mac
	pop	af
00110$:
;net.c:389: show_mac(mac);
	ld	hl, #_mac
	push	hl
	call	_show_mac
;net.c:391: log_printf("Wiznet port: $");
	ld	hl, #___str_18
	ex	(sp),hl
	call	_log_printf
	pop	af
;net.c:392: if ( net_pch != NULL ) net_parse_port (&wnaddr);
	ld	iy, #_net_pch
	ld	a, 1 (iy)
	or	a, 0 (iy)
	jr	Z,00112$
	ld	hl, #0
	add	hl, sp
	push	hl
	call	_net_parse_port
	pop	af
00112$:
;net.c:393: show_port (wnaddr);
	ld	a, -1 (ix)
	push	af
	inc	sp
	call	_show_port
	inc	sp
;net.c:394: wiz_config (wnaddr);
	ld	a, -1 (ix)
	push	af
	inc	sp
	call	_wiz_config
	inc	sp
;net.c:396: }
	inc	sp
	pop	ix
	ret
___str_14:
	.ascii "IP address:  $"
	.db 0x00
___str_15:
	.ascii "Net mask:    $"
	.db 0x00
___str_16:
	.ascii "Gateway:     $"
	.db 0x00
___str_17:
	.ascii "MAC address: $"
	.db 0x00
___str_18:
	.ascii "Wiznet port: $"
	.db 0x00
;net.c:400: static void outnibble(byte n)
;	---------------------------------
; Function outnibble
; ---------------------------------
_outnibble:
;net.c:402: nibble[0] = ( n < 10 ) ? ( n+'0' ) : ( -10+'A' );
	ld	iy, #2
	add	iy, sp
	ld	a, 0 (iy)
	sub	a, #0x0a
	jr	NC,00103$
	ld	a, 0 (iy)
	add	a, #0x30
	jr	00104$
00103$:
	ld	a, #0x37
00104$:
	ld	hl, #_nibble
	ld	(hl), a
;net.c:403: log_printf(nibble);
	push	hl
	call	_log_printf
	pop	af
;net.c:404: }
	ret
;net.c:405: static void outbyte(byte b)
;	---------------------------------
; Function outbyte
; ---------------------------------
_outbyte:
;net.c:407: outnibble(b>>4);
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	push	af
	inc	sp
	call	_outnibble
	inc	sp
;net.c:408: outnibble(b   );
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	_outnibble
	inc	sp
;net.c:409: }
	ret
;net.c:413: void net_alloc(SOCKET_ALLOC *sockalloc, NF nf, void *nfp)
;	---------------------------------
; Function net_alloc
; ---------------------------------
_net_alloc::
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:415: SOCKET *socket = list_remove_first(&net_sockets_free);
	ld	hl, #_net_sockets_free
	push	hl
	call	_list_remove_first
	pop	af
	ld	c, l
	ld	b, h
;net.c:419: sockalloc->socket = socket;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
;net.c:416: if ( socket != NULL )
	ld	a, b
	or	a, c
	jr	Z,00102$
;net.c:418: socket->state = SS_ALLOCATED;
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x01
;net.c:419: sockalloc->socket = socket;
	ld	hl, #0x0007
	add	hl, de
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:420: nf(nfp);
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	call	___sdcc_call_hl
	pop	af
	jr	00104$
00102$:
;net.c:424: sockalloc->fiber.nf  = nf;
	ld	c, e
	ld	b, d
	inc	bc
	inc	bc
	ld	a, 6 (ix)
	ld	(bc), a
	inc	bc
	ld	a, 7 (ix)
	ld	(bc), a
;net.c:425: sockalloc->fiber.nfp = nfp;
	inc	de
	inc	de
	inc	de
	inc	de
	ld	a, 8 (ix)
	ld	(de), a
	inc	de
	ld	a, 9 (ix)
	ld	(de), a
;net.c:426: list_add_last(&net_sockets_waiters, sockalloc);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	ld	hl, #_net_sockets_waiters
	push	hl
	call	_list_add_last
	pop	af
	pop	af
00104$:
;net.c:428: }
	pop	ix
	ret
;net.c:431: void net_free(SOCKET *socket)
;	---------------------------------
; Function net_free
; ---------------------------------
_net_free::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:433: SOCKET_ALLOC *sockalloc = list_remove_first(&net_sockets_waiters);
	ld	hl, #_net_sockets_waiters
	push	hl
	call	_list_remove_first
	pop	af
	ld	c, l
	ld	b, h
;net.c:434: if ( socket->state != SS_ALLOCATED )
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	ld	a, -2 (ix)
	add	a, #0x0e
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
	ld	a, (de)
	dec	a
	jr	Z,00102$
;net.c:435: net_fatal(socket, "net_free: socket ? not SS_ALLOCATED\r\n$");
	push	bc
	push	de
	ld	hl, #___str_19
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_net_fatal
	pop	af
	pop	af
	pop	de
	pop	bc
00102$:
;net.c:436: if ( sockalloc != NULL )
	ld	a, b
	or	a, c
	jr	Z,00104$
;net.c:438: sockalloc->socket = socket;
	ld	hl, #0x0007
	add	hl, bc
	ld	a, -2 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -1 (ix)
	ld	(hl), a
;net.c:439: fiber_enqueue((FIBER *) sockalloc);
	push	bc
	call	_fiber_enqueue
	pop	af
	jr	00106$
00104$:
;net.c:443: socket->state = SS_FREE;
	xor	a, a
	ld	(de), a
;net.c:444: list_add_first(&net_sockets_free, socket);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	ld	hl, #_net_sockets_free
	push	hl
	call	_list_add_first
	pop	af
	pop	af
00106$:
;net.c:446: }
	ld	sp, ix
	pop	ix
	ret
___str_19:
	.ascii "net_free: socket ? not SS_ALLOCATED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:450: word net_next_ephemeral_port(void)
;	---------------------------------
; Function net_next_ephemeral_port
; ---------------------------------
_net_next_ephemeral_port::
;net.c:452: return 0x8000 + (net_ephemeral++) % 0x7fff;
	ld	bc, (_net_ephemeral)
	ld	hl, (_net_ephemeral)
	inc	hl
	ld	(_net_ephemeral), hl
	ld	hl, #0x7fff
	push	hl
	push	bc
	call	__moduint
	pop	af
	pop	af
	ld	a, h
	add	a, #0x80
	ld	h, a
;net.c:453: }
	ret
;net.c:456: static void net_init_socket_as_tcp(word sra, word port)
;	---------------------------------
; Function net_init_socket_as_tcp
; ---------------------------------
_net_init_socket_as_tcp:
	push	ix
	ld	ix,#0
	add	ix,sp
00104$:
;net.c:470: wiz_write(sra+W5100_OFFSET_SOCKET_MR, W5100_SOCKET_MR_TCP);
	ld	a, #0x01
	push	af
	inc	sp
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
;net.c:471: wiz_write_word(sra+W5100_OFFSET_SOCKET_PORT0, port);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	hl, #0x0004
	add	hl, de
	push	de
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	push	bc
	push	hl
	call	_wiz_write_word
	pop	af
	pop	af
	pop	de
;net.c:472: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_OPEN);
	ld	c, e
	ld	b, d
	inc	bc
	push	bc
	push	de
	ld	a, #0x01
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
	pop	de
	pop	bc
;net.c:484: if ( wiz_read(sra+W5100_OFFSET_SOCKET_SR) == W5100_SOCKET_SR_SOCK_INIT )
	inc	de
	inc	de
	inc	de
	push	bc
	push	de
	call	_wiz_read
	pop	af
	ld	a, l
	pop	bc
	sub	a, #0x13
	jr	Z,00106$
;net.c:492: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_CLOSE);
	ld	a, #0x10
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
	jr	00104$
00106$:
;net.c:494: }
	pop	ix
	ret
;net.c:497: static void net_complete_op(SOCKET *socket)
;	---------------------------------
; Function net_complete_op
; ---------------------------------
_net_complete_op:
;net.c:507: fiber_enqueue (&socket->fiber_op);
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000f
	add	hl, bc
	push	hl
	call	_fiber_enqueue
	pop	af
;net.c:508: }
	ret
;net.c:512: static void net_connect_ok(SOCKET *socket)
;	---------------------------------
; Function net_connect_ok
; ---------------------------------
_net_connect_ok:
;net.c:514: socket->state = SS_ESTABLISHED;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x04
;net.c:515: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:516: }
	ret
;net.c:518: static void net_connect_error(SOCKET *socket)
;	---------------------------------
; Function net_connect_error
; ---------------------------------
_net_connect_error:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:520: word sra = socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;net.c:521: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_CLOSE);
	inc	de
	push	bc
	ld	a, #0x10
	push	af
	inc	sp
	push	de
	call	_wiz_write
	pop	af
	inc	sp
	pop	bc
;net.c:522: socket->state = SS_ALLOCATED;
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x01
;net.c:523: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:524: }
	pop	ix
	ret
;net.c:526: void net_connect(SOCKET *socket, const byte *ip, word port, NF nf, void *nfp)
;	---------------------------------
; Function net_connect
; ---------------------------------
_net_connect::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:528: word sra = socket->sra;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	l, e
	ld	h, d
	ld	bc, #0x0007
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;net.c:529: if ( socket->state != SS_ALLOCATED )
	ld	hl, #0x000e
	add	hl, de
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	dec	a
	jr	Z,00102$
;net.c:530: net_fatal(socket, "net_connect: socket ? not SS_ALLOCATED\r\n$");
	push	bc
	push	de
	ld	hl, #___str_20
	push	hl
	push	de
	call	_net_fatal
	pop	af
	pop	af
	pop	de
	pop	bc
00102$:
;net.c:531: if ( socket->fiber_op.queued ) fiber_dequeue (&socket->fiber_op);
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x0015
	add	hl, bc
	pop	bc
	ld	a, (hl)
	or	a, a
	jr	Z,00104$
	ld	hl, #0x000f
	add	hl, de
	push	bc
	push	de
	push	hl
	call	_fiber_dequeue
	pop	af
	pop	de
	pop	bc
00104$:
;net.c:540: socket->fiber_op.nf  = nf;
	ld	hl, #0x0011
	add	hl, de
	ld	a, 10 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 11 (ix)
	ld	(hl), a
;net.c:541: socket->fiber_op.nfp = nfp;
	ld	hl, #0x0013
	add	hl, de
	ld	a, 12 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 13 (ix)
	ld	(hl), a
;net.c:542: socket->consumed = 0;
	ld	hl, #0x0020
	add	hl, de
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;net.c:543: net_init_socket_as_tcp(sra, net_next_ephemeral_port());
	push	bc
	call	_net_next_ephemeral_port
	pop	bc
	push	bc
	push	hl
	push	bc
	call	_net_init_socket_as_tcp
	pop	af
	pop	af
	pop	bc
;net.c:544: wiz_write_n(sra+W5100_OFFSET_SOCKET_DIPR0, ip, 4);
	ld	hl, #0x000c
	add	hl, bc
	push	bc
	ld	de, #0x0004
	push	de
	ld	e, 6 (ix)
	ld	d, 7 (ix)
	push	de
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;net.c:545: wiz_write_word(sra+W5100_OFFSET_SOCKET_DPORT0, port);
	ld	hl, #0x0010
	add	hl, bc
	push	bc
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	push	de
	push	hl
	call	_wiz_write_word
	pop	af
	pop	af
	pop	bc
;net.c:546: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_CONNECT);
	inc	bc
	ld	a, #0x04
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
;net.c:547: socket->state = SS_CONNECT;
	pop	hl
	push	hl
	ld	(hl), #0x02
;net.c:548: }
	ld	sp, ix
	pop	ix
	ret
___str_20:
	.ascii "net_connect: socket ? not SS_ALLOCATED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:551: static void net_listen_ok(SOCKET *socket)
;	---------------------------------
; Function net_listen_ok
; ---------------------------------
_net_listen_ok:
;net.c:558: socket->state = SS_ESTABLISHED;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x04
;net.c:559: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:560: }
	ret
;net.c:562: void net_listen(SOCKET *socket, word port, NF nf, void *nfp)
;	---------------------------------
; Function net_listen
; ---------------------------------
_net_listen::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:564: word sra = socket->sra;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	l, e
	ld	h, d
	ld	bc, #0x0007
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;net.c:565: if ( socket->state != SS_ALLOCATED )
	ld	hl, #0x000e
	add	hl, de
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	dec	a
	jr	Z,00102$
;net.c:566: net_fatal(socket, "net_listen: socket ? not SS_ALLOCATED\r\n$");
	push	bc
	push	de
	ld	hl, #___str_21
	push	hl
	push	de
	call	_net_fatal
	pop	af
	pop	af
	pop	de
	pop	bc
00102$:
;net.c:567: if ( socket->fiber_op.queued ) fiber_dequeue (&socket->fiber_op);
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x0015
	add	hl, bc
	pop	bc
	ld	a, (hl)
	or	a, a
	jr	Z,00104$
	ld	hl, #0x000f
	add	hl, de
	push	bc
	push	de
	push	hl
	call	_fiber_dequeue
	pop	af
	pop	de
	pop	bc
00104$:
;net.c:576: socket->fiber_op.nf  = nf;
	ld	hl, #0x0011
	add	hl, de
	ld	a, 8 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 9 (ix)
	ld	(hl), a
;net.c:577: socket->fiber_op.nfp = nfp;
	ld	hl, #0x0013
	add	hl, de
	ld	a, 10 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 11 (ix)
	ld	(hl), a
;net.c:578: socket->consumed = 0;
	ld	hl, #0x0020
	add	hl, de
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;net.c:579: net_init_socket_as_tcp(sra, port);
	push	bc
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	push	bc
	call	_net_init_socket_as_tcp
	pop	af
	pop	af
	pop	bc
;net.c:580: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_LISTEN);
	inc	bc
	ld	a, #0x02
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
;net.c:581: socket->state = SS_LISTEN;
	pop	hl
	push	hl
	ld	(hl), #0x03
;net.c:582: }
	ld	sp, ix
	pop	ix
	ret
___str_21:
	.ascii "net_listen: socket ? not SS_ALLOCATED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:585: static void net_disconnect_ok(SOCKET *socket)
;	---------------------------------
; Function net_disconnect_ok
; ---------------------------------
_net_disconnect_ok:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:587: word sra = socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;net.c:588: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_CLOSE);
	inc	de
	push	bc
	ld	a, #0x10
	push	af
	inc	sp
	push	de
	call	_wiz_write
	pop	af
	inc	sp
	pop	bc
;net.c:589: socket->state = SS_ALLOCATED;
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x01
;net.c:590: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:591: }
	pop	ix
	ret
;net.c:593: void net_disconnect(SOCKET *socket, NF nf, void *nfp)
;	---------------------------------
; Function net_disconnect
; ---------------------------------
_net_disconnect::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:595: word sra = socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;net.c:596: if ( socket->state != SS_ESTABLISHED && socket->state != SS_ERROR )
	ld	hl, #0x000e
	add	hl, bc
	ex	de, hl
	ld	a, (de)
	cp	a, #0x04
	jr	Z,00102$
	sub	a, #0x07
	jr	Z,00102$
;net.c:597: net_fatal(socket, "net_disconnect: socket ? not SS_ESTABLISHED or SS_ERROR\r\n$");
	push	bc
	push	de
	ld	hl, #___str_22
	push	hl
	push	bc
	call	_net_fatal
	pop	af
	pop	af
	pop	de
	pop	bc
00102$:
;net.c:598: if ( socket->fiber_op.queued ) fiber_dequeue (&socket->fiber_op);
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x0015
	add	hl, bc
	pop	bc
	ld	a, (hl)
	or	a, a
	jr	Z,00105$
	ld	hl, #0x000f
	add	hl, bc
	push	bc
	push	de
	push	hl
	call	_fiber_dequeue
	pop	af
	pop	de
	pop	bc
00105$:
;net.c:607: socket->fiber_op.nf  = nf;
	ld	hl, #0x0011
	add	hl, bc
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;net.c:608: socket->fiber_op.nfp = nfp;
	ld	hl, #0x0013
	add	hl, bc
	ld	a, 8 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 9 (ix)
	ld	(hl), a
;net.c:609: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_DISCON);
	pop	bc
	push	bc
	inc	bc
	push	de
	ld	a, #0x08
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
	pop	de
;net.c:610: socket->state = SS_DISCONNECT;
	ld	a, #0x08
	ld	(de), a
;net.c:611: }
	ld	sp, ix
	pop	ix
	ret
___str_22:
	.ascii "net_disconnect: socket ? not SS_ESTABLISHED or SS_ERROR"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:615: static void net_send_chunk_error(SOCKET *socket)
;	---------------------------------
; Function net_send_chunk_error
; ---------------------------------
_net_send_chunk_error:
;net.c:617: socket->state = SS_ERROR;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x07
;net.c:618: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:619: }
	ret
;net.c:621: static void show_reg(const char *reg, word val)
;	---------------------------------
; Function show_reg
; ---------------------------------
_show_reg:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:625: log_printf (reg);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_log_printf
	pop	af
;net.c:626: h = val >> 12;
	ld	a, 7 (ix)
	rlca
	rlca
	rlca
	rlca
	and	a, #0x0f
	ld	d, a
;net.c:627: hex[0] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	bc, #_show_reg_hex_65536_203+0
	ld	e, d
	ld	a, d
	sub	a, #0x0a
	jr	NC,00103$
	ld	a, e
	add	a, #0x30
	jr	00104$
00103$:
	ld	a, e
	add	a, #0x37
00104$:
	ld	(bc), a
;net.c:628: h = ( val >> 8 ) & 0x0F;
	ld	a, 7 (ix)
	and	a, #0x0f
;net.c:629: hex[1] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	e, c
	ld	d, b
	inc	de
;net.c:627: hex[0] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	l, a
;net.c:629: hex[1] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	sub	a, #0x0a
	jr	NC,00105$
	ld	a, l
	add	a, #0x30
	jr	00106$
00105$:
	ld	a, l
	add	a, #0x37
00106$:
	ld	(de), a
;net.c:630: h = ( val >> 4 ) & 0x0F;
	ld	e, 6 (ix)
	ld	d, 7 (ix)
	srl	d
	rr	e
	srl	d
	rr	e
	srl	d
	rr	e
	srl	d
	rr	e
	ld	a, e
	and	a, #0x0f
;net.c:631: hex[2] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	e, c
	ld	d, b
	inc	de
	inc	de
;net.c:627: hex[0] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	l, a
;net.c:631: hex[2] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	sub	a, #0x0a
	jr	NC,00107$
	ld	a, l
	add	a, #0x30
	jr	00108$
00107$:
	ld	a, l
	add	a, #0x37
00108$:
	ld	(de), a
;net.c:632: h = val & 0x0F;
	ld	a, 6 (ix)
	and	a, #0x0f
	ld	d, a
;net.c:633: hex[3] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
;net.c:627: hex[0] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	e, d
;net.c:633: hex[3] = ( h < 10 ) ? h + '0' : h - 10 + 'A';
	ld	a, d
	sub	a, #0x0a
	jr	NC,00109$
	ld	a, e
	add	a, #0x30
	jr	00110$
00109$:
	ld	a, e
	add	a, #0x37
00110$:
	ld	(#(_show_reg_hex_65536_203 + 0x0003)),a
;net.c:634: log_printf (hex);
	push	bc
	call	_log_printf
	pop	af
;net.c:635: }
	pop	ix
	ret
;net.c:637: static void net_send_chunk(SOCKET *socket)
;	---------------------------------
; Function net_send_chunk
; ---------------------------------
_net_send_chunk:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-18
	add	hl, sp
	ld	sp, hl
;net.c:645: if ( socket->actual == socket->length )
	ld	a, 4 (ix)
	ld	-18 (ix), a
	ld	a, 5 (ix)
	ld	-17 (ix), a
	ld	a, -18 (ix)
	add	a, #0x1e
	ld	-6 (ix), a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, -18 (ix)
	add	a, #0x1a
	ld	-4 (ix), a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ex	de,hl
	cp	a, a
	sbc	hl, bc
	jr	NZ,00112$
;net.c:650: socket->state = SS_ESTABLISHED;
	ld	a, -18 (ix)
	add	a, #0x0e
	ld	l, a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	h, a
	ld	(hl), #0x04
;net.c:651: net_complete_op(socket);
	pop	hl
	push	hl
	push	hl
	call	_net_complete_op
	pop	af
	jp	00114$
00112$:
;net.c:658: word sra = socket->sra;
	pop	hl
	push	hl
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;net.c:659: word wr = wiz_read_word(sra+W5100_OFFSET_SOCKET_TX_WR0);
	ld	-16 (ix), c
	ld	-15 (ix), b
	ld	a, -16 (ix)
	add	a, #0x24
	ld	c, a
	ld	a, -15 (ix)
	adc	a, #0x00
	ld	b, a
	ld	-14 (ix), c
	ld	-13 (ix), b
	push	bc
	call	_wiz_read_word
	pop	af
;net.c:660: word wr_modulo = wr & 2047;
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	c, l
	ld	a, h
	and	a, #0x07
	ld	b, a
	ld	-2 (ix), c
	ld	-1 (ix), b
;net.c:661: word thisgo = socket->length - socket->actual;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, c
	sub	a, e
	ld	c, a
	ld	a, b
	sbc	a, d
	ld	b, a
	ld	-10 (ix), c
	ld	-9 (ix), b
;net.c:662: word fsr = wiz_read_word(sra+W5100_OFFSET_SOCKET_TX_FSR0);
	ld	a, -16 (ix)
	add	a, #0x20
	ld	c, a
	ld	a, -15 (ix)
	adc	a, #0x00
	ld	b, a
	push	bc
	call	_wiz_read_word
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
;net.c:663: if ( thisgo > 2048 ) thisgo = 2048;
	ld	c, -10 (ix)
	ld	b, -9 (ix)
	xor	a, a
	cp	a, c
	ld	a, #0x08
	sbc	a, b
	jr	NC,00102$
	ld	-10 (ix), #0x00
	ld	-9 (ix), #0x08
00102$:
;net.c:677: if ( fsr < thisgo )
	ld	a, -4 (ix)
	sub	a, -10 (ix)
	ld	a, -3 (ix)
	sbc	a, -9 (ix)
	jr	NC,00107$
;net.c:679: if ( ! socket->fiber_int.queued )
	pop	hl
	push	hl
	ld	de, #0x0006
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	NZ,00104$
;net.c:682: socket->fiber_int.nf     = (NF)net_send_chunk;
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	bc, #_net_send_chunk
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:683: socket->fiber_int.nfp    = socket;
	ld	a, -18 (ix)
	add	a, #0x04
	ld	l, a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	h, a
	ld	c, 4 (ix)
	ld	a, 5 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), a
;net.c:685: fiber_enqueue(&(socket->fiber_int));
	pop	hl
	push	hl
	push	hl
	call	_fiber_enqueue
	pop	af
	jr	00107$
00104$:
;net.c:692: net_fatal(socket, "net_send_chunk: socket ? no free space\r\n$");
	ld	hl, #___str_24
	ld	c, l
	ld	b, h
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_net_fatal
	pop	af
	pop	af
00107$:
;net.c:695: if ( wr_modulo + thisgo <= 2048 )
	ld	a, -2 (ix)
	add	a, -10 (ix)
	ld	e, a
	ld	a, -1 (ix)
	adc	a, -9 (ix)
	ld	d, a
;net.c:696: wiz_write_n(socket->tx_buf+wr_modulo, socket->send_ptr, thisgo);
	ld	a, -18 (ix)
	add	a, #0x16
	ld	c, a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, -18 (ix)
	add	a, #0x09
	ld	-8 (ix), a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	-7 (ix), a
;net.c:701: wiz_write_n(socket->tx_buf+wr_modulo, socket->send_ptr        , thisgo1);
	ld	a, (bc)
	ld	-6 (ix), a
	inc	bc
	ld	a, (bc)
	ld	-5 (ix), a
	dec	bc
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
;net.c:696: wiz_write_n(socket->tx_buf+wr_modulo, socket->send_ptr, thisgo);
	add	a, -2 (ix)
	ld	-4 (ix), a
	ld	a, h
	adc	a, -1 (ix)
	ld	-3 (ix), a
;net.c:695: if ( wr_modulo + thisgo <= 2048 )
	xor	a, a
	cp	a, e
	ld	a, #0x08
	sbc	a, d
	jr	C,00109$
;net.c:696: wiz_write_n(socket->tx_buf+wr_modulo, socket->send_ptr, thisgo);
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	jr	00110$
00109$:
;net.c:699: word thisgo1 = 2048-wr_modulo;
	xor	a, a
	sub	a, -2 (ix)
	ld	e, a
	ld	a, #0x08
	sbc	a, -1 (ix)
	ld	d, a
;net.c:700: word thisgo2 = thisgo-thisgo1;
	ld	a, -10 (ix)
	sub	a, e
	ld	l, a
	ld	a, -9 (ix)
	sbc	a, d
	ld	h, a
	ld	-2 (ix), l
	ld	-1 (ix), h
;net.c:701: wiz_write_n(socket->tx_buf+wr_modulo, socket->send_ptr        , thisgo1);
	push	bc
	push	de
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	de
;net.c:702: wiz_write_n(socket->tx_buf          , socket->send_ptr+thisgo1, thisgo2); 
	pop	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, de
	ex	de, hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
00110$:
;net.c:704: wiz_write_word(sra+W5100_OFFSET_SOCKET_TX_WR0, wr+thisgo);
	ld	a, -12 (ix)
	add	a, -10 (ix)
	ld	c, a
	ld	a, -11 (ix)
	adc	a, -9 (ix)
	ld	b, a
	push	bc
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	push	hl
	call	_wiz_write_word
	pop	af
	pop	af
;net.c:705: socket->thisgo = thisgo;
	ld	a, -18 (ix)
	add	a, #0x1c
	ld	c, a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, -10 (ix)
	ld	(bc), a
	inc	bc
	ld	a, -9 (ix)
	ld	(bc), a
;net.c:706: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_SEND);
	ld	c, -16 (ix)
	ld	b, -15 (ix)
	inc	bc
	ld	a, #0x20
	push	af
	inc	sp
	push	bc
	call	_wiz_write
	pop	af
	inc	sp
00114$:
;net.c:708: }
	ld	sp, ix
	pop	ix
	ret
___str_24:
	.ascii "net_send_chunk: socket ? no free space"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:710: static void net_send_chunk_ok(SOCKET *socket)
;	---------------------------------
; Function net_send_chunk_ok
; ---------------------------------
_net_send_chunk_ok:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;net.c:712: socket->send_ptr += socket->thisgo;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0016
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0x001c
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, de
	ex	de, hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
;net.c:713: socket->actual   += socket->thisgo;
	ld	hl, #0x001e
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, de
	ex	de, hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
;net.c:714: net_send_chunk(socket);
	push	bc
	call	_net_send_chunk
;net.c:715: }
	ld	sp,ix
	pop	ix
	ret
;net.c:717: void net_send(SOCKET *socket, const byte *ptr, size_t length, NF nf, void *nfp)
;	---------------------------------
; Function net_send
; ---------------------------------
_net_send::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:720: if (( socket->state != SS_ESTABLISHED ) && ( socket->state != SS_RECV ))
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x000e
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	cp	a, #0x04
	jr	Z,00102$
	sub	a, #0x06
	jr	Z,00102$
;net.c:721: net_fatal(socket, "net_send: socket ? not SS_ESTABLISHED\r\n$");
	push	bc
	ld	hl, #___str_25
	push	hl
	push	bc
	call	_net_fatal
	pop	af
	pop	af
	pop	bc
00102$:
;net.c:722: if ( socket->fiber_op.queued ) fiber_dequeue (&socket->fiber_op);
	ld	l, c
	ld	h, b
	ld	de, #0x0015
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	Z,00105$
	ld	hl, #0x000f
	add	hl, bc
	push	bc
	push	hl
	call	_fiber_dequeue
	pop	af
	pop	bc
00105$:
;net.c:731: socket->fiber_op.nf  = nf;
	ld	hl, #0x0011
	add	hl, bc
	ld	a, 10 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 11 (ix)
	ld	(hl), a
;net.c:732: socket->fiber_op.nfp = nfp;
	ld	hl, #0x0013
	add	hl, bc
	ld	a, 12 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 13 (ix)
	ld	(hl), a
;net.c:733: socket->send_ptr     = ptr;
	ld	hl, #0x0016
	add	hl, bc
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;net.c:734: socket->length       = length;
	ld	hl, #0x001a
	add	hl, bc
	ld	e, 8 (ix)
	ld	a, 9 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), a
;net.c:735: socket->actual       = 0;
	ld	hl, #0x001e
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;net.c:736: socket->state        = SS_SEND;
	pop	hl
	push	hl
	ld	(hl), #0x05
;net.c:737: net_send_chunk(socket);
	push	bc
	call	_net_send_chunk
;net.c:738: }
	ld	sp,ix
	pop	ix
	ret
___str_25:
	.ascii "net_send: socket ? not SS_ESTABLISHED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:741: static void net_recv_error(SOCKET *socket)
;	---------------------------------
; Function net_recv_error
; ---------------------------------
_net_recv_error:
;net.c:743: socket->state = SS_ERROR;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000e
	add	hl, bc
	ld	(hl), #0x07
;net.c:744: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
;net.c:745: }
	ret
;net.c:747: static void net_recv_consume(SOCKET *socket, word available)
;	---------------------------------
; Function net_recv_consume
; ---------------------------------
_net_recv_consume:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-20
	add	hl, sp
	ld	sp, hl
;net.c:749: word sra = socket->sra;
	ld	a, 4 (ix)
	ld	-20 (ix), a
	ld	a, 5 (ix)
	ld	-19 (ix), a
	pop	hl
	push	hl
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;net.c:750: word rd = wiz_read_word(sra+W5100_OFFSET_SOCKET_RX_RD0) + socket->consumed;
	ld	-18 (ix), c
	ld	-17 (ix), b
	ld	a, -18 (ix)
	add	a, #0x28
	ld	c, a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	b, a
	ld	-16 (ix), c
	ld	-15 (ix), b
	push	bc
	call	_wiz_read_word
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, -20 (ix)
	add	a, #0x20
	ld	-14 (ix), a
	ld	a, -19 (ix)
	adc	a, #0x00
	ld	-13 (ix), a
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, -4 (ix)
	add	a, -2 (ix)
	ld	c, a
	ld	a, -3 (ix)
	adc	a, -1 (ix)
	ld	b, a
;net.c:751: word rd_modulo = rd & 2047;
	ld	-12 (ix), c
	ld	-11 (ix), b
	ld	a, b
	and	a, #0x07
	ld	b, a
	ld	-10 (ix), c
	ld	-9 (ix), b
;net.c:752: word thisgo = socket->length;
	pop	hl
	push	hl
	ld	de, #0x001a
	add	hl, de
	ld	a, (hl)
	ld	-8 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-7 (ix), a
;net.c:759: if ( thisgo > available )
	ld	a, 6 (ix)
	sub	a, -8 (ix)
	ld	a, 7 (ix)
	sbc	a, -7 (ix)
	jr	NC,00102$
;net.c:760: thisgo = available;
	ld	a, 6 (ix)
	ld	-8 (ix), a
	ld	a, 7 (ix)
	ld	-7 (ix), a
00102$:
;net.c:764: if ( rd_modulo + thisgo <= 2048 )
	ld	a, -10 (ix)
	add	a, -8 (ix)
	ld	c, a
	ld	a, -9 (ix)
	adc	a, -7 (ix)
	ld	b, a
;net.c:765: wiz_read_n(socket->rx_buf+rd_modulo, socket->recv_ptr, thisgo);
	ld	a, -20 (ix)
	add	a, #0x18
	ld	-6 (ix), a
	ld	a, -19 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, -20 (ix)
	add	a, #0x0b
	ld	-4 (ix), a
	ld	a, -19 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
;net.c:764: if ( rd_modulo + thisgo <= 2048 )
	xor	a, a
	cp	a, c
	ld	a, #0x08
	sbc	a, b
	jr	C,00104$
;net.c:765: wiz_read_n(socket->rx_buf+rd_modulo, socket->recv_ptr, thisgo);
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	add	hl, de
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	push	de
	push	bc
	push	hl
	call	_wiz_read_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	jp	00105$
00104$:
;net.c:768: word thisgo1 = 2048-rd_modulo;
	xor	a, a
	sub	a, -10 (ix)
	ld	c, a
	ld	a, #0x08
	sbc	a, -9 (ix)
	ld	b, a
;net.c:769: word thisgo2 = thisgo-thisgo1;
	ld	a, -8 (ix)
	sub	a, c
	ld	e, a
	ld	a, -7 (ix)
	sbc	a, b
	ld	d, a
	ld	-2 (ix), e
	ld	-1 (ix), d
;net.c:770: show_reg ("thisgo1 = ", thisgo1);
	push	bc
	push	bc
	ld	hl, #___str_26
	push	hl
	call	_show_reg
	pop	af
	pop	af
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	hl, #___str_27
	push	hl
	call	_show_reg
	pop	af
	pop	af
	pop	bc
;net.c:772: wiz_read_n(socket->rx_buf+rd_modulo, socket->recv_ptr        , thisgo1);
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	add	a, -10 (ix)
	ld	l, a
	ld	a, h
	adc	a, -9 (ix)
	ld	h, a
	push	bc
	push	bc
	push	de
	push	hl
	call	_wiz_read_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;net.c:773: wiz_read_n(socket->rx_buf          , socket->recv_ptr+thisgo1, thisgo2); 
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ex	de, hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_wiz_read_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
00105$:
;net.c:775: if ( thisgo < available )
	ld	a, -8 (ix)
	sub	a, 6 (ix)
	ld	a, -7 (ix)
	sbc	a, 7 (ix)
	jr	NC,00107$
;net.c:776: socket->consumed += thisgo;
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, c
	add	a, -8 (ix)
	ld	c, a
	ld	a, b
	adc	a, -7 (ix)
	ld	b, a
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
	jr	00108$
00107$:
;net.c:779: socket->consumed = 0;
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;net.c:780: wiz_write_word(sra+W5100_OFFSET_SOCKET_RX_RD0, rd+thisgo);
	ld	a, -12 (ix)
	add	a, -8 (ix)
	ld	-2 (ix), a
	ld	a, -11 (ix)
	adc	a, -7 (ix)
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	push	hl
	call	_wiz_write_word
	pop	af
	pop	af
;net.c:781: wiz_write(sra+W5100_OFFSET_SOCKET_CR, W5100_SOCKET_CR_RECV); /* keep receiving */
	ld	a, -18 (ix)
	add	a, #0x01
	ld	-2 (ix), a
	ld	a, -17 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	a, #0x40
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
00108$:
;net.c:783: socket->actual = thisgo;
	ld	a, -20 (ix)
	add	a, #0x1e
	ld	c, a
	ld	a, -19 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, -8 (ix)
	ld	(bc), a
	inc	bc
	ld	a, -7 (ix)
	ld	(bc), a
;net.c:784: socket->state  = SS_ESTABLISHED;
	ld	a, -20 (ix)
	add	a, #0x0e
	ld	l, a
	ld	a, -19 (ix)
	adc	a, #0x00
	ld	h, a
	ld	(hl), #0x04
;net.c:785: net_complete_op(socket);
	pop	hl
	push	hl
	push	hl
	call	_net_complete_op
;net.c:786: }
	ld	sp,ix
	pop	ix
	ret
___str_26:
	.ascii "thisgo1 = "
	.db 0x00
___str_27:
	.ascii "thisgo2 = "
	.db 0x00
;net.c:788: static void net_recv_more(SOCKET *socket)
;	---------------------------------
; Function net_recv_more
; ---------------------------------
_net_recv_more:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:794: word sra = socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;net.c:795: word available = wiz_read_word(sra+W5100_OFFSET_SOCKET_RX_RSR0) - socket->consumed;
	ld	hl, #0x0026
	add	hl, de
	push	bc
	push	hl
	call	_wiz_read_word
	pop	af
	ex	de,hl
	pop	bc
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x0020
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	a, e
	sub	a, l
	ld	e, a
	ld	a, d
	sbc	a, h
	ld	d, a
	ld	l, e
;net.c:796: if ( available > 0 )
	ld	a,d
	ld	h,a
	or	a, e
	jr	Z,00103$
;net.c:797: net_recv_consume(socket, available);
	push	hl
	push	bc
	call	_net_recv_consume
	pop	af
	pop	af
00103$:
;net.c:798: }
	pop	ix
	ret
;net.c:800: void net_recv(SOCKET *socket, byte *ptr, size_t length, NF nf, void *nfp)
;	---------------------------------
; Function net_recv
; ---------------------------------
_net_recv::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:809: if ( socket->state != SS_ESTABLISHED )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x000e
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	sub	a, #0x04
	jr	Z,00102$
;net.c:810: net_fatal(socket, "net_recv: socket ? not SS_ESTABLISHED\r\n$");
	push	bc
	ld	hl, #___str_28
	push	hl
	push	bc
	call	_net_fatal
	pop	af
	pop	af
	pop	bc
00102$:
;net.c:811: if ( socket->fiber_op.queued ) fiber_dequeue (&socket->fiber_op);
	ld	l, c
	ld	h, b
	ld	de, #0x0015
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	Z,00104$
	ld	hl, #0x000f
	add	hl, bc
	push	bc
	push	hl
	call	_fiber_dequeue
	pop	af
	pop	bc
00104$:
;net.c:820: socket->fiber_op.nf  = nf;
	ld	hl, #0x0011
	add	hl, bc
	ld	a, 10 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 11 (ix)
	ld	(hl), a
;net.c:821: socket->fiber_op.nfp = nfp;
	ld	hl, #0x0013
	add	hl, bc
	ld	a, 12 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 13 (ix)
	ld	(hl), a
;net.c:822: socket->recv_ptr     = ptr;
	ld	hl, #0x0018
	add	hl, bc
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;net.c:823: socket->length       = length;
	ld	hl, #0x001a
	add	hl, bc
	ld	e, 8 (ix)
	ld	a, 9 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), a
;net.c:824: socket->actual       = 0;
	ld	hl, #0x001e
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;net.c:825: if ( length == 0 )
	ld	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00106$
;net.c:826: net_complete_op(socket);
	push	bc
	call	_net_complete_op
	pop	af
	jr	00108$
00106$:
;net.c:829: socket->state = SS_RECV;
	pop	hl
	push	hl
	ld	(hl), #0x06
;net.c:830: net_recv_more(socket);
	push	bc
	call	_net_recv_more
	pop	af
00108$:
;net.c:832: }
	ld	sp, ix
	pop	ix
	ret
___str_28:
	.ascii "net_recv: socket ? not SS_ESTABLISHED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:837: static void net_bad_interrupt (SOCKET *socket, byte ir, char *psState)
;	---------------------------------
; Function net_bad_interrupt
; ---------------------------------
_net_bad_interrupt:
	push	ix
	ld	ix,#0
	add	ix,sp
;net.c:839: log_printf ("net_bad_interrupt: socket $");
	ld	hl, #___str_29
	push	hl
	call	_log_printf
	pop	af
;net.c:840: log_uint ((socket->sra - W5100_ADDR_SOCKET) >> 8);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	add	a, #0x00
	ld	a, d
	adc	a, #0xfc
	ld	h, a
	ld	d, #0x00
	ld	e, h
	push	bc
	push	de
	call	_log_uint
	ld	hl, #___str_30
	ex	(sp),hl
	call	_log_printf
	pop	af
	ld	a, 6 (ix)
	push	af
	inc	sp
	call	_log_byte
	inc	sp
	ld	hl, #___str_31
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;net.c:844: net_fatal (socket, psState);
	ld	l, 7 (ix)
	ld	h, 8 (ix)
	push	hl
	push	bc
	call	_net_fatal
	pop	af
	pop	af
;net.c:845: }
	pop	ix
	ret
___str_29:
	.ascii "net_bad_interrupt: socket $"
	.db 0x00
___str_30:
	.ascii " unexpected interrupt $"
	.db 0x00
___str_31:
	.ascii " in $"
	.db 0x00
;net.c:847: static void net_interrupt(SOCKET *socket)
;	---------------------------------
; Function net_interrupt
; ---------------------------------
_net_interrupt:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;net.c:849: word sra = socket->sra;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;net.c:850: byte ir = wiz_read(sra+W5100_OFFSET_SOCKET_IR);
	inc	de
	inc	de
	inc	sp
	inc	sp
	push	de
	push	bc
	pop	de
	pop	hl
	push	hl
	push	de
	push	hl
	call	_wiz_read
	pop	af
	ld	a, l
	pop	bc
	ld	e, a
;net.c:876: switch ( socket->state )
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	d, (hl)
	ld	a, #0x08
	sub	a, d
	jp	C, 00137$
	push	de
	ld	e, d
	ld	d, #0x00
	ld	hl, #00201$
	add	hl, de
	add	hl, de
	add	hl, de
	pop	de
	jp	(hl)
00201$:
	jp	00137$
	jp	00137$
	jp	00101$
	jp	00108$
	jp	00114$
	jp	00117$
	jp	00126$
	jp	00133$
	jp	00134$
;net.c:878: case SS_CONNECT:
00101$:
;net.c:882: if ( ir & W5100_SOCKET_IR_CON )
	bit	0, e
	jr	Z,00106$
;net.c:884: wiz_write(sra+W5100_OFFSET_SOCKET_IR, W5100_SOCKET_IR_CON); /* clear it */
	push	bc
	ld	a, #0x01
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_connect_ok
	pop	af
	jp	00139$
00106$:
;net.c:887: else if ( ir & (W5100_SOCKET_IR_DISCON|W5100_SOCKET_IR_TIMEOUT) )
	ld	a, e
	and	a, #0x0a
	jr	Z,00103$
;net.c:889: wiz_write(sra+W5100_OFFSET_SOCKET_IR, ir); /* clear it */
	push	bc
	ld	a, e
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_connect_error
	pop	af
	jp	00139$
00103$:
;net.c:894: net_bad_interrupt (socket, ir, "SS_CONNECT\r\n$");
	ld	hl, #___str_32
	push	hl
	ld	a, e
	push	af
	inc	sp
	push	bc
	call	_net_bad_interrupt
	pop	af
	pop	af
	inc	sp
;net.c:896: break;
	jp	00139$
;net.c:897: case SS_LISTEN:
00108$:
;net.c:901: if ( ir & W5100_SOCKET_IR_CON )
	bit	0, e
	jr	Z,00112$
;net.c:903: wiz_write(sra+W5100_OFFSET_SOCKET_IR, W5100_SOCKET_IR_CON); /* clear it */
	push	bc
	ld	a, #0x01
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_listen_ok
	pop	af
	jp	00139$
00112$:
;net.c:906: else if ( ir & ~W5100_SOCKET_IR_RECV )
	ld	a, e
	and	a, #0xfb
	jp	Z,00139$
;net.c:908: net_bad_interrupt (socket, ir, "SS_LISTEN\r\n$");
	ld	hl, #___str_33
	push	hl
	ld	a, e
	push	af
	inc	sp
	push	bc
	call	_net_bad_interrupt
	pop	af
	pop	af
	inc	sp
;net.c:910: break;
	jp	00139$
;net.c:911: case SS_ESTABLISHED:
00114$:
;net.c:915: if ( ir & ~(W5100_SOCKET_IR_RECV | W5100_SOCKET_IR_DISCON))
	ld	a, e
	and	a, #0xf9
	jp	Z,00139$
;net.c:916: net_bad_interrupt (socket, ir, "SS_ESTABLISHED\r\n$");
	ld	hl, #___str_34
	push	hl
	ld	a, e
	push	af
	inc	sp
	push	bc
	call	_net_bad_interrupt
	pop	af
	pop	af
	inc	sp
;net.c:917: break;
	jp	00139$
;net.c:918: case SS_SEND:
00117$:
;net.c:922: if ( ir & W5100_SOCKET_IR_SEND_OK )
	bit	4, e
	jr	Z,00124$
;net.c:924: wiz_write(sra+W5100_OFFSET_SOCKET_IR, W5100_SOCKET_IR_SEND_OK); /* clear it */
	push	bc
	ld	a, #0x10
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_send_chunk_ok
	pop	af
	jp	00139$
00124$:
;net.c:927: else if ( ir & (W5100_SOCKET_IR_DISCON|W5100_SOCKET_IR_TIMEOUT) )
	ld	a, e
	and	a, #0x0a
	jr	Z,00121$
;net.c:929: wiz_write(sra+W5100_OFFSET_SOCKET_IR, ir); /* clear it */
	push	bc
	ld	a, e
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_send_chunk_error
	pop	af
	jp	00139$
00121$:
;net.c:932: else if ( ir & ~W5100_SOCKET_IR_RECV )
	ld	a, e
	and	a, #0xfb
	jp	Z,00139$
;net.c:934: net_bad_interrupt (socket, ir, "SS_SEND\r\n$");
	ld	hl, #___str_35
	push	hl
	ld	a, e
	push	af
	inc	sp
	push	bc
	call	_net_bad_interrupt
	pop	af
	pop	af
	inc	sp
;net.c:936: break;
	jp	00139$
;net.c:937: case SS_RECV:
00126$:
;net.c:941: if ( ir & W5100_SOCKET_IR_RECV )
	bit	2, e
	jr	Z,00131$
;net.c:943: wiz_write(sra+W5100_OFFSET_SOCKET_IR, W5100_SOCKET_IR_RECV); /* clear it */
	push	bc
	ld	a, #0x04
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_recv_more
	pop	af
	jr	00139$
00131$:
;net.c:946: else if ( ir & (W5100_SOCKET_IR_DISCON|W5100_SOCKET_IR_TIMEOUT) )
	ld	a, e
	and	a, #0x0a
	jr	Z,00128$
;net.c:948: wiz_write(sra+W5100_OFFSET_SOCKET_IR, ir); /* clear it */
	push	bc
	ld	a, e
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_recv_error
	pop	af
	jr	00139$
00128$:
;net.c:953: net_bad_interrupt (socket, ir, "SS_RECV\r\n$");
	ld	hl, #___str_36
	push	hl
	ld	a, e
	push	af
	inc	sp
	push	bc
	call	_net_bad_interrupt
	pop	af
	pop	af
	inc	sp
;net.c:955: break;
	jr	00139$
;net.c:956: case SS_ERROR:
00133$:
;net.c:960: wiz_write(sra+W5100_OFFSET_SOCKET_IR, ir); /* clear it */
	ld	a, e
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
;net.c:961: break;
	jr	00139$
;net.c:962: case SS_DISCONNECT:
00134$:
;net.c:966: if ( ir & (W5100_SOCKET_IR_DISCON|W5100_SOCKET_IR_TIMEOUT) )
	ld	a, e
	and	a, #0x0a
	jr	Z,00139$
;net.c:968: wiz_write(sra+W5100_OFFSET_SOCKET_IR, ir); /* clear it */
	push	bc
	ld	a, e
	push	af
	inc	sp
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
	call	_net_disconnect_ok
	pop	af
;net.c:971: break;
	jr	00139$
;net.c:972: default:
00137$:
;net.c:976: net_fatal(socket, "net_interrupt: socket ? unexpected interrupt\r\n$");
	ld	hl, #___str_37
	push	hl
	push	bc
	call	_net_fatal
	pop	af
	pop	af
;net.c:978: }
00139$:
;net.c:979: }
	ld	sp, ix
	pop	ix
	ret
___str_32:
	.ascii "SS_CONNECT"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_33:
	.ascii "SS_LISTEN"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_34:
	.ascii "SS_ESTABLISHED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_35:
	.ascii "SS_SEND"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_36:
	.ascii "SS_RECV"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_37:
	.ascii "net_interrupt: socket ? unexpected interrupt"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:982: void net_handle_interrupts(void)
;	---------------------------------
; Function net_handle_interrupts
; ---------------------------------
_net_handle_interrupts::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;net.c:984: byte ir = wiz_read(W5100_ADDR_REG_IR);
	ld	hl, #0x0015
	push	hl
	call	_wiz_read
	pop	af
	ld	-1 (ix), l
;net.c:994: if ( ir & W5100_IR_CONFLICT )
	bit	7, -1 (ix)
	jr	Z,00115$
;net.c:996: log_printf("net_handle_interrupts: IP Conflict\r\n$");
	ld	hl, #___str_38
	push	hl
	call	_log_printf
;net.c:997: wiz_write(W5100_ADDR_REG_IR, W5100_IR_CONFLICT);
	ld	h,#0x80
	ex	(sp),hl
	inc	sp
	ld	hl, #0x0015
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
;net.c:999: for ( i = 0; i < N_SOCKETS; i++ )
00115$:
	ld	c, #0x00
00108$:
;net.c:1001: SOCKET *socket = &(net_sockets[i]);
	ld	b, #0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ex	de, hl
	ld	hl, #_net_sockets
	add	hl, de
	ex	de, hl
;net.c:1002: if ( ir & socket->int_bit )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000d
	add	hl, bc
	pop	bc
	ld	a, (hl)
	and	a, -1 (ix)
	or	a, a
	jr	Z,00109$
;net.c:1004: if ( ! socket->fiber_int.queued )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x0006
	add	hl, bc
	pop	bc
	ld	a, (hl)
	or	a, a
	jr	NZ,00109$
;net.c:1006: socket->fiber_int.nf     = (NF)net_interrupt;
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	(hl), #<(_net_interrupt)
	ld	a, #>(_net_interrupt)
	inc	hl
	ld	(hl), a
;net.c:1007: socket->fiber_int.nfp    = socket;
	ld	hl, #0x0004
	add	hl, de
	ld	b, e
	ld	a, d
	ld	(hl), b
	inc	hl
	ld	(hl), a
;net.c:1009: fiber_enqueue(&(socket->fiber_int));
	push	bc
	push	de
	call	_fiber_enqueue
	pop	af
	pop	bc
00109$:
;net.c:999: for ( i = 0; i < N_SOCKETS; i++ )
	inc	c
	ld	a, c
	sub	a, #0x04
	jr	C,00108$
;net.c:1012: }
	inc	sp
	pop	ix
	ret
___str_38:
	.ascii "net_handle_interrupts: IP Conflict"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;net.c:1016: void net_init(void)
;	---------------------------------
; Function net_init
; ---------------------------------
_net_init::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;net.c:1019: net_config();
	call	_net_config
;net.c:1020: list_init(&net_sockets_free);
	ld	hl, #_net_sockets_free
	push	hl
	call	_list_init
;net.c:1021: list_init(&net_sockets_waiters);
	ld	hl, #_net_sockets_waiters
	ex	(sp),hl
	call	_list_init
	pop	af
;net.c:1022: for ( i = 0; i < N_SOCKETS; i++ )
	xor	a, a
	ld	-1 (ix), a
00102$:
;net.c:1024: SOCKET *socket = &(net_sockets[i]);
	ld	c, -1 (ix)
	ld	b, #0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ex	de, hl
	ld	hl, #_net_sockets
	add	hl, de
	ex	de, hl
;net.c:1025: socket->fiber_int.nf     = (NF)net_interrupt;
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	bc, #_net_interrupt
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:1026: socket->fiber_int.nfp    = socket;
	ld	hl, #0x0004
	add	hl, de
	inc	sp
	inc	sp
	push	de
	ld	a, -5 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -4 (ix)
	ld	(hl), a
;net.c:1027: socket->fiber_int.queued = 0;
	ld	hl, #0x0006
	add	hl, de
	ld	(hl), #0x00
;net.c:1029: socket->fiber_op.queued  = 0;
	ld	hl, #0x0015
	add	hl, de
	ld	(hl), #0x00
;net.c:1030: socket->sra              = W5100_ADDR_SOCKET + (i<< 8);
	ld	hl, #0x0007
	add	hl, de
	ld	a, -1 (ix)
	ld	-3 (ix), a
	xor	a, a
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	c, #0x00
	add	a, #0x04
	ld	b, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:1031: socket->tx_buf           = W5100_ADDR_TX     + (i<<11);
	ld	hl, #0x0009
	add	hl, de
	ld	a, -3 (ix)
	add	a, a
	add	a, a
	add	a, a
	ld	-2 (ix), a
	ld	-3 (ix), #0x00
	ld	c, #0x00
	ld	a, -2 (ix)
	add	a, #0x40
	ld	b, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:1032: socket->rx_buf           = W5100_ADDR_RX     + (i<<11);
	ld	hl, #0x000b
	add	hl, de
	ld	c, -3 (ix)
	ld	a, -2 (ix)
	add	a, #0x60
	ld	b, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
;net.c:1033: socket->int_bit          = (0x01<<i); /* per W5100_IR_Sx_INT */
	ld	hl, #0x000d
	add	hl, de
	ld	b, -1 (ix)
	ld	c, #0x01
	inc	b
	jr	00118$
00117$:
	sla	c
00118$:
	djnz	00117$
	ld	(hl), c
;net.c:1034: socket->state            = SS_FREE;
	ld	hl, #0x000e
	add	hl, de
	ld	(hl), #0x00
;net.c:1035: list_add_last(&net_sockets_free, socket);
	pop	hl
	push	hl
	push	hl
	ld	hl, #_net_sockets_free
	push	hl
	call	_list_add_last
	pop	af
	pop	af
;net.c:1022: for ( i = 0; i < N_SOCKETS; i++ )
	inc	-1 (ix)
	ld	a, -1 (ix)
	sub	a, #0x04
	jp	C, 00102$
;net.c:1038: wiz_reset();
	call	_wiz_reset
;net.c:1040: wiz_write(W5100_ADDR_REG_IMR, 0x00); /* turn off all interrupts */
	xor	a, a
	push	af
	inc	sp
	ld	hl, #0x0016
	push	hl
	call	_wiz_write
;net.c:1042: wiz_write_n(W5100_ADDR_REG_SUBR0, ip_subnet, 4);
	inc	sp
	ld	hl,#0x0004
	ex	(sp),hl
	ld	hl, #_ip_subnet
	push	hl
	ld	hl, #0x0005
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;net.c:1044: wiz_write_n(W5100_ADDR_REG_SIPR0, ip, 4);
	ld	hl, #0x0004
	push	hl
	ld	hl, #_ip
	push	hl
	ld	hl, #0x000f
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;net.c:1046: wiz_write_n(W5100_ADDR_REG_GAR0 , ip_gateway, 4);
	ld	hl, #0x0004
	push	hl
	ld	hl, #_ip_gateway
	push	hl
	ld	hl, #0x0001
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;net.c:1048: wiz_write_n(W5100_ADDR_REG_SHAR0, mac, 6);
	ld	hl, #0x0006
	push	hl
	ld	hl, #_mac
	push	hl
	ld	hl, #0x0009
	push	hl
	call	_wiz_write_n
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;net.c:1050: wiz_write_word(W5100_ADDR_REG_RTR0, 2000);
	ld	hl, #0x07d0
	push	hl
	ld	hl, #0x0017
	push	hl
	call	_wiz_write_word
	pop	af
;net.c:1052: wiz_write(W5100_ADDR_REG_RCR, 10); /* retries */
	ld	h,#0x0a
	ex	(sp),hl
	inc	sp
	ld	hl, #0x0019
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
;net.c:1054: wiz_write(W5100_ADDR_REG_RMSR, 0x55); /* 2KB each for sockets 0,1,2,3 */
	ld	a, #0x55
	push	af
	inc	sp
	ld	hl, #0x001a
	push	hl
	call	_wiz_write
	pop	af
	inc	sp
;net.c:1056: wiz_write(W5100_ADDR_REG_TMSR, 0x55); /* 2KB each for sockets 0,1,2,3 */
	ld	a, #0x55
	push	af
	inc	sp
	ld	hl, #0x001b
	push	hl
	call	_wiz_write
;net.c:1057: }
	ld	sp,ix
	pop	ix
	ret
	.area _CODE
___str_39:
	.ascii " SS_FREE"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_40:
	.ascii " SS_ALLOCATED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_41:
	.ascii " SS_CONNECT"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_42:
	.ascii " SS_LISTEN"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_43:
	.ascii " SS_ESTABLISHED"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_44:
	.ascii " SS_SEND"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_45:
	.ascii " SS_RECV"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_46:
	.ascii " SS_ERROR"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_47:
	.ascii " SS_DISCONNECT"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _INITIALIZER
__xinit__ip_subnet:
	.db #0xff	; 255
	.db #0xff	; 255
	.db #0xff	; 255
	.db #0x00	; 0
__xinit__ip:
	.db #0xc0	; 192
	.db #0xa8	; 168
	.db #0x01	; 1
	.db #0x7b	; 123
__xinit__ip_gateway:
	.db #0xc0	; 192
	.db #0xa8	; 168
	.db #0x01	; 1
	.db #0x01	; 1
__xinit__mac:
	.db #0x00	; 0
	.db #0x08	; 8
	.db #0xdc	; 220
	.db #0x4e	; 78	'N'
	.db #0x46	; 70	'F'
	.db #0x58	; 88	'X'
__xinit__net_pch:
	.dw #0x0000
__xinit__net_ephemeral:
	.dw #0x0000
__xinit__psStatus:
	.dw ___str_39
	.dw ___str_40
	.dw ___str_41
	.dw ___str_42
	.dw ___str_43
	.dw ___str_44
	.dw ___str_45
	.dw ___str_46
	.dw ___str_47
__xinit__nibble:
	.ascii "_$"
	.db 0x00
	.area _CABS (ABS)
