;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module nfx
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _parse
	.globl _quit
	.globl _log_close
	.globl _log_open
	.globl _log_fatal
	.globl _http_init
	.globl _http_start
	.globl _chargen_init
	.globl _chargen_start
	.globl _echo_init
	.globl _echo_start
	.globl _net_handle_interrupts
	.globl _net_init
	.globl _bdos_printf
	.globl _bdos_inkey
	.globl _bdos_exit
	.globl _fiber_drain
	.globl _fiber_enqueue
	.globl _fiber_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_echo:
	.ds 265
_chargen:
	.ds 84
_http1:
	.ds 686
_http2:
	.ds 686
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_first_fiber:
	.ds 7
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;nfx.c:36: static void first(void *nfp)
;	---------------------------------
; Function first
; ---------------------------------
_first:
;nfx.c:39: echo_start(&echo);
	ld	hl, #_echo
	push	hl
	call	_echo_start
;nfx.c:40: chargen_start(&chargen);
	ld	hl, #_chargen
	ex	(sp),hl
	call	_chargen_start
	pop	af
;nfx.c:41: http1.allow_post   = TRUE;
	ld	hl, #0x0001
	ld	((_http1 + 0x02a3)), hl
;nfx.c:42: http1.allow_delete = TRUE;
	ld	l, #0x01
	ld	((_http1 + 0x02a5)), hl
;nfx.c:43: http_start(&http1);
	ld	hl, #_http1
	push	hl
	call	_http_start
	pop	af
;nfx.c:44: http2.allow_post   = TRUE;
	ld	hl, #0x0001
	ld	((_http2 + 0x02a3)), hl
;nfx.c:45: http2.allow_delete = TRUE;
	ld	l, #0x01
	ld	((_http2 + 0x02a5)), hl
;nfx.c:46: http_start(&http2);
	ld	hl, #_http2
	push	hl
	call	_http_start
	pop	af
;nfx.c:47: }
	ret
;nfx.c:51: void quit(void)
;	---------------------------------
; Function quit
; ---------------------------------
_quit::
;nfx.c:53: log_close();
	call	_log_close
;nfx.c:54: bdos_exit();
;nfx.c:55: }
	jp	_bdos_exit
;nfx.c:57: void parse(void)
;	---------------------------------
; Function parse
; ---------------------------------
_parse::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;nfx.c:60: const char *cend = ctail + ctail[0] + 1;
	ld	hl,#0x0080
	ld	c,(hl)
	ld	b, #0x00
	add	hl, bc
	inc	hl
	ld	-4 (ix), l
	ld	-3 (ix), h
;nfx.c:61: const char *ps = ctail + 1;
	ld	-2 (ix), #0x81
	xor	a, a
	ld	-1 (ix), a
;nfx.c:62: while ( ps < cend )
00111$:
	ld	a, -2 (ix)
	sub	a, -4 (ix)
	ld	a, -1 (ix)
	sbc	a, -3 (ix)
	jp	NC, 00114$
;nfx.c:64: if ( *ps == ' ' )
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
;nfx.c:66: ++ps;
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	inc	bc
;nfx.c:64: if ( *ps == ' ' )
	cp	a, #0x20
	jr	NZ,00109$
;nfx.c:66: ++ps;
	ld	-2 (ix), c
	ld	-1 (ix), b
	jr	00111$
00109$:
;nfx.c:68: else if ( *ps == '-' )
	sub	a, #0x2d
	jr	NZ,00106$
;nfx.c:70: ++ps;
;nfx.c:71: switch (*ps)
	ld	-2 (ix), c
	ld	-1 (ix), b
	ld	l, c
	ld	h, b
	ld	a, (hl)
	ld	-5 (ix), a
	sub	a, #0x4c
	jr	Z,00102$
	ld	a, -5 (ix)
	sub	a, #0x6c
	jr	NZ,00103$
;nfx.c:74: case 'l':
00102$:
;nfx.c:75: ++ps;
	ld	a, -2 (ix)
	add	a, #0x01
	ld	-6 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
;nfx.c:76: ps = log_open (ps, cend);
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	c, l
	ld	b, h
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_log_open
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
;nfx.c:77: break;
	jr	00111$
;nfx.c:78: default:
00103$:
;nfx.c:79: log_fatal ("Invalid parameter\r\n$");
	ld	hl, #___str_0
	push	hl
	call	_log_fatal
	pop	af
;nfx.c:80: }
	jr	00111$
00106$:
;nfx.c:84: ps = log_open (ps, cend);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_log_open
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	jp	00111$
00114$:
;nfx.c:87: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "Invalid parameter"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;nfx.c:89: int main(void)
;	---------------------------------
; Function main
; ---------------------------------
_main::
;nfx.c:91: bdos_printf("NFX test" VERSION "\r\n$");
	ld	hl, #___str_1
	push	hl
	call	_bdos_printf
	pop	af
;nfx.c:92: parse();
	call	_parse
;nfx.c:93: fiber_init();
	call	_fiber_init
;nfx.c:96: net_init();
	call	_net_init
;nfx.c:97: echo_init();
	call	_echo_init
;nfx.c:98: chargen_init();
	call	_chargen_init
;nfx.c:99: http_init();
	call	_http_init
;nfx.c:100: fiber_enqueue(&first_fiber);
	ld	hl, #_first_fiber
	push	hl
	call	_fiber_enqueue
	pop	af
00105$:
;nfx.c:103: if ( bdos_inkey() == 'q' ) quit();
	call	_bdos_inkey
	ld	a, l
	sub	a, #0x71
	jr	NZ,00102$
	call	_quit
00102$:
;nfx.c:104: net_handle_interrupts();
	call	_net_handle_interrupts
;nfx.c:106: fiber_drain();
	call	_fiber_drain
;nfx.c:108: }
	jr	00105$
___str_1:
	.ascii "NFX testv230307"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
__xinit__first_fiber:
	.dw #0x0000
	.dw _first
	.dw #0x0000
	.db #0x00	; 0
	.area _CABS (ABS)
