;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module chargen
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _log_printf
	.globl _net_send
	.globl _net_disconnect
	.globl _net_listen
	.globl _net_alloc
	.globl _chargen_start
	.globl _chargen_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;chargen.c:23: static byte chargen_next_char(byte b)
;	---------------------------------
; Function chargen_next_char
; ---------------------------------
_chargen_next_char:
;chargen.c:25: return b == '}' ? ' ' : b+1;
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	sub	a, #0x7d
	jr	NZ,00103$
	ld	hl, #0x0020
	ret
00103$:
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	inc	a
	ld	l, a
	rla
	sbc	a, a
;chargen.c:26: }
	ret
;chargen.c:33: static void chargen_disconnect(CHARGEN *chargen)
;	---------------------------------
; Function chargen_disconnect
; ---------------------------------
_chargen_disconnect:
	push	ix
	ld	ix,#0
	add	ix,sp
;chargen.c:35: SOCKET *socket = chargen->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;chargen.c:36: log_printf("chargen_disconnect:\r\n$");
	push	bc
	ld	hl, #___str_0
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;chargen.c:37: net_disconnect(socket, (NF)chargen_listen, chargen);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_chargen_listen
	push	hl
	push	de
	push	bc
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;chargen.c:38: }		
	pop	ix
	ret
___str_0:
	.ascii "chargen_disconnect:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;chargen.c:41: static void chargen_sent(CHARGEN *chargen)
;	---------------------------------
; Function chargen_sent
; ---------------------------------
_chargen_sent:
	push	ix
	ld	ix,#0
	add	ix,sp
;chargen.c:43: SOCKET *socket = chargen->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	h, (hl)
;chargen.c:44: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00102$
;chargen.c:45: chargen_disconnect(chargen);
	push	bc
	call	_chargen_disconnect
	pop	af
	jr	00104$
00102$:
;chargen.c:47: chargen_send(chargen);
	push	bc
	call	_chargen_send
	pop	af
00104$:
;chargen.c:48: }		
	pop	ix
	ret
;chargen.c:51: static void chargen_send(CHARGEN *chargen)
;	---------------------------------
; Function chargen_send
; ---------------------------------
_chargen_send:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;chargen.c:53: SOCKET *socket = chargen->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;chargen.c:54: byte b = chargen_next_char(chargen->start);
	ld	hl, #0x0053
	add	hl, bc
	ld	a, (hl)
	push	hl
	push	bc
	push	af
	inc	sp
	call	_chargen_next_char
	inc	sp
	ld	a, l
	pop	bc
	pop	hl
	ld	d, a
;chargen.c:56: chargen->start = b;
	ld	(hl), d
;chargen.c:57: for ( i = 0; i < CHARGEN_CHARS; i++ )
	ld	hl, #0x0009
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	e, #0x00
00102$:
;chargen.c:59: chargen->buf[i] = b;
	ld	a, -2 (ix)
	add	a, e
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	h, a
	ld	(hl), d
;chargen.c:60: b = chargen_next_char(b);
	push	bc
	push	de
	push	de
	inc	sp
	call	_chargen_next_char
	inc	sp
	ld	a, l
	pop	de
	pop	bc
	ld	d, a
;chargen.c:57: for ( i = 0; i < CHARGEN_CHARS; i++ )
	inc	e
	ld	a, e
	sub	a, #0x48
	jr	C,00102$
;chargen.c:62: net_send(socket, chargen->buf, CHARGEN_BUF_SIZE, (NF)chargen_sent, chargen);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_chargen_sent
	ld	a, c
	add	a, #0x09
	ld	c, a
	jr	NC,00117$
	inc	b
00117$:
	push	hl
	push	de
	ld	hl, #0x004a
	push	hl
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;chargen.c:63: }
	ld	sp, ix
	pop	ix
	ret
;chargen.c:66: static void chargen_connected(CHARGEN *chargen)
;	---------------------------------
; Function chargen_connected
; ---------------------------------
_chargen_connected:
;chargen.c:69: log_printf("chargen_connected:\r\n$");
	ld	hl, #___str_1
	push	hl
	call	_log_printf
	pop	af
;chargen.c:70: chargen->buf[72] = '\r';
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0051
	add	hl, bc
	ld	(hl), #0x0d
;chargen.c:71: chargen->buf[73] = '\n';
	ld	hl, #0x0052
	add	hl, bc
	ld	(hl), #0x0a
;chargen.c:72: chargen->start = ' ';
	ld	hl, #0x0053
	add	hl, bc
	ld	(hl), #0x20
;chargen.c:73: chargen_send(chargen);
	push	bc
	call	_chargen_send
	pop	af
;chargen.c:74: }
	ret
___str_1:
	.ascii "chargen_connected:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;chargen.c:77: static void chargen_listen(CHARGEN *chargen)
;	---------------------------------
; Function chargen_listen
; ---------------------------------
_chargen_listen:
	push	ix
	ld	ix,#0
	add	ix,sp
;chargen.c:79: SOCKET *socket = chargen->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;chargen.c:80: log_printf("chargen_listen:\r\n$");
	push	bc
	ld	hl, #___str_2
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;chargen.c:81: net_listen(socket, CHARGEN_PORT, (NF)chargen_connected, chargen);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_chargen_connected
	push	hl
	push	de
	ld	hl, #0x0013
	push	hl
	push	bc
	call	_net_listen
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;chargen.c:82: }
	pop	ix
	ret
___str_2:
	.ascii "chargen_listen:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;chargen.c:85: void chargen_start(CHARGEN *chargen)
;	---------------------------------
; Function chargen_start
; ---------------------------------
_chargen_start::
	push	ix
	ld	ix,#0
	add	ix,sp
;chargen.c:87: chargen->socket_alloc.fiber.queued = 0;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x00
;chargen.c:88: net_alloc(&(chargen->socket_alloc), (NF)chargen_listen, chargen);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_chargen_listen
	push	hl
	push	de
	push	bc
	call	_net_alloc
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;chargen.c:89: }
	pop	ix
	ret
;chargen.c:92: void chargen_init(void)
;	---------------------------------
; Function chargen_init
; ---------------------------------
_chargen_init::
;chargen.c:94: }
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
