;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module http
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _log_strn
	.globl _log_printf
	.globl _log_fatal
	.globl _net_recv
	.globl _net_send
	.globl _net_disconnect
	.globl _net_listen
	.globl _net_alloc
	.globl _bdos_search_for_next
	.globl _bdos_search_for_first
	.globl _bdos_delete_files
	.globl _bdos_close_file
	.globl _bdos_write_file
	.globl _bdos_read_file
	.globl _bdos_create_file
	.globl _bdos_open_file
	.globl _bdos_set_dma_address
	.globl _fiber_enqueue
	.globl _memcmp
	.globl _home
	.globl _http_start
	.globl _http_init
	.globl _set_home
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_http_send_dirent_dirbuf_131072_134:
	.ds 128
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_home::
	.ds 14
_mime_ofs:
	.ds 72
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;http.c:27: static void httpline_complete(HTTPLINE *httpline, byte state)
;	---------------------------------
; Function httpline_complete
; ---------------------------------
_httpline_complete:
;http.c:29: httpline->state = state;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000d
	add	hl, bc
	ld	iy, #4
	add	iy, sp
	ld	a, 0 (iy)
	ld	(hl), a
;http.c:30: fiber_enqueue(&(httpline->fiber));
	ld	hl, #0x0005
	add	hl, bc
	push	hl
	call	_fiber_enqueue
	pop	af
;http.c:31: }
	ret
;http.c:35: static void httpline_rcvd(HTTPLINE *httpline)
;	---------------------------------
; Function httpline_rcvd
; ---------------------------------
_httpline_rcvd:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;http.c:37: SOCKET *socket = httpline->socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	h, (hl)
;http.c:38: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00110$
;http.c:39: httpline_complete(httpline, HTTPLINE_STATE_ERROR);
	ld	a, #0x02
	push	af
	inc	sp
	push	bc
	call	_httpline_complete
	pop	af
	inc	sp
	jr	00112$
00110$:
;http.c:42: byte n = ++(httpline->actual);
	ld	hl, #0x000c
	add	hl, bc
	ld	a, (hl)
	inc	a
	ld	(hl), a
;http.c:43: if ( n >= 2                     &&
	ld	-3 (ix), a
	sub	a, #0x02
	jr	C,00105$
;http.c:44: httpline->buf[n-2] == '\r' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, -3 (ix)
	ld	-2 (ix), a
	xor	a, a
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	dec	hl
	add	hl, de
	ld	a, (hl)
	sub	a, #0x0d
	jr	NZ,00105$
;http.c:45: httpline->buf[n-1] == '\n' )
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	add	hl, de
	ld	a, (hl)
	sub	a, #0x0a
	jr	NZ,00105$
;http.c:46: httpline_complete(httpline, HTTPLINE_STATE_OK);
	xor	a, a
	push	af
	inc	sp
	push	bc
	call	_httpline_complete
	pop	af
	inc	sp
	jr	00112$
00105$:
;http.c:47: else if ( n == httpline->length )
	ld	l, c
	ld	h, b
	ld	de, #0x0004
	add	hl, de
	ld	a,-3 (ix)
	sub	a,(hl)
	jr	NZ,00102$
;http.c:48: httpline_complete(httpline, HTTPLINE_STATE_TOO_LONG);
	ld	a, #0x01
	push	af
	inc	sp
	push	bc
	call	_httpline_complete
	pop	af
	inc	sp
	jr	00112$
00102$:
;http.c:50: httpline_recv_char(httpline);
	push	bc
	call	_httpline_recv_char
	pop	af
00112$:
;http.c:52: }
	ld	sp, ix
	pop	ix
	ret
;http.c:54: static void httpline_recv_char(HTTPLINE *httpline)
;	---------------------------------
; Function httpline_recv_char
; ---------------------------------
_httpline_recv_char:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;http.c:56: SOCKET *socket = httpline->socket;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, (de)
	ld	-6 (ix), a
	inc	de
	ld	a, (de)
	ld	-5 (ix), a
	dec	de
;http.c:57: net_recv(socket, httpline->buf+httpline->actual, 1, (NF)httpline_rcvd, httpline);
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	-2 (ix), #<(_httpline_rcvd)
	ld	-1 (ix), #>(_httpline_rcvd)
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ex	de,hl
	ld	de, #0x000c
	add	hl, de
	ld	l, (hl)
	ld	h, #0x00
	add	hl, bc
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	push	bc
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	push	bc
	ld	bc, #0x0001
	push	bc
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;http.c:58: }
	ld	sp, ix
	pop	ix
	ret
;http.c:60: static void httpline_recv(HTTPLINE *httpline, SOCKET *socket, byte *buf, byte length, NF nf, void *nfp)
;	---------------------------------
; Function httpline_recv
; ---------------------------------
_httpline_recv:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:62: httpline->socket    = socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;http.c:63: httpline->buf       = buf;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	a, 8 (ix)
	ld	(de), a
	inc	de
	ld	a, 9 (ix)
	ld	(de), a
;http.c:64: httpline->length    = length;
	ld	hl, #0x0004
	add	hl, bc
	ld	a, 10 (ix)
	ld	(hl), a
;http.c:65: httpline->fiber.nf  = nf;
	ld	hl, #0x0007
	add	hl, bc
	ld	a, 11 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 12 (ix)
	ld	(hl), a
;http.c:66: httpline->fiber.nfp = nfp;
	ld	hl, #0x0009
	add	hl, bc
	ld	a, 13 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 14 (ix)
	ld	(hl), a
;http.c:67: httpline->actual    = 0;
	ld	hl, #0x000c
	add	hl, bc
	ld	(hl), #0x00
;http.c:68: httpline_recv_char(httpline);
	push	bc
	call	_httpline_recv_char
	pop	af
;http.c:69: }
	pop	ix
	ret
;http.c:72: static void httpblock_complete(HTTPBLOCK *httpblock, byte state)
;	---------------------------------
; Function httpblock_complete
; ---------------------------------
_httpblock_complete:
;http.c:74: httpblock->state = state;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x000d
	add	hl, bc
	ld	iy, #4
	add	iy, sp
	ld	a, 0 (iy)
	ld	(hl), a
;http.c:75: fiber_enqueue(&(httpblock->fiber));
	inc	bc
	inc	bc
	inc	bc
	inc	bc
	push	bc
	call	_fiber_enqueue
	pop	af
;http.c:76: }
	ret
;http.c:80: static void httpblock_rcvd(HTTPBLOCK *httpblock)
;	---------------------------------
; Function httpblock_rcvd
; ---------------------------------
_httpblock_rcvd:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;http.c:82: SOCKET *socket = httpblock->socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;http.c:83: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00105$
;http.c:84: httpblock_complete(httpblock, HTTPBLOCK_STATE_ERROR);
	ld	a, #0x01
	push	af
	inc	sp
	push	bc
	call	_httpblock_complete
	pop	af
	inc	sp
	jr	00107$
00105$:
;http.c:87: httpblock->actual += socket->actual;
	ld	hl, #0x000c
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	a, (hl)
	ex	de,hl
	ld	de, #0x001e
	add	hl, de
	ld	e, (hl)
	add	a, e
	pop	hl
	push	hl
	ld	(hl), a
;http.c:88: if ( httpblock->actual == httpblock->length )
	ld	e, c
	ld	d, b
	ex	de,hl
	ld	de, #0x000b
	add	hl, de
	ld	e, (hl)
	sub	a, e
	jr	NZ,00102$
;http.c:89: httpblock_complete(httpblock, HTTPBLOCK_STATE_OK);
	xor	a, a
	push	af
	inc	sp
	push	bc
	call	_httpblock_complete
	pop	af
	inc	sp
	jr	00107$
00102$:
;http.c:91: httpblock_recv_more(httpblock);
	push	bc
	call	_httpblock_recv_more
	pop	af
00107$:
;http.c:93: }
	ld	sp, ix
	pop	ix
	ret
;http.c:95: static void httpblock_recv_more(HTTPBLOCK *httpblock)
;	---------------------------------
; Function httpblock_recv_more
; ---------------------------------
_httpblock_recv_more:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-7
	add	hl, sp
	ld	sp, hl
;http.c:97: SOCKET *socket = httpblock->socket;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, (de)
	ld	-7 (ix), a
	inc	de
	ld	a, (de)
	ld	-6 (ix), a
	dec	de
;http.c:98: net_recv(socket, httpblock->buf+httpblock->actual, httpblock->length-httpblock->actual, (NF)httpblock_rcvd, httpblock);
	ld	a, 4 (ix)
	ld	-5 (ix), a
	ld	a, 5 (ix)
	ld	-4 (ix), a
	ld	-3 (ix), #<(_httpblock_rcvd)
	ld	-2 (ix), #>(_httpblock_rcvd)
	ld	l, e
	ld	h, d
	ld	bc, #0x000b
	add	hl, bc
	ld	c, (hl)
	ld	b, #0x00
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000c
	add	hl, bc
	pop	bc
	ld	a, (hl)
	ld	-1 (ix), a
	ld	l, a
	ld	h, #0x00
	ld	a, c
	sub	a, l
	ld	c, a
	ld	a, b
	sbc	a, h
	ld	b, a
	ex	de,hl
	inc	hl
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, -1 (ix)
	ld	h, #0x00
	add	hl, de
	ld	e, -5 (ix)
	ld	d, -4 (ix)
	push	de
	ld	e, -3 (ix)
	ld	d, -2 (ix)
	push	de
	push	bc
	push	hl
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	call	_net_recv
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;http.c:99: }
	ld	sp, ix
	pop	ix
	ret
;http.c:101: static void httpblock_recv(HTTPBLOCK *httpblock, SOCKET *socket, byte *buf, byte length, NF nf, void *nfp)
;	---------------------------------
; Function httpblock_recv
; ---------------------------------
_httpblock_recv:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:103: httpblock->socket    = socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;http.c:104: httpblock->buf       = buf;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	a, 8 (ix)
	ld	(de), a
	inc	de
	ld	a, 9 (ix)
	ld	(de), a
;http.c:105: httpblock->length    = length;
	ld	hl, #0x000b
	add	hl, bc
	ld	a, 10 (ix)
	ld	(hl), a
;http.c:106: httpblock->fiber.nf  = nf;
	ld	hl, #0x0006
	add	hl, bc
	ld	a, 11 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 12 (ix)
	ld	(hl), a
;http.c:107: httpblock->fiber.nfp = nfp;
	ld	hl, #0x0008
	add	hl, bc
	ld	a, 13 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 14 (ix)
	ld	(hl), a
;http.c:108: httpblock->actual    = 0;
	ld	hl, #0x000c
	add	hl, bc
	ld	(hl), #0x00
;http.c:109: httpblock_recv_more(httpblock);
	push	bc
	call	_httpblock_recv_more
	pop	af
;http.c:110: }
	pop	ix
	ret
;http.c:116: static byte *http_copy(byte *dest, const byte *src)
;	---------------------------------
; Function http_copy
; ---------------------------------
_http_copy:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:118: while ( *src )
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	ld	e, 4 (ix)
	ld	d, 5 (ix)
00101$:
	ld	a, (bc)
	or	a, a
	jr	Z,00103$
;http.c:119: *dest++ = *src++;
	inc	bc
	ld	(de), a
	inc	de
	jr	00101$
00103$:
;http.c:120: return dest;
	ex	de,hl
;http.c:121: }
	pop	ix
	ret
;http.c:126: static void http_disconnect(HTTP *http)
;	---------------------------------
; Function http_disconnect
; ---------------------------------
_http_disconnect:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:128: SOCKET *socket = http->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;http.c:129: log_printf("http_disconnect:\r\n$");
	push	bc
	ld	hl, #___str_0
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;http.c:130: net_disconnect(socket, (NF)http_listen, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_http_listen
	push	hl
	push	de
	push	bc
	call	_net_disconnect
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;http.c:131: }		
	pop	ix
	ret
___str_0:
	.ascii "http_disconnect:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;http.c:134: static void http_close_and_disconnect(HTTP *http)
;	---------------------------------
; Function http_close_and_disconnect
; ---------------------------------
_http_close_and_disconnect:
;http.c:136: bdos_close_file(&(http->fcb));
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0089
	add	hl, bc
	push	bc
	push	hl
	call	_bdos_close_file
	pop	af
	call	_http_disconnect
	pop	af
;http.c:138: }
	ret
;http.c:141: static void http_send_ok_response(
;	---------------------------------
; Function http_send_ok_response
; ---------------------------------
_http_send_ok_response:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:147: SOCKET *socket = http->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;http.c:148: byte *p = http->buffer;
	ld	hl, #0x00ad
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
;http.c:149: log_printf("http_send_ok_response:\r\n$");
	push	bc
	push	hl
	ld	hl, #___str_1
	push	hl
	call	_log_printf
	pop	af
	pop	de
	ld	hl, #___str_2
	push	hl
	push	de
	call	_http_copy
	pop	af
	pop	af
	pop	bc
;http.c:151: if ( mime != NULL )
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	Z,00102$
;http.c:153: p = http_copy(p, "Content-type: ");
	ld	de, #___str_3+0
	push	bc
	push	de
	push	hl
	call	_http_copy
	pop	af
	pop	af
	ld	e, 6 (ix)
	ld	d, 7 (ix)
	push	de
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	bc
;http.c:155: p = http_copy(p, "\r\n");
	ld	de, #___str_4+0
	push	bc
	push	de
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	bc
00102$:
;http.c:157: p = http_copy(p, "\r\n");
	ld	de, #___str_4+0
	push	bc
	push	de
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	bc
;http.c:158: net_send(socket, http->buffer, p-http->buffer, nf, http);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, l
	sub	a, -2 (ix)
	ld	l, a
	ld	a, h
	sbc	a, -1 (ix)
	ld	h, a
	ld	a, c
	add	a, #0xad
	ld	c, a
	jr	NC,00110$
	inc	b
00110$:
	push	de
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	push	de
	push	hl
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;http.c:159: }
	ld	sp, ix
	pop	ix
	ret
___str_1:
	.ascii "http_send_ok_response:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_2:
	.ascii "HTTP/1.1 200 OK"
	.db 0x0d
	.db 0x0a
	.db 0x00
___str_3:
	.ascii "Content-type: "
	.db 0x00
___str_4:
	.db 0x0d
	.db 0x0a
	.db 0x00
;http.c:162: static void http_send_error_response(
;	---------------------------------
; Function http_send_error_response
; ---------------------------------
_http_send_error_response:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-14
	add	hl, sp
	ld	sp, hl
;http.c:169: SOCKET *socket = http->socket_alloc.socket;
	ld	a, 4 (ix)
	ld	-10 (ix), a
	ld	a, 5 (ix)
	ld	-9 (ix), a
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-8 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-7 (ix), a
;http.c:170: byte *p = http->buffer;
	ld	a, -10 (ix)
	add	a, #0xad
	ld	-6 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, -6 (ix)
	ld	-4 (ix), a
	ld	a, -5 (ix)
	ld	-3 (ix), a
;http.c:172: log_printf("http_send_error_response: $");
	ld	hl, #___str_5
	push	hl
	call	_log_printf
	pop	af
;http.c:173: s[0] = status_code[0];
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	a, 6 (ix)
	ld	-2 (ix), a
	ld	a, 7 (ix)
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
	ld	(de), a
;http.c:174: s[1] = status_code[1];
	ld	c, e
	ld	b, d
	inc	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	inc	hl
	ld	a, (hl)
	ld	(bc), a
;http.c:175: s[2] = status_code[2];
	ld	c, e
	ld	b, d
	inc	bc
	inc	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	(bc), a
;http.c:176: s[3] = '$';
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	inc	hl
	ld	(hl), #0x24
;http.c:177: log_printf(s);
	push	de
	call	_log_printf
;http.c:178: log_printf("\r\n$");
	ld	hl, #___str_6
	ex	(sp),hl
	call	_log_printf
;http.c:179: p = http_copy(p, "HTTP/1.1 ");
	ld	hl, #___str_7
	ex	(sp),hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:180: p = http_copy(p, status_code);
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:181: p = http_copy(p, " ");
	ld	bc, #___str_8+0
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:182: p = http_copy(p, status_text);
	ld	c, 8 (ix)
	ld	b, 9 (ix)
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:183: p = http_copy(p, "\r\n\r\n");
	ld	bc, #___str_9+0
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:184: p = http_copy(p, "<H1>Error ");
	ld	bc, #___str_10+0
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:185: p = http_copy(p, status_code);
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:186: p = http_copy(p, "</H1>\r\n<P>");
	ld	bc, #___str_11+0
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:187: p = http_copy(p, status_text);
	ld	c, 8 (ix)
	ld	b, 9 (ix)
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:188: p = http_copy(p, "\r\n");
	ld	bc, #___str_12+0
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
;http.c:189: net_send(socket, http->buffer, p-http->buffer, nf, http);
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, l
	sub	a, -6 (ix)
	ld	l, a
	ld	a, h
	sbc	a, -5 (ix)
	ld	h, a
	ld	a, -10 (ix)
	add	a, #0xad
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
	push	de
	ld	e, 10 (ix)
	ld	d, 11 (ix)
	push	de
	push	hl
	push	bc
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;http.c:190: }
	ld	sp, ix
	pop	ix
	ret
___str_5:
	.ascii "http_send_error_response: $"
	.db 0x00
___str_6:
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_7:
	.ascii "HTTP/1.1 "
	.db 0x00
___str_8:
	.ascii " "
	.db 0x00
___str_9:
	.db 0x0d
	.db 0x0a
	.db 0x0d
	.db 0x0a
	.db 0x00
___str_10:
	.ascii "<H1>Error "
	.db 0x00
___str_11:
	.ascii "</H1>"
	.db 0x0d
	.db 0x0a
	.ascii "<P>"
	.db 0x00
___str_12:
	.db 0x0d
	.db 0x0a
	.db 0x00
;http.c:193: static void http_send_block(HTTP *http)
;	---------------------------------
; Function http_send_block
; ---------------------------------
_http_send_block:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:195: SOCKET *socket = http->socket_alloc.socket;
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;http.c:196: if ( socket->state == SS_ERROR )
	pop	hl
	push	hl
	ld	de, #0x000e
	add	hl, de
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00112$
;http.c:197: http_close_and_disconnect(http);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_http_close_and_disconnect
	pop	af
	jp	00118$
00112$:
;http.c:200: bdos_set_dma_address(http->buffer);
	ld	a, -2 (ix)
	add	a, #0xad
	ld	c, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	b, a
	ld	e, c
	ld	d, b
	push	bc
	push	de
	call	_bdos_set_dma_address
	pop	af
	pop	bc
;http.c:201: if ( bdos_read_file(&(http->fcb)) != 0 )
	ld	a, -2 (ix)
	add	a, #0x89
	ld	e, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	d, a
	push	bc
	push	de
	call	_bdos_read_file
	pop	af
	ld	a, l
	pop	bc
	or	a, a
	jr	Z,00109$
;http.c:203: http_close_and_disconnect(http);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_http_close_and_disconnect
	pop	af
	jr	00118$
00109$:
;http.c:213: if ( http->textual )
	pop	de
	pop	hl
	push	hl
	push	de
	ld	de, #0x02a1
	add	hl, de
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	jr	Z,00103$
;http.c:214: for ( len = 0; len < 128 && http->buffer[len] != CTRL_Z; len++ )
	ld	e, #0x00
00116$:
	ld	a, e
	sub	a, #0x80
	jr	NC,00127$
	ld	l, e
	ld	h, #0x00
	add	hl, bc
	ld	a, (hl)
	sub	a, #0x1a
	jr	Z,00127$
	inc	e
	jr	00116$
00103$:
;http.c:217: len = 128;
	ld	e, #0x80
;http.c:221: net_send(socket, http->buffer, len, (NF)http_close_and_disconnect, http);
;http.c:217: len = 128;
00127$:
;http.c:219: net_send(socket, http->buffer, len, (NF)http_send_block, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	-2 (ix), e
	xor	a, a
	ld	-1 (ix), a
;http.c:218: if ( len == 128 )
	ld	a, e
	sub	a, #0x80
	jr	NZ,00106$
;http.c:219: net_send(socket, http->buffer, len, (NF)http_send_block, http);
	ld	de, #_http_send_block
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
	jr	00118$
00106$:
;http.c:221: net_send(socket, http->buffer, len, (NF)http_close_and_disconnect, http);
	ld	de, #_http_close_and_disconnect
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00118$:
;http.c:224: }
	ld	sp, ix
	pop	ix
	ret
;http.c:227: static byte *http_dir_filename(byte *p, DIRENT *dir)
;	---------------------------------
; Function http_dir_filename
; ---------------------------------
_http_dir_filename:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;http.c:231: for (i = 0; i < 8; ++i)
	ld	a, 6 (ix)
	ld	-5 (ix), a
	ld	a, 7 (ix)
	ld	-4 (ix), a
	ld	a, -5 (ix)
	add	a, #0x01
	ld	-3 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	de, #0x0000
00107$:
;http.c:233: c = dir->filename[i] & 0x7F;
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	add	hl, de
	ld	a, (hl)
	and	a, #0x7f
	ld	-1 (ix), a
;http.c:234: if (c > ' ') *(p++) = c;
	ld	a, #0x20
	sub	a, -1 (ix)
	jr	NC,00108$
	ld	a, -1 (ix)
	ld	(bc), a
	inc	bc
00108$:
;http.c:231: for (i = 0; i < 8; ++i)
	inc	de
	ld	a, e
	sub	a, #0x08
	ld	a, d
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00107$
;http.c:236: *(p++) = '.';
	ld	a, #0x2e
	ld	(bc), a
	inc	bc
	ld	4 (ix), c
	ld	5 (ix), b
;http.c:237: for (i = 0; i < 3; ++i)
	ld	a, -5 (ix)
	add	a, #0x09
	ld	-2 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	bc, #0x0000
00109$:
;http.c:239: c = dir->type[i] & 0x7F;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, bc
	ld	a, (hl)
	and	a, #0x7f
	ld	-3 (ix), a
;http.c:240: if (c > ' ') *(p++) = c;
	ld	a, #0x20
	sub	a, -3 (ix)
	jr	NC,00110$
	ld	a, -3 (ix)
	ld	(de), a
	inc	de
00110$:
;http.c:237: for (i = 0; i < 3; ++i)
	inc	bc
	ld	a, c
	sub	a, #0x03
	ld	a, b
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00109$
;http.c:242: return p;
	ex	de,hl
;http.c:243: }
	ld	sp, ix
	pop	ix
	ret
;http.c:245: static void http_send_dirent(HTTP *http)
;	---------------------------------
; Function http_send_dirent
; ---------------------------------
_http_send_dirent:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-15
	add	hl, sp
	ld	sp, hl
;http.c:247: SOCKET *socket = http->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;http.c:248: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00111$
;http.c:249: http_close_and_disconnect(http);
	push	bc
	call	_http_close_and_disconnect
	pop	af
	jp	00113$
00111$:
;http.c:253: byte *p = http->buffer;
	ld	hl, #0x00ad
	add	hl, bc
	ld	-13 (ix), l
	ld	-12 (ix), h
	ld	a, -13 (ix)
	ld	-11 (ix), a
	ld	a, -12 (ix)
	ld	-10 (ix), a
;http.c:255: bdos_set_dma_address((byte *)dirbuf);
	push	bc
	push	de
	ld	hl, #_http_send_dirent_dirbuf_131072_134
	push	hl
	call	_bdos_set_dma_address
	pop	af
	pop	de
	pop	bc
;http.c:256: if ( http->first_dir )
	ld	hl, #0x02a7
	add	hl, bc
	ld	-9 (ix), l
	ld	-8 (ix), h
	ld	a, (hl)
	ld	-15 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-14 (ix), a
;http.c:258: dir = bdos_search_for_first(&http->fcb);
	ld	hl, #0x0089
	add	hl, bc
;http.c:262: net_send(socket, http->buffer, p-http->buffer, (NF)http_close_and_disconnect, http);
	ld	a, 4 (ix)
	ld	-7 (ix), a
	ld	a, 5 (ix)
	ld	-6 (ix), a
	ld	a, -11 (ix)
	sub	a, -13 (ix)
	ld	-5 (ix), a
	ld	a, -10 (ix)
	sbc	a, -12 (ix)
	ld	-4 (ix), a
	ld	a, c
	add	a, #0xad
	ld	-3 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-2 (ix), a
;http.c:256: if ( http->first_dir )
	ld	a, -14 (ix)
	or	a, -15 (ix)
	jr	Z,00105$
;http.c:258: dir = bdos_search_for_first(&http->fcb);
	push	de
	push	hl
	call	_bdos_search_for_first
	pop	af
	pop	de
;http.c:259: if (dir == 255)
	ld	-1 (ix), l
	ld	a, l
	inc	a
	jr	NZ,00102$
;http.c:261: http_copy(p, "No files\r\n</body></html>\r\n");
	push	de
	ld	hl, #___str_13
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
;http.c:262: net_send(socket, http->buffer, p-http->buffer, (NF)http_close_and_disconnect, http);
	ld	bc, #_http_close_and_disconnect
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	push	bc
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
;http.c:263: return;
	jp	00113$
00102$:
;http.c:267: http_copy(p, "<ul>");
	push	de
	ld	hl, #___str_14
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
;http.c:269: http->first_dir = FALSE;
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	jr	00106$
00105$:
;http.c:273: dir = bdos_search_for_next(&http->fcb);
	push	de
	push	hl
	call	_bdos_search_for_next
	pop	af
	pop	de
	ld	-1 (ix), l
00106$:
;http.c:275: if (dir == 255)
	ld	a, -1 (ix)
	inc	a
	jr	NZ,00108$
;http.c:277: http_copy(p, "</ul></body></html>\r\n");
	push	de
	ld	hl, #___str_15
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
;http.c:278: net_send(socket, http->buffer, p-http->buffer, (NF)http_close_and_disconnect, http);
	ld	bc, #_http_close_and_disconnect
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	push	bc
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
	jp	00113$
00108$:
;http.c:282: p = http_copy(p, "<li><a href=\"/");
	push	de
	ld	hl, #___str_16
	push	hl
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
	ld	c, l
	ld	b, h
;http.c:283: p = http_dir_filename(p, &dirbuf[dir]);
	ld	l, -1 (ix)
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	a, l
	add	a, #<(_http_send_dirent_dirbuf_131072_134)
	ld	-5 (ix), a
	ld	a, h
	adc	a, #>(_http_send_dirent_dirbuf_131072_134)
	ld	-4 (ix), a
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	de
	push	hl
	push	bc
	call	_http_dir_filename
	pop	af
	pop	af
	pop	de
;http.c:284: p = http_copy(p, "\">");
	ld	bc, #___str_17+0
	push	de
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
;http.c:285: p = http_dir_filename(p, &dirbuf[dir]);
	ld	c, -5 (ix)
	ld	b, -4 (ix)
	push	de
	push	bc
	push	hl
	call	_http_dir_filename
	pop	af
	pop	af
	pop	de
;http.c:286: p = http_copy(p, "</a></li>\r\n");
	ld	bc, #___str_18+0
	push	de
	push	bc
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
;http.c:287: net_send(socket, http->buffer, p-http->buffer, (NF)http_send_dirent, http);
	ld	bc, #_http_send_dirent
	ld	a, l
	sub	a, -13 (ix)
	ld	-5 (ix), a
	ld	a, h
	sbc	a, -12 (ix)
	ld	-4 (ix), a
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	push	bc
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00113$:
;http.c:290: }
	ld	sp, ix
	pop	ix
	ret
___str_13:
	.ascii "No files"
	.db 0x0d
	.db 0x0a
	.ascii "</body></html>"
	.db 0x0d
	.db 0x0a
	.db 0x00
___str_14:
	.ascii "<ul>"
	.db 0x00
___str_15:
	.ascii "</ul></body></html>"
	.db 0x0d
	.db 0x0a
	.db 0x00
___str_16:
	.ascii "<li><a href="
	.db 0x22
	.ascii "/"
	.db 0x00
___str_17:
	.db 0x22
	.ascii ">"
	.db 0x00
___str_18:
	.ascii "</a></li>"
	.db 0x0d
	.db 0x0a
	.db 0x00
;http.c:292: static void http_send_index_head(HTTP *http)
;	---------------------------------
; Function http_send_index_head
; ---------------------------------
_http_send_index_head:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;http.c:294: SOCKET *socket = http->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;http.c:295: if ( socket->state == SS_ERROR )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000e
	add	hl, bc
	pop	bc
	ld	a, (hl)
	sub	a, #0x07
	jr	NZ,00104$
;http.c:296: http_close_and_disconnect(http);
	push	bc
	call	_http_close_and_disconnect
	pop	af
	jp	00110$
00104$:
;http.c:300: byte *p = http->buffer;
	ld	hl, #0x00ad
	add	hl, bc
	ex	(sp), hl
	ld	a, -8 (ix)
	ld	-6 (ix), a
	ld	a, -7 (ix)
	ld	-5 (ix), a
;http.c:301: http->fcb.drive = 0;
	ld	hl, #0x0089
	add	hl, bc
	ld	(hl), #0x00
;http.c:302: for (i = 0; i < 8; ++i) http->fcb.filename[i] = '?';
	ld	hl, #0x008a
	add	hl, bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00106$:
	ld	a, -4 (ix)
	add	a, -2 (ix)
	ld	l, a
	ld	a, -3 (ix)
	adc	a, -1 (ix)
	ld	h, a
	ld	(hl), #0x3f
	inc	-2 (ix)
	jr	NZ,00141$
	inc	-1 (ix)
00141$:
	ld	a, -2 (ix)
	sub	a, #0x08
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00106$
;http.c:303: for (i = 0; i < 3; ++i) http->fcb.type[i] = '?';
	ld	hl, #0x0092
	add	hl, bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	xor	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
00108$:
	ld	a, -4 (ix)
	add	a, -2 (ix)
	ld	l, a
	ld	a, -3 (ix)
	adc	a, -1 (ix)
	ld	h, a
	ld	(hl), #0x3f
	inc	-2 (ix)
	jr	NZ,00142$
	inc	-1 (ix)
00142$:
	ld	a, -2 (ix)
	sub	a, #0x03
	ld	a, -1 (ix)
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00108$
;http.c:304: http->fcb.ex = 0;
	ld	hl, #0x0095
	add	hl, bc
	ld	(hl), #0x00
;http.c:305: http->fcb.s1 = 0;
	ld	hl, #0x0096
	add	hl, bc
	ld	(hl), #0x00
;http.c:306: http->fcb.s2 = 0;
	ld	hl, #0x0097
	add	hl, bc
	ld	(hl), #0x00
;http.c:307: http->first_dir = TRUE;
	ld	hl, #0x02a7
	add	hl, bc
	ld	(hl), #0x01
	inc	hl
	ld	(hl), #0x00
;http.c:308: p = http_copy(p, "<html><head><title>HTTPD Index</title></head>\r\n");
	push	bc
	push	de
	ld	hl, #___str_19
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	-2 (ix), l
	ld	-1 (ix), h
;http.c:309: p = http_copy(p, "<body><h1>HTTPD Version " VERSION "</h1>\r\n");
	push	bc
	push	de
	ld	hl, #___str_20
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_http_copy
	pop	af
	pop	af
	pop	de
	pop	bc
;http.c:310: net_send(socket, http->buffer, p-http->buffer, (NF)http_send_dirent, http);
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	-4 (ix), #<(_http_send_dirent)
	ld	-3 (ix), #>(_http_send_dirent)
	ld	a, l
	sub	a, -8 (ix)
	ld	-2 (ix), a
	ld	a, h
	sbc	a, -7 (ix)
	ld	-1 (ix), a
	ld	hl, #0x00ad
	add	hl, bc
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	push	bc
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	push	bc
	ld	c, -2 (ix)
	ld	b, -1 (ix)
	push	bc
	push	hl
	push	de
	call	_net_send
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
00110$:
;http.c:312: }
	ld	sp, ix
	pop	ix
	ret
___str_19:
	.ascii "<html><head><title>HTTPD Index</title></head>"
	.db 0x0d
	.db 0x0a
	.db 0x00
___str_20:
	.ascii "<body><h1>HTTPD Version v230307</h1>"
	.db 0x0d
	.db 0x0a
	.db 0x00
;http.c:344: static const byte *http_mime_of(byte *type)
;	---------------------------------
; Function http_mime_of
; ---------------------------------
_http_mime_of:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:347: for ( i = 0; i < sizeof(mime_ofs)/sizeof(mime_ofs[0]); i++ )
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	c, #0x00
00106$:
;http.c:349: MIME_OF *mo = &(mime_ofs[i]);
	ld	l, c
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	ld	de, #_mime_ofs
	add	hl, de
	ld	-2 (ix), l
	ld	-1 (ix), h
;http.c:350: if ( type[0] == mo->type[0] &&
	pop	hl
	push	hl
	ld	b, (hl)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, (de)
	sub	a, b
	jr	NZ,00107$
;http.c:351: type[1] == mo->type[1] &&
	pop	hl
	push	hl
	inc	hl
	ld	a, (hl)
	ld	b, e
	ld	h, d
	ld	l, b
	inc	hl
	ld	b, (hl)
	sub	a, b
	jr	NZ,00107$
;http.c:352: type[2] == mo->type[2] )
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ex	de,hl
	inc	hl
	inc	hl
	ld	b, (hl)
	sub	a, b
	jr	NZ,00107$
;http.c:353: return mo->mime;
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	inc	hl
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	jr	00108$
00107$:
;http.c:347: for ( i = 0; i < sizeof(mime_ofs)/sizeof(mime_ofs[0]); i++ )
	inc	c
	ld	a, c
	sub	a, #0x12
	jr	C,00106$
;http.c:355: return "text/plain";
	ld	hl, #___str_21
00108$:
;http.c:356: }
	ld	sp, ix
	pop	ix
	ret
___str_21:
	.ascii "text/plain"
	.db 0x00
;http.c:359: static BOOLEAN http_mime_is_textual(const byte *mime)
;	---------------------------------
; Function http_mime_is_textual
; ---------------------------------
_http_mime_is_textual:
;http.c:361: return mime[0] == 't';
	pop	de
	pop	bc
	push	bc
	push	de
	ld	a, (bc)
	sub	a, #0x74
	ld	a, #0x01
	jr	Z,00104$
	xor	a, a
00104$:
	ld	l, a
	ld	h, #0x00
;http.c:362: }
	ret
;http.c:365: static void http_do_get(HTTP *http)
;	---------------------------------
; Function http_do_get
; ---------------------------------
_http_do_get:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:367: log_printf("http_do_get: $");
	ld	hl, #___str_22
	push	hl
	call	_log_printf
	pop	af
;http.c:368: log_strn(http->fcb.filename, 8);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0089
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	hl, #0x008a
	add	hl, bc
	push	bc
	ld	de, #0x0008
	push	de
	push	hl
	call	_log_strn
	pop	af
	ld	hl, #___str_23
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	bc
;http.c:370: log_strn(http->fcb.type, 3);
	ld	hl, #0x0092
	add	hl, bc
	ex	de, hl
	push	bc
	push	de
	ld	hl, #0x0003
	push	hl
	push	de
	call	_log_strn
	pop	af
	ld	hl, #___str_24
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;http.c:372: http->fcb.ex = 0;
	ld	hl, #0x0095
	add	hl, bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	(hl), #0x00
;http.c:373: http->fcb.s1 = 0;
	ld	hl, #0x0096
	add	hl, bc
	ld	(hl), #0x00
;http.c:374: http->fcb.s2 = 0;
	ld	hl, #0x0097
	add	hl, bc
	ld	(hl), #0x00
;http.c:375: http->fcb.rc = 0;
	ld	hl, #0x0098
	add	hl, bc
	ld	(hl), #0x00
;http.c:376: if ( bdos_open_file(&(http->fcb)) == 255 )
	push	bc
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_bdos_open_file
	pop	af
	pop	de
	pop	bc
	inc	l
	jr	NZ,00102$
;http.c:377: http_send_error_response(http, "404", "File Not Found", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_26
	push	hl
	ld	hl, #___str_25
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00104$
00102$:
;http.c:380: const byte *mime = http_mime_of(http->fcb.type);
	push	bc
	push	de
	call	_http_mime_of
	pop	af
	pop	bc
	ex	de,hl
;http.c:381: http->textual = http_mime_is_textual(mime);
	ld	hl, #0x02a1
	add	hl, bc
	push	hl
	push	bc
	push	de
	push	de
	call	_http_mime_is_textual
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
	pop	de
	pop	bc
	pop	hl
	ld	a, -2 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -1 (ix)
	ld	(hl), a
;http.c:382: http->fcb.ex = 0;
	pop	hl
	push	hl
	ld	(hl), #0x00
;http.c:383: http->fcb.cr = 0;
	ld	hl, #0x00a9
	add	hl, bc
	ld	(hl), #0x00
;http.c:384: http_send_ok_response(http, mime, (NF)http_send_block);
	ld	hl, #_http_send_block
	push	hl
	push	de
	push	bc
	call	_http_send_ok_response
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
00104$:
;http.c:386: }
	ld	sp, ix
	pop	ix
	ret
___str_22:
	.ascii "http_do_get: $"
	.db 0x00
___str_23:
	.ascii ".$"
	.db 0x00
___str_24:
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_25:
	.ascii "404"
	.db 0x00
___str_26:
	.ascii "File Not Found"
	.db 0x00
;http.c:389: static void http_do_index(HTTP *http)
;	---------------------------------
; Function http_do_index
; ---------------------------------
_http_do_index:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:391: log_printf("http_do_index:\r\n$");
	ld	hl, #___str_27
	push	hl
	call	_log_printf
	pop	af
;http.c:392: http_send_ok_response(http, "text/html", (NF)http_send_index_head);
	ld	bc, #_http_send_index_head
	push	bc
	ld	hl, #___str_28
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_http_send_ok_response
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;http.c:393: }
	pop	ix
	ret
___str_27:
	.ascii "http_do_index:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_28:
	.ascii "text/html"
	.db 0x00
;http.c:398: static void http_rcvd_block(HTTP *http)
;	---------------------------------
; Function http_rcvd_block
; ---------------------------------
_http_rcvd_block:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;http.c:401: HTTPBLOCK *httpblock = &(http->httpblock);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0017
	add	hl, bc
	ex	de, hl
;http.c:402: for ( i = httpblock->actual; i < 128; i++ )
	ld	hl, #0x000c
	add	hl, de
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, (hl)
	ld	-3 (ix), a
	ld	hl, #0x00ad
	add	hl, bc
	ld	-5 (ix), l
	ld	-4 (ix), h
00109$:
	ld	a, -3 (ix)
	sub	a, #0x80
	jr	NC,00101$
;http.c:403: http->buffer[i] = CTRL_Z;
	ld	a, -3 (ix)
	ld	h, #0x00
	add	a, -5 (ix)
	ld	l, a
	ld	a, h
	adc	a, -4 (ix)
	ld	h, a
	ld	(hl), #0x1a
;http.c:402: for ( i = httpblock->actual; i < 128; i++ )
	inc	-3 (ix)
	jr	00109$
00101$:
;http.c:404: bdos_set_dma_address(http->buffer);
	ld	hl, #0x00ad
	add	hl, bc
	push	bc
	push	de
	push	hl
	call	_bdos_set_dma_address
	pop	af
	pop	de
	pop	bc
;http.c:405: if ( bdos_write_file(&(http->fcb)) != 0 )
	ld	hl, #0x0089
	add	hl, bc
	push	bc
	push	de
	push	hl
	call	_bdos_write_file
	pop	af
	ld	-3 (ix), l
	pop	de
	pop	bc
	ld	a, -3 (ix)
	or	a, a
	jr	Z,00106$
;http.c:406: http_send_error_response(http, "500", "Internal Server Error - unable to write file", (NF)http_close_and_disconnect);
	ld	de, #_http_close_and_disconnect
	push	de
	ld	hl, #___str_30
	push	hl
	ld	hl, #___str_29
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00111$
00106$:
;http.c:407: else if ( httpblock->state != HTTPBLOCK_STATE_OK )
	ex	de,hl
	ld	de, #0x000d
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	Z,00103$
;http.c:408: http_close_and_disconnect(http);
	push	bc
	call	_http_close_and_disconnect
	pop	af
	jr	00111$
00103$:
;http.c:411: http->content_length -= httpblock->actual;
	ld	hl, #0x02aa
	add	hl, bc
	ex	(sp), hl
	push	bc
	ld	e, -10 (ix)
	ld	d, -9 (ix)
	ld	hl, #0x0004
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	pop	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	e, (hl)
	ld	d, #0x00
	ld	hl, #0x0000
	ld	a, -8 (ix)
	sub	a, e
	ld	-4 (ix), a
	ld	a, -7 (ix)
	sbc	a, d
	ld	-3 (ix), a
	ld	a, -6 (ix)
	sbc	a, l
	ld	-2 (ix), a
	ld	a, -5 (ix)
	sbc	a, h
	ld	-1 (ix), a
	push	bc
	ld	e, -10 (ix)
	ld	d, -9 (ix)
	ld	hl, #0x0008
	add	hl, sp
	ld	bc, #0x0004
	ldir
	call	_http_recv_block
	pop	af
00111$:
;http.c:414: }
	ld	sp, ix
	pop	ix
	ret
___str_29:
	.ascii "500"
	.db 0x00
___str_30:
	.ascii "Internal Server Error - unable to write file"
	.db 0x00
;http.c:417: static void http_recv_block(HTTP *http)
;	---------------------------------
; Function http_recv_block
; ---------------------------------
_http_recv_block:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;http.c:419: if ( http->content_length == 0 )
	ld	a, 4 (ix)
	ld	-10 (ix), a
	ld	a, 5 (ix)
	ld	-9 (ix), a
	pop	hl
	push	hl
	ld	de, #0x02aa
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, d
	or	a, e
	or	a, b
	or	a, c
	jr	NZ,00104$
;http.c:420: http_send_ok_response(http, NULL, (NF)http_close_and_disconnect);
	ld	bc, #_http_close_and_disconnect
	push	bc
	ld	hl, #0x0000
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	_http_send_ok_response
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	jp	00106$
00104$:
;http.c:423: SOCKET *socket = http->socket_alloc.socket;
	pop	hl
	push	hl
	push	bc
	ld	bc, #0x0007
	add	hl, bc
	pop	bc
	ld	a, (hl)
	ld	-8 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-7 (ix), a
;http.c:424: HTTPBLOCK *httpblock = &(http->httpblock);
	ld	a, -10 (ix)
	add	a, #0x17
	ld	-6 (ix), a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
;http.c:425: dword length = http->content_length;
	ld	-4 (ix), c
	ld	-3 (ix), b
	ld	-2 (ix), e
	ld	-1 (ix), d
;http.c:426: if ( length > 128 )
	ld	a, #0x80
	cp	a, -4 (ix)
	ld	a, #0x00
	sbc	a, -3 (ix)
	ld	a, #0x00
	sbc	a, -2 (ix)
	ld	a, #0x00
	sbc	a, -1 (ix)
	jr	NC,00102$
;http.c:427: length = 128;
	ld	-4 (ix), #0x80
	xor	a, a
	ld	-3 (ix), a
	ld	-2 (ix), a
	ld	-1 (ix), a
00102$:
;http.c:428: httpblock_recv(httpblock, socket, http->buffer, (byte) length, (NF)http_rcvd_block, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	bc, #_http_rcvd_block
	ld	a, -4 (ix)
	ld	-1 (ix), a
	ld	a, -10 (ix)
	add	a, #0xad
	ld	e, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	d, a
	push	hl
	push	bc
	ld	a, -1 (ix)
	push	af
	inc	sp
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	_httpblock_recv
	ld	hl, #11
	add	hl, sp
	ld	sp, hl
00106$:
;http.c:430: }
	ld	sp, ix
	pop	ix
	ret
;http.c:433: static void http_do_post(HTTP *http)
;	---------------------------------
; Function http_do_post
; ---------------------------------
_http_do_post:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:435: log_printf("http_do_post: $");
	ld	hl, #___str_31
	push	hl
	call	_log_printf
	pop	af
;http.c:436: log_strn(http->fcb.filename, 8);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0089
	add	hl, bc
	ex	de, hl
	ld	hl, #0x008a
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	push	bc
	push	de
	ld	hl, #0x0008
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_log_strn
	pop	af
	ld	hl, #___str_32
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;http.c:438: log_strn(http->fcb.type, 3);
	ld	hl, #0x0092
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	push	bc
	push	de
	ld	hl, #0x0003
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_log_strn
	pop	af
	ld	hl, #___str_33
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	de
	pop	bc
;http.c:440: if ( http->content_length == ((dword)0xffffffffUL) )
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x02aa
	add	hl, bc
	pop	bc
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, -4 (ix)
	and	a, -3 (ix)
	and	a, -2 (ix)
	and	a, -1 (ix)
	inc	a
	jr	NZ,00105$
;http.c:441: http_send_error_response(http, "411", "Length Required", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_35
	push	hl
	ld	hl, #___str_34
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00107$
00105$:
;http.c:445: bdos_delete_files(&(http->fcb));
	push	bc
	push	de
	push	de
	call	_bdos_delete_files
	pop	af
	pop	de
	pop	bc
;http.c:446: http->fcb.ex = 0;
	ld	hl, #0x0095
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	(hl), #0x00
;http.c:447: http->fcb.s1 = 0;
	ld	hl, #0x0096
	add	hl, bc
	ld	(hl), #0x00
;http.c:448: http->fcb.s2 = 0;
	ld	hl, #0x0097
	add	hl, bc
	ld	(hl), #0x00
;http.c:449: http->fcb.rc = 0;
	ld	hl, #0x0098
	add	hl, bc
	ld	(hl), #0x00
;http.c:450: if ( bdos_create_file(&(http->fcb)) == 255 )
	push	bc
	push	de
	call	_bdos_create_file
	pop	af
	pop	bc
	inc	l
	jr	NZ,00102$
;http.c:451: http_send_error_response(http, "500", "Internal Server Error - can't create file", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_37
	push	hl
	ld	hl, #___str_36
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00107$
00102$:
;http.c:454: http->fcb.ex = 0;
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), #0x00
;http.c:455: http->fcb.cr = 0;
	ld	hl, #0x00a9
	add	hl, bc
	ld	(hl), #0x00
;http.c:456: http_recv_block(http);
	push	bc
	call	_http_recv_block
	pop	af
00107$:
;http.c:459: }
	ld	sp, ix
	pop	ix
	ret
___str_31:
	.ascii "http_do_post: $"
	.db 0x00
___str_32:
	.ascii ".$"
	.db 0x00
___str_33:
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
___str_34:
	.ascii "411"
	.db 0x00
___str_35:
	.ascii "Length Required"
	.db 0x00
___str_36:
	.ascii "500"
	.db 0x00
___str_37:
	.ascii "Internal Server Error - can't create file"
	.db 0x00
;http.c:462: static void http_do_delete(HTTP *http)
;	---------------------------------
; Function http_do_delete
; ---------------------------------
_http_do_delete:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;http.c:465: log_printf("http_do_delete: $");
	ld	hl, #___str_38
	push	hl
	call	_log_printf
	pop	af
;http.c:466: log_strn(http->fcb.filename, 8);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0089
	add	hl, bc
	ex	(sp), hl
	ld	hl, #0x008a
	add	hl, bc
	push	bc
	ld	de, #0x0008
	push	de
	push	hl
	call	_log_strn
	pop	af
	ld	hl, #___str_39
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	bc
;http.c:468: log_strn(http->fcb.type, 3);
	ld	hl, #0x0092
	add	hl, bc
	push	bc
	ld	de, #0x0003
	push	de
	push	hl
	call	_log_strn
	pop	af
	ld	hl, #___str_40
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	de
	pop	hl
	push	hl
	push	de
	push	hl
	call	_bdos_delete_files
	pop	af
	pop	bc
;http.c:471: http_send_ok_response(http, NULL, (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #0x0000
	push	hl
	push	bc
	call	_http_send_ok_response
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;http.c:472: }
	ld	sp, ix
	pop	ix
	ret
___str_38:
	.ascii "http_do_delete: $"
	.db 0x00
___str_39:
	.ascii ".$"
	.db 0x00
___str_40:
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;http.c:476: static dword http_parse_number(const byte *p)
;	---------------------------------
; Function http_parse_number
; ---------------------------------
_http_parse_number:
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-9
	add	hl, sp
	ld	sp, hl
;http.c:478: dword n = 0;
	xor	a, a
	ld	-9 (ix), a
	ld	-8 (ix), a
	ld	-7 (ix), a
	ld	-6 (ix), a
;http.c:479: while ( *p == ' ' )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
00101$:
	ld	a, (bc)
	sub	a, #0x20
	jr	NZ,00114$
;http.c:480: p++;
	inc	bc
	jr	00101$
;http.c:481: while ( *p >= '0' && *p <= '9' )
00114$:
00105$:
	ld	a, (bc)
	ld	-5 (ix), a
	sub	a, #0x30
	jr	C,00107$
	ld	a, #0x39
	sub	a, -5 (ix)
	jr	C,00107$
;http.c:483: n *= 10;
	push	bc
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	push	hl
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x000a
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;http.c:484: n += ( *p++ - '0' );
	ld	e, -5 (ix)
	inc	bc
	ld	d, #0x00
	ld	a, e
	add	a, #0xd0
	ld	e, a
	ld	a, d
	adc	a, #0xff
	ld	d, a
	rla
	sbc	a, a
	ld	l, a
	ld	h, a
	ld	a, -4 (ix)
	add	a, e
	ld	-9 (ix), a
	ld	a, -3 (ix)
	adc	a, d
	ld	-8 (ix), a
	ld	a, -2 (ix)
	adc	a, l
	ld	-7 (ix), a
	ld	a, -1 (ix)
	adc	a, h
	ld	-6 (ix), a
	jr	00105$
00107$:
;http.c:486: return n;
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	ld	e, -7 (ix)
	ld	d, -6 (ix)
;http.c:487: }
	ld	sp, ix
	pop	ix
	ret
;http.c:492: static void http_rcvd_request_header(HTTP *http)
;	---------------------------------
; Function http_rcvd_request_header
; ---------------------------------
_http_rcvd_request_header:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:494: HTTPLINE *httpline = &(http->httpline);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0009
	add	hl, bc
	ex	de, hl
;http.c:495: if ( httpline->state != HTTPLINE_STATE_OK )
	ld	l, e
	ld	h, d
	push	bc
	ld	bc, #0x000d
	add	hl, bc
	pop	bc
	ld	a, (hl)
	ld	-1 (ix), a
	or	a, a
	jr	Z,00112$
;http.c:496: http_disconnect(http);
	push	bc
	call	_http_disconnect
	pop	af
	jp	00114$
00112$:
;http.c:497: else if ( httpline->actual != 2 )
	ex	de,hl
	ld	de, #0x000c
	add	hl, de
	ld	a, (hl)
	sub	a, #0x02
	jr	Z,00109$
;http.c:500: int mc = memcmp(http->buffer, "Content-Length:", 15);
	ld	hl, #0x00ad
	add	hl, bc
	push	bc
	ld	de, #0x000f
	push	de
	ld	de, #___str_41
	push	de
	push	hl
	call	_memcmp
	pop	af
	pop	af
	pop	af
	pop	bc
;http.c:504: if ( !mc )
	ld	a, h
	or	a, l
	jr	NZ,00102$
;http.c:506: http->content_length = http_parse_number(http->buffer+15);
	ld	hl, #0x02aa
	add	hl, bc
	ex	de, hl
	ld	hl, #0x00bc
	add	hl, bc
	push	bc
	push	de
	push	hl
	call	_http_parse_number
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	ld	hl, #0x0002
	add	hl, sp
	ld	bc, #0x0004
	ldir
	pop	bc
00102$:
;http.c:509: http_recv_request_header(http);
	push	bc
	call	_http_recv_request_header
	pop	af
	jr	00114$
00109$:
;http.c:512: switch ( http->verb )
	ld	l, c
	ld	h, b
	ld	de, #0x02a9
	add	hl, de
	ld	a, (hl)
	or	a, a
	jr	Z,00103$
	cp	a, #0x01
	jr	Z,00104$
	cp	a, #0x02
	jr	Z,00105$
	sub	a, #0x03
	jr	Z,00106$
	jr	00114$
;http.c:514: case HTTP_VERB_GET:
00103$:
;http.c:515: http_do_get(http);
	push	bc
	call	_http_do_get
	pop	af
;http.c:516: break;
	jr	00114$
;http.c:517: case HTTP_VERB_POST:
00104$:
;http.c:518: http_do_post(http);
	push	bc
	call	_http_do_post
	pop	af
;http.c:519: break;
	jr	00114$
;http.c:520: case HTTP_VERB_DELETE:
00105$:
;http.c:521: http_do_delete(http);
	push	bc
	call	_http_do_delete
	pop	af
;http.c:522: break;
	jr	00114$
;http.c:523: case HTTP_VERB_INDEX:
00106$:
;http.c:524: http_do_index(http);
	push	bc
	call	_http_do_index
	pop	af
;http.c:526: }
00114$:
;http.c:527: }
	ld	sp, ix
	pop	ix
	ret
___str_41:
	.ascii "Content-Length:"
	.db 0x00
;http.c:530: static void http_recv_request_header(HTTP *http)
;	---------------------------------
; Function http_recv_request_header
; ---------------------------------
_http_recv_request_header:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:532: SOCKET *socket = http->socket_alloc.socket;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	l, e
	ld	h, d
	ld	bc, #0x0007
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;http.c:533: HTTPLINE *httpline = &(http->httpline);
	ld	hl, #0x0009
	add	hl, de
	ex	(sp), hl
;http.c:534: httpline_recv(httpline, socket, http->buffer, HTTP_MAX_REQUEST_HEADER, (NF)http_rcvd_request_header, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	-2 (ix), #<(_http_rcvd_request_header)
	ld	-1 (ix), #>(_http_rcvd_request_header)
	ld	a, e
	add	a, #0xad
	ld	e, a
	jr	NC,00103$
	inc	d
00103$:
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	a, #0xff
	push	af
	inc	sp
	push	de
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	_httpline_recv
	ld	hl, #11
	add	hl, sp
	ld	sp, hl
;http.c:535: }
	ld	sp, ix
	pop	ix
	ret
;http.c:548: static BOOLEAN http_verb_is_get(const byte *line)
;	---------------------------------
; Function http_verb_is_get
; ---------------------------------
_http_verb_is_get:
;http.c:550: return line[0] == 'G' &&
	pop	de
	pop	bc
	push	bc
	push	de
	ld	a, (bc)
	sub	a, #0x47
	jr	NZ,00103$
;http.c:551: line[1] == 'E' &&
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	sub	a, #0x45
	jr	NZ,00103$
;http.c:552: line[2] == 'T' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x54
	jr	NZ,00103$
;http.c:553: line[3] == ' ' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00103$
;http.c:554: line[4] == '/' ;
	ld	l, c
	ld	h, b
	ld	de, #0x0004
	add	hl, de
	ld	a, (hl)
	sub	a, #0x2f
	jr	Z,00104$
00103$:
	ld	l, #0x00
	jr	00105$
00104$:
	ld	l, #0x01
00105$:
	ld	h, #0x00
;http.c:555: }
	ret
;http.c:558: static BOOLEAN http_verb_is_post(const byte *line)
;	---------------------------------
; Function http_verb_is_post
; ---------------------------------
_http_verb_is_post:
;http.c:560: return line[0] == 'P' &&
	pop	de
	pop	bc
	push	bc
	push	de
	ld	a, (bc)
	sub	a, #0x50
	jr	NZ,00103$
;http.c:561: line[1] == 'O' &&
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	sub	a, #0x4f
	jr	NZ,00103$
;http.c:562: line[2] == 'S' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x53
	jr	NZ,00103$
;http.c:563: line[3] == 'T' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x54
	jr	NZ,00103$
;http.c:564: line[4] == ' ' &&
	ld	l, c
	ld	h, b
	ld	de, #0x0004
	add	hl, de
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00103$
;http.c:565: line[5] == '/' ;
	ld	l, c
	ld	h, b
	ld	de, #0x0005
	add	hl, de
	ld	a, (hl)
	sub	a, #0x2f
	jr	Z,00104$
00103$:
	ld	l, #0x00
	jr	00105$
00104$:
	ld	l, #0x01
00105$:
	ld	h, #0x00
;http.c:566: }
	ret
;http.c:569: static BOOLEAN http_verb_is_delete(const byte *line)
;	---------------------------------
; Function http_verb_is_delete
; ---------------------------------
_http_verb_is_delete:
;http.c:571: return line[0] == 'D' &&
	pop	de
	pop	bc
	push	bc
	push	de
	ld	a, (bc)
	sub	a, #0x44
	jr	NZ,00103$
;http.c:572: line[1] == 'E' &&
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	sub	a, #0x45
	jr	NZ,00103$
;http.c:573: line[2] == 'L' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x4c
	jr	NZ,00103$
;http.c:574: line[3] == 'E' &&
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x45
	jr	NZ,00103$
;http.c:575: line[4] == 'T' &&
	ld	l, c
	ld	h, b
	ld	de, #0x0004
	add	hl, de
	ld	a, (hl)
	sub	a, #0x54
	jr	NZ,00103$
;http.c:576: line[5] == 'E' &&
	ld	l, c
	ld	h, b
	ld	de, #0x0005
	add	hl, de
	ld	a, (hl)
	sub	a, #0x45
	jr	NZ,00103$
;http.c:577: line[6] == ' ' &&
	ld	l, c
	ld	h, b
	ld	de, #0x0006
	add	hl, de
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00103$
;http.c:578: line[7] == '/' ;
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	sub	a, #0x2f
	jr	Z,00104$
00103$:
	ld	l, #0x00
	jr	00105$
00104$:
	ld	l, #0x01
00105$:
	ld	h, #0x00
;http.c:579: }
	ret
;http.c:583: static BOOLEAN http_valid_filename_char(byte b)
;	---------------------------------
; Function http_valid_filename_char
; ---------------------------------
_http_valid_filename_char:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:585: return ( b >= '0' && b <= '9' )
	ld	a, 4 (ix)
	sub	a, #0x30
	jr	C,00111$
	ld	a, #0x39
	sub	a, 4 (ix)
	jr	NC,00104$
00111$:
;http.c:586: || ( b >= 'A' && b <= 'Z' )
	ld	a, 4 (ix)
	sub	a, #0x41
	jr	C,00108$
	ld	a, #0x5a
	sub	a, 4 (ix)
	jr	NC,00104$
00108$:
;http.c:587: || ( b >= 'a' && b <= 'z' )
	ld	a, 4 (ix)
	sub	a, #0x61
	jr	C,00103$
	ld	a, #0x7a
	sub	a, 4 (ix)
	jr	NC,00104$
00103$:
	ld	l, #0x00
	jr	00105$
00104$:
	ld	l, #0x01
00105$:
	ld	h, #0x00
;http.c:589: }
	pop	ix
	ret
;http.c:592: static char http_canonical_filename_char(byte b)
;	---------------------------------
; Function http_canonical_filename_char
; ---------------------------------
_http_canonical_filename_char:
;http.c:594: return ( b >= 'a' && b <= 'z' ) ? ( b & ~0x20 ) : b;
	ld	iy, #2
	add	iy, sp
	ld	a, 0 (iy)
	sub	a, #0x61
	jr	C,00103$
	ld	a, #0x7a
	sub	a, 0 (iy)
	jr	C,00103$
	ld	l, 0 (iy)
	res	5, l
	ret
00103$:
	ld	iy, #2
	add	iy, sp
	ld	l, 0 (iy)
;http.c:595: }
	ret
;http.c:598: static BOOLEAN http_parse_filename(const byte *line, FCB *fcb)
;	---------------------------------
; Function http_parse_filename
; ---------------------------------
_http_parse_filename:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;http.c:601: fcb->drive = 0;
	ld	a, 6 (ix)
	ld	-3 (ix), a
	ld	a, 7 (ix)
	ld	-2 (ix), a
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	(hl), #0x00
;http.c:602: if ( *line == ' ' || *line == '?' || *line == '\r' )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, (bc)
	cp	a, #0x20
	jr	Z,00101$
	cp	a, #0x3f
	jr	Z,00101$
	sub	a, #0x0d
	jr	NZ,00135$
00101$:
;http.c:603: line = home; // "index.htm ";
	ld	4 (ix), #<(_home)
	ld	5 (ix), #>(_home)
;http.c:604: i = 0;
00135$:
	ld	c, -3 (ix)
	ld	b, -2 (ix)
	inc	bc
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	xor	a, a
	ld	-1 (ix), a
00117$:
;http.c:605: for ( ; i < 8 && http_valid_filename_char(*line); i++ )
	ld	a, -1 (ix)
	sub	a, #0x08
	jr	NC,00147$
	ld	a, (de)
	push	bc
	push	de
	push	af
	inc	sp
	call	_http_valid_filename_char
	inc	sp
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00147$
;http.c:606: fcb->filename[i] = http_canonical_filename_char(*line++);
	ld	a, c
	add	a, -1 (ix)
	ld	-5 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-4 (ix), a
	ld	a, (de)
	inc	de
	push	bc
	push	de
	push	af
	inc	sp
	call	_http_canonical_filename_char
	inc	sp
	ld	a, l
	pop	de
	pop	bc
	pop	hl
	push	hl
	ld	(hl), a
;http.c:605: for ( ; i < 8 && http_valid_filename_char(*line); i++ )
	inc	-1 (ix)
	jr	00117$
00147$:
	ld	4 (ix), e
	ld	5 (ix), d
	ld	e, -1 (ix)
00120$:
;http.c:607: for ( ; i < 8; i++ )
	ld	a, e
	sub	a, #0x08
	jr	NC,00106$
;http.c:608: fcb->filename[i] = ' ';
	ld	l, e
	ld	h, #0x00
	add	hl, bc
	ld	(hl), #0x20
;http.c:607: for ( ; i < 8; i++ )
	inc	e
	jr	00120$
00106$:
;http.c:609: i = 0;
	xor	a, a
	ld	-1 (ix), a
;http.c:610: if ( *line == '.' )
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	c, (hl)
;http.c:612: line++;
	ld	a, -3 (ix)
	add	a, #0x09
	ld	e, a
	ld	a, -2 (ix)
	adc	a, #0x00
	ld	d, a
;http.c:610: if ( *line == '.' )
	ld	a, c
	sub	a, #0x2e
	jr	NZ,00143$
;http.c:612: line++;
	inc	hl
	ld	4 (ix), l
	ld	5 (ix), h
	inc	sp
	inc	sp
	push	de
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	xor	a, a
	ld	-1 (ix), a
00124$:
;http.c:613: for ( ; i < 3 && http_valid_filename_char(*line); i++ )
	ld	a, -1 (ix)
	sub	a, #0x03
	jr	NC,00149$
	ld	a, (bc)
	push	bc
	push	de
	push	af
	inc	sp
	call	_http_valid_filename_char
	inc	sp
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00149$
;http.c:614: fcb->type[i] = http_canonical_filename_char(*line++);
	ld	a, -5 (ix)
	add	a, -1 (ix)
	ld	-3 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	a, (bc)
	inc	bc
	push	bc
	push	de
	push	af
	inc	sp
	call	_http_canonical_filename_char
	inc	sp
	ld	a, l
	pop	de
	pop	bc
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	ld	(hl), a
;http.c:613: for ( ; i < 3 && http_valid_filename_char(*line); i++ )
	inc	-1 (ix)
	jr	00124$
00149$:
	ld	4 (ix), c
	ld	5 (ix), b
00143$:
	ld	c, -1 (ix)
00127$:
;http.c:616: for ( ; i < 3; i++ )
	ld	a, c
	sub	a, #0x03
	jr	NC,00110$
;http.c:617: fcb->type[i] = ' ';
	ld	l, c
	ld	h, #0x00
	add	hl, de
	ld	(hl), #0x20
;http.c:616: for ( ; i < 3; i++ )
	inc	c
	jr	00127$
00110$:
;http.c:618: if ( *line != ' ' && *line != '?' && *line != '\r' )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	a, (bc)
	cp	a, #0x20
	jr	Z,00112$
	cp	a, #0x3f
	jr	Z,00112$
	sub	a, #0x0d
	jr	Z,00112$
;http.c:619: return FALSE;
	ld	hl, #0x0000
	jr	00129$
00112$:
;http.c:620: return TRUE;
	ld	hl, #0x0001
00129$:
;http.c:621: }	
	ld	sp, ix
	pop	ix
	ret
;http.c:624: static void http_rcvd_request(HTTP *http)
;	---------------------------------
; Function http_rcvd_request
; ---------------------------------
_http_rcvd_request:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;http.c:626: HTTPLINE *httpline = &(http->httpline);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0009
	add	hl, bc
;http.c:627: FCB *fcb = &(http->fcb);
	ld	a, c
	add	a, #0x89
	ld	-5 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-4 (ix), a
;http.c:628: if ( httpline->state != HTTPLINE_STATE_OK )
	ld	de, #0x000d
	add	hl, de
	ld	e, (hl)
	ld	a, e
	or	a, a
	jr	Z,00132$
;http.c:629: http_disconnect(http);
	push	bc
	call	_http_disconnect
	pop	af
	jp	00134$
00132$:
;http.c:630: else if ( http_verb_is_get(http->request) )
	ld	hl, #0x0025
	add	hl, bc
	ex	de, hl
	push	bc
	push	de
	push	de
	call	_http_verb_is_get
	pop	af
	pop	de
	pop	bc
;http.c:634: http->verb = HTTP_VERB_INDEX;
	ld	a, c
	add	a, #0xa9
	ld	-3 (ix), a
	ld	a, b
	adc	a, #0x02
	ld	-2 (ix), a
;http.c:630: else if ( http_verb_is_get(http->request) )
	ld	a, h
	or	a, l
	jr	Z,00129$
;http.c:632: if ((http->request[5] == '?') || (home[0] == '\0' ) && ((http->request[5] == ' ') || (http->request[5] == '\r')))
	ld	hl, #0x002a
	add	hl, bc
	ex	de, hl
	ld	a, (de)
	ld	-1 (ix), a
	sub	a, #0x3f
	jr	Z,00104$
	ld	a, (#_home + 0)
	or	a, a
	jr	NZ,00105$
	ld	a, -1 (ix)
	sub	a, #0x20
	jr	Z,00104$
	ld	a, -1 (ix)
	sub	a, #0x0d
	jr	NZ,00105$
00104$:
;http.c:634: http->verb = HTTP_VERB_INDEX;
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), #0x03
;http.c:635: http_recv_request_header(http);
	push	bc
	call	_http_recv_request_header
	pop	af
	jp	00134$
00105$:
;http.c:637: else if ( ! http_parse_filename(http->request+5, fcb) )
	push	bc
	ld	l, -5 (ix)
	ld	h, -4 (ix)
	push	hl
	push	de
	call	_http_parse_filename
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00102$
;http.c:638: http_send_error_response(http, "400", "Bad Request - bad filename", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_43
	push	hl
	ld	hl, #___str_42
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jp	00134$
00102$:
;http.c:641: http->verb = HTTP_VERB_GET;
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), #0x00
;http.c:642: http_recv_request_header(http);
	push	bc
	call	_http_recv_request_header
	pop	af
	jp	00134$
00129$:
;http.c:645: else if ( http_verb_is_post(http->request) )
	push	bc
	push	de
	push	de
	call	_http_verb_is_post
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00126$
;http.c:647: if ( ! http->allow_post )
	ld	l, c
	ld	h, b
	ld	de, #0x02a3
	add	hl, de
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	jr	NZ,00114$
;http.c:648: http_send_error_response(http, "405", "Method Not Allowed", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_45
	push	hl
	ld	hl, #___str_44
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jp	00134$
00114$:
;http.c:649: else if ( ! http_parse_filename(http->request+6, fcb) )
	ld	hl, #0x002b
	add	hl, bc
	push	bc
	ld	e, -5 (ix)
	ld	d, -4 (ix)
	push	de
	push	hl
	call	_http_parse_filename
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00111$
;http.c:650: http_send_error_response(http, "400", "Bad Request - bad filename", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_43
	push	hl
	ld	hl, #___str_42
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jp	00134$
00111$:
;http.c:653: http->verb = HTTP_VERB_POST;
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), #0x01
;http.c:654: http->content_length = ((dword)0xffffffffUL);
	ld	hl, #0x02aa
	add	hl, bc
	ld	(hl), #0xff
	inc	hl
	ld	(hl), #0xff
	inc	hl
	ld	(hl), #0xff
	inc	hl
	ld	(hl), #0xff
;http.c:655: http_recv_request_header(http);
	push	bc
	call	_http_recv_request_header
	pop	af
	jp	00134$
00126$:
;http.c:658: else if ( http_verb_is_delete(http->request) )
	push	bc
	push	de
	call	_http_verb_is_delete
	pop	af
	pop	bc
;http.c:638: http_send_error_response(http, "400", "Bad Request - bad filename", (NF)http_disconnect);
	ld	de, #_http_disconnect
;http.c:658: else if ( http_verb_is_delete(http->request) )
	ld	a, h
	or	a, l
	jr	Z,00123$
;http.c:660: if ( ! http->allow_delete )
	ld	l, c
	ld	h, b
	push	bc
	ld	bc, #0x02a6
	add	hl, bc
	pop	bc
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	or	a, l
	jr	NZ,00120$
;http.c:661: http_send_error_response(http, "405", "Method Not Allowed", (NF)http_disconnect);
	push	de
	ld	hl, #___str_45
	push	hl
	ld	hl, #___str_44
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00134$
00120$:
;http.c:662: else if ( ! http_parse_filename(http->request+8, fcb) )
	ld	hl, #0x002d
	add	hl, bc
	push	bc
	ld	e, -5 (ix)
	ld	d, -4 (ix)
	push	de
	push	hl
	call	_http_parse_filename
	pop	af
	pop	af
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00117$
;http.c:663: http_send_error_response(http, "400", "Bad Request - bad filename", (NF)http_disconnect);
	ld	de, #_http_disconnect
	push	de
	ld	hl, #___str_43
	push	hl
	ld	hl, #___str_42
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	jr	00134$
00117$:
;http.c:666: http->verb = HTTP_VERB_DELETE;
	pop	de
	pop	hl
	push	hl
	push	de
	ld	(hl), #0x02
;http.c:667: http_recv_request_header(http);			
	push	bc
	call	_http_recv_request_header
	pop	af
	jr	00134$
00123$:
;http.c:671: http_send_error_response(http, "500", "Not Implemented", (NF)http_disconnect);
	push	de
	ld	hl, #___str_47
	push	hl
	ld	hl, #___str_46
	push	hl
	push	bc
	call	_http_send_error_response
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
00134$:
;http.c:672: }
	ld	sp, ix
	pop	ix
	ret
___str_42:
	.ascii "400"
	.db 0x00
___str_43:
	.ascii "Bad Request - bad filename"
	.db 0x00
___str_44:
	.ascii "405"
	.db 0x00
___str_45:
	.ascii "Method Not Allowed"
	.db 0x00
___str_46:
	.ascii "500"
	.db 0x00
___str_47:
	.ascii "Not Implemented"
	.db 0x00
;http.c:675: static void http_connected(HTTP *http)
;	---------------------------------
; Function http_connected
; ---------------------------------
_http_connected:
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:677: SOCKET *socket = http->socket_alloc.socket;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;http.c:678: HTTPLINE *httpline = &(http->httpline);
	ld	hl, #0x0009
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
;http.c:679: log_printf("http_connected:\r\n$");
	push	bc
	ld	hl, #___str_48
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;http.c:680: httpline_recv(httpline, socket, http->request, HTTP_MAX_REQUEST, (NF)http_rcvd_request, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_http_rcvd_request
	ld	a, c
	add	a, #0x25
	ld	c, a
	jr	NC,00103$
	inc	b
00103$:
	push	hl
	push	de
	ld	a, #0x64
	push	af
	inc	sp
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	_httpline_recv
	ld	hl, #11
	add	hl, sp
	ld	sp, hl
;http.c:681: }
	ld	sp, ix
	pop	ix
	ret
___str_48:
	.ascii "http_connected:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;http.c:684: static void http_listen(HTTP *http)
;	---------------------------------
; Function http_listen
; ---------------------------------
_http_listen:
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:686: SOCKET *socket = http->socket_alloc.socket;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;http.c:687: log_printf("http_listen:\r\n$");
	push	bc
	ld	hl, #___str_49
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;http.c:688: net_listen(socket, HTTP_PORT, (NF)http_connected, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_http_connected
	push	hl
	push	de
	ld	hl, #0x0050
	push	hl
	push	bc
	call	_net_listen
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;http.c:689: }
	pop	ix
	ret
___str_49:
	.ascii "http_listen:"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;http.c:692: void http_start(HTTP *http)
;	---------------------------------
; Function http_start
; ---------------------------------
_http_start::
	push	ix
	ld	ix,#0
	add	ix,sp
;http.c:694: http->socket_alloc.fiber.queued = 0;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x00
;http.c:695: http->httpline.fiber.queued = 0;
	ld	hl, #0x0014
	add	hl, bc
	ld	(hl), #0x00
;http.c:696: http->httpblock.fiber.queued = 0;
	ld	hl, #0x0021
	add	hl, bc
	ld	(hl), #0x00
;http.c:697: net_alloc(&(http->socket_alloc), (NF)http_listen, http);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	de, #_http_listen
	push	hl
	push	de
	push	bc
	call	_net_alloc
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;http.c:698: }
	pop	ix
	ret
;http.c:701: void http_init(void)
;	---------------------------------
; Function http_init
; ---------------------------------
_http_init::
;http.c:703: }
	ret
;http.c:706: const char * set_home (const char *ps, const char *cend)
;	---------------------------------
; Function set_home
; ---------------------------------
_set_home::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;http.c:708: char *ph = home;
	ld	bc, #_home+0
;http.c:709: while ((ps < cend) && (*ps <= ' ')) ++ps;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
00102$:
	ld	a, e
	sub	a, 6 (ix)
	ld	a, d
	sbc	a, 7 (ix)
	jr	NC,00127$
	ld	a, (de)
	ld	l, a
	ld	a, #0x20
	sub	a, l
	jr	C,00127$
	inc	de
	jr	00102$
00127$:
	ld	4 (ix), e
	ld	5 (ix), d
;http.c:710: if (ps == cend) return ps;
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	cp	a, a
	sbc	hl, de
	jr	NZ,00106$
	ex	de,hl
	jr	00116$
00106$:
;http.c:711: int n = 8;
	ld	hl, #0x0008
	ex	(sp), hl
;http.c:712: while (ps < cend)
	ld	-2 (ix), c
	ld	-1 (ix), b
00113$:
	ld	a, e
	sub	a, 6 (ix)
	ld	a, d
	sbc	a, 7 (ix)
	jr	NC,00115$
;http.c:714: if (*ps <= ' ') break;
	ld	a, (de)
	ld	h, a
	ld	a, #0x20
	sub	a, h
	jr	NC,00115$
;http.c:715: if (*ps == '.') n = 4;
	ld	a, h
	sub	a, #0x2e
	jr	NZ,00110$
	ld	-4 (ix), #0x04
	xor	a, a
	ld	-3 (ix), a
00110$:
;http.c:716: if ( n == 0 )
	ld	a, -3 (ix)
	or	a, -4 (ix)
	jr	NZ,00112$
;http.c:718: log_fatal ("Invalid home file\r\n$");
	push	bc
	ld	hl, #___str_50
	push	hl
	call	_log_fatal
	pop	af
	pop	bc
;http.c:719: break;
	jr	00115$
00112$:
;http.c:721: *ph = http_canonical_filename_char(*ps);
	push	de
	push	hl
	inc	sp
	call	_http_canonical_filename_char
	inc	sp
	ld	a, l
	pop	de
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	(hl), a
;http.c:722: ++ps;
	inc	de
	ld	4 (ix), e
	ld	5 (ix), d
;http.c:723: ++ph;
	inc	-2 (ix)
	jr	NZ,00168$
	inc	-1 (ix)
00168$:
	ld	c, -2 (ix)
	ld	b, -1 (ix)
;http.c:724: --n;
	pop	hl
	push	hl
	dec	hl
	ex	(sp), hl
	jr	00113$
00115$:
;http.c:726: *ph = ' ';
	ld	a, #0x20
	ld	(bc), a
;http.c:727: ++ph;
	inc	bc
;http.c:728: *ph = '\0';
	xor	a, a
	ld	(bc), a
;http.c:729: return ps;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
00116$:
;http.c:730: }
	ld	sp, ix
	pop	ix
	ret
___str_50:
	.ascii "Invalid home file"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _CODE
___str_53:
	.ascii "HTM"
	.db 0x00
___str_54:
	.ascii "text/html"
	.db 0x00
___str_55:
	.ascii "CSS"
	.db 0x00
___str_56:
	.ascii "text/css"
	.db 0x00
___str_57:
	.ascii "JS "
	.db 0x00
___str_58:
	.ascii "text/javascript"
	.db 0x00
___str_59:
	.ascii "TXT"
	.db 0x00
___str_60:
	.ascii "text/plain"
	.db 0x00
___str_61:
	.ascii "SUB"
	.db 0x00
___str_62:
	.ascii "DOC"
	.db 0x00
___str_63:
	.ascii "XML"
	.db 0x00
___str_64:
	.ascii "text/xml"
	.db 0x00
___str_65:
	.ascii "GIF"
	.db 0x00
___str_66:
	.ascii "image/gif"
	.db 0x00
___str_67:
	.ascii "PNG"
	.db 0x00
___str_68:
	.ascii "image/png"
	.db 0x00
___str_69:
	.ascii "JPG"
	.db 0x00
___str_70:
	.ascii "image/jpeg"
	.db 0x00
___str_71:
	.ascii "TIF"
	.db 0x00
___str_72:
	.ascii "image/tiff"
	.db 0x00
___str_73:
	.ascii "PDF"
	.db 0x00
___str_74:
	.ascii "application/pdf"
	.db 0x00
___str_75:
	.ascii "COM"
	.db 0x00
___str_76:
	.ascii "application/octet-stream"
	.db 0x00
___str_77:
	.ascii "OVR"
	.db 0x00
___str_78:
	.ascii "MTX"
	.db 0x00
___str_79:
	.ascii "RUN"
	.db 0x00
___str_80:
	.ascii "BAS"
	.db 0x00
___str_81:
	.ascii "ZIP"
	.db 0x00
___str_82:
	.ascii "application/x-zip-compressed"
	.db 0x00
	.area _INITIALIZER
__xinit__home:
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
__xinit__mime_ofs:
	.dw ___str_53
	.dw ___str_54
	.dw ___str_55
	.dw ___str_56
	.dw ___str_57
	.dw ___str_58
	.dw ___str_59
	.dw ___str_60
	.dw ___str_61
	.dw ___str_60
	.dw ___str_62
	.dw ___str_60
	.dw ___str_63
	.dw ___str_64
	.dw ___str_65
	.dw ___str_66
	.dw ___str_67
	.dw ___str_68
	.dw ___str_69
	.dw ___str_70
	.dw ___str_71
	.dw ___str_72
	.dw ___str_73
	.dw ___str_74
	.dw ___str_75
	.dw ___str_76
	.dw ___str_77
	.dw ___str_76
	.dw ___str_78
	.dw ___str_76
	.dw ___str_79
	.dw ___str_76
	.dw ___str_80
	.dw ___str_76
	.dw ___str_81
	.dw ___str_82
	.area _CABS (ABS)
