;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module httpd
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _parse
	.globl _quit
	.globl _log_close
	.globl _log_open
	.globl _log_fatal
	.globl _http_init
	.globl _http_start
	.globl _set_home
	.globl _net_handle_interrupts
	.globl _net_init
	.globl _bdos_printf
	.globl _bdos_inkey
	.globl _bdos_exit
	.globl _fiber_drain
	.globl _fiber_enqueue
	.globl _fiber_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_http:
	.ds 2744
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_first_fiber:
	.ds 7
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;httpd.c:30: static void first(void *nfp)
;	---------------------------------
; Function first
; ---------------------------------
_first:
	push	ix
;httpd.c:34: for (i = 0; i < 4; ++i)
	ld	bc, #0x0000
00102$:
;httpd.c:36: http[i].allow_post   = TRUE;
	ld	e, c
	ld	d, b
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	ex	de, hl
	ld	hl, #_http
	add	hl, de
	ex	de, hl
	ld	hl, #0x02a3
	add	hl, de
	ld	(hl), #0x01
	inc	hl
	ld	(hl), #0x00
;httpd.c:37: http[i].allow_delete = TRUE;
	ld	hl, #0x02a5
	add	hl, de
	ld	(hl), #0x01
	inc	hl
	ld	(hl), #0x00
;httpd.c:38: http_start(&http[i]);
	push	bc
	push	de
	call	_http_start
	pop	af
	pop	bc
;httpd.c:34: for (i = 0; i < 4; ++i)
	inc	bc
	ld	a, c
	sub	a, #0x04
	ld	a, b
	rla
	ccf
	rra
	sbc	a, #0x80
	jr	C,00102$
;httpd.c:40: }
	pop	ix
	ret
;httpd.c:44: void quit(void)
;	---------------------------------
; Function quit
; ---------------------------------
_quit::
;httpd.c:46: log_close();
	call	_log_close
;httpd.c:47: bdos_exit();
;httpd.c:48: }
	jp	_bdos_exit
;httpd.c:50: void parse(void)
;	---------------------------------
; Function parse
; ---------------------------------
_parse::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;httpd.c:53: const char *cend = ctail + ctail[0] + 1;
	ld	a, (#0x0080)
	add	a, #0x80
	ld	c, a
	ld	a, #0x00
	adc	a, #0x00
	ld	b, a
	inc	bc
;httpd.c:54: const char *ps = ctail + 1;
	ld	de, #0x0081
;httpd.c:55: while ( ps < cend )
00113$:
	ld	a, e
	sub	a, c
	ld	a, d
	sbc	a, b
	jr	NC,00116$
;httpd.c:57: if ( *ps == ' ' )
	ld	a, (de)
;httpd.c:59: ++ps;
	ld	l, e
	ld	h, d
	inc	hl
;httpd.c:57: if ( *ps == ' ' )
	cp	a, #0x20
	jr	NZ,00111$
;httpd.c:59: ++ps;
	ex	de,hl
	jr	00113$
00111$:
;httpd.c:61: else if ( *ps == '-' )
	sub	a, #0x2d
	jr	NZ,00108$
;httpd.c:63: ++ps;
	ex	de,hl
;httpd.c:64: switch (*ps)
	ld	a, (de)
	ld	-1 (ix), a
;httpd.c:59: ++ps;
	ld	l, e
	ld	h, d
	inc	hl
;httpd.c:64: switch (*ps)
	ld	a, -1 (ix)
	sub	a, #0x48
	jr	Z,00104$
	ld	a, -1 (ix)
	sub	a, #0x4c
	jr	Z,00102$
	ld	a, -1 (ix)
	sub	a, #0x68
	jr	Z,00104$
	ld	a, -1 (ix)
	sub	a, #0x6c
	jr	NZ,00105$
;httpd.c:67: case 'l':
00102$:
;httpd.c:68: ++ps;
;httpd.c:69: ps = log_open (ps, cend);
	push	bc
	push	bc
	push	hl
	call	_log_open
	pop	af
	pop	af
	pop	bc
	ex	de,hl
;httpd.c:70: break;
	jr	00113$
;httpd.c:72: case 'h':
00104$:
;httpd.c:73: ++ps;
;httpd.c:74: ps = set_home (ps, cend);
	push	bc
	push	bc
	push	hl
	call	_set_home
	pop	af
	pop	af
	pop	bc
	ex	de,hl
;httpd.c:75: break;
	jr	00113$
;httpd.c:76: default:
00105$:
;httpd.c:77: log_fatal ("Invalid parameter\r\n$");
	push	bc
	push	de
	ld	hl, #___str_0
	push	hl
	call	_log_fatal
	pop	af
	pop	de
	pop	bc
;httpd.c:78: }
	jr	00113$
00108$:
;httpd.c:82: ps = log_open (ps, cend);
	push	bc
	push	bc
	push	de
	call	_log_open
	pop	af
	pop	af
	pop	bc
	ex	de,hl
	jr	00113$
00116$:
;httpd.c:85: }
	inc	sp
	pop	ix
	ret
___str_0:
	.ascii "Invalid parameter"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;httpd.c:87: int main(void)
;	---------------------------------
; Function main
; ---------------------------------
_main::
;httpd.c:89: bdos_printf("Hypertext Transfer Protocol Daemon" VERSION "\r\n$");
	ld	hl, #___str_1
	push	hl
	call	_bdos_printf
	pop	af
;httpd.c:90: parse();
	call	_parse
;httpd.c:91: fiber_init();
	call	_fiber_init
;httpd.c:93: net_init();
	call	_net_init
;httpd.c:94: http_init();
	call	_http_init
;httpd.c:95: fiber_enqueue(&first_fiber);
	ld	hl, #_first_fiber
	push	hl
	call	_fiber_enqueue
	pop	af
00105$:
;httpd.c:98: if ( bdos_inkey() == 'q' ) quit();
	call	_bdos_inkey
	ld	a, l
	sub	a, #0x71
	jr	NZ,00102$
	call	_quit
00102$:
;httpd.c:99: net_handle_interrupts();
	call	_net_handle_interrupts
;httpd.c:100: fiber_drain();
	call	_fiber_drain
;httpd.c:102: }
	jr	00105$
___str_1:
	.ascii "Hypertext Transfer Protocol Daemonv230307"
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
__xinit__first_fiber:
	.dw #0x0000
	.dw _first
	.dw #0x0000
	.db #0x00	; 0
	.area _CABS (ABS)
