;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module list
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _list_init
	.globl _list_empty
	.globl _list_first
	.globl _list_next
	.globl _list_add_first
	.globl _list_add_last
	.globl _list_add_after
	.globl _list_remove_first
	.globl _list_remove_item
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;list.c:15: void list_init(LIST *list)
;	---------------------------------
; Function list_init
; ---------------------------------
_list_init::
;list.c:17: list->first = NULL;
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	(hl), #0x00
	inc	hl
	ld	(hl), #0x00
	inc	hl
	pop	de
	pop	bc
	push	bc
	push	de
	ld	(hl), c
	inc	hl
	ld	(hl), b
;list.c:19: }
	ret
;list.c:22: BOOLEAN list_empty(LIST *list)
;	---------------------------------
; Function list_empty
; ---------------------------------
_list_empty::
;list.c:24: return list->first != NULL;
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	sub	a,#0x01
	ld	a, #0x00
	rla
	xor	a, #0x01
	ld	l, a
	ld	h, #0x00
;list.c:25: }
	ret
;list.c:28: void *list_first(LIST *list)
;	---------------------------------
; Function list_first
; ---------------------------------
_list_first::
;list.c:30: return list->first;
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
;list.c:31: }
	ret
;list.c:34: void *list_next(void *elem)
;	---------------------------------
; Function list_next
; ---------------------------------
_list_next::
;list.c:36: LINK *link = (LINK *) elem;
	pop	bc
	pop	hl
	push	hl
	push	bc
;list.c:37: return link->next;
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
;list.c:38: }
	ret
;list.c:41: void list_add_first(LIST *list, void *elem)
;	---------------------------------
; Function list_add_first
; ---------------------------------
_list_add_first::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;list.c:43: LINK *link = (LINK *) elem;
	ld	a, 6 (ix)
	ld	-4 (ix), a
	ld	a, 7 (ix)
	ld	-3 (ix), a
;list.c:44: link->next = list->first;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
;list.c:45: list->first = link;
	ld	l, c
	ld	h, b
	ld	a, -4 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -3 (ix)
	ld	(hl), a
;list.c:46: if ( list->last == (LINK *) list )
	inc	bc
	inc	bc
	ld	a, (bc)
	ld	-2 (ix), a
	inc	bc
	ld	a, (bc)
	ld	-1 (ix), a
	dec	bc
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	cp	a, a
	sbc	hl, de
	jr	NZ,00103$
;list.c:47: list->last = link;
	ld	a, -4 (ix)
	ld	(bc), a
	inc	bc
	ld	a, -3 (ix)
	ld	(bc), a
00103$:
;list.c:48: }
	ld	sp, ix
	pop	ix
	ret
;list.c:51: void list_add_last(LIST *list, void *elem)
;	---------------------------------
; Function list_add_last
; ---------------------------------
_list_add_last::
	push	ix
	ld	ix,#0
	add	ix,sp
;list.c:53: LINK *link = (LINK *) elem;
	ld	c, 6 (ix)
	ld	b, 7 (ix)
;list.c:54: link->next = NULL;
	ld	l, c
	ld	h, b
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;list.c:55: list->last->next = link; /* may be list->first */
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	inc	de
	inc	de
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
;list.c:56: list->last = link;
	ld	a, c
	ld	(de), a
	inc	de
	ld	a, b
	ld	(de), a
;list.c:57: }
	pop	ix
	ret
;list.c:60: void list_add_after(LIST *list, void *elem, void *elem_new)
;	---------------------------------
; Function list_add_after
; ---------------------------------
_list_add_after::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;list.c:62: LINK *link     = (LINK *) elem;
	ld	a, 6 (ix)
	ld	-4 (ix), a
	ld	a, 7 (ix)
	ld	-3 (ix), a
;list.c:63: LINK *link_new = (LINK *) elem_new;
	ld	c, 8 (ix)
	ld	b, 9 (ix)
;list.c:64: link_new->next = link->next;
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	ld	(hl), e
	inc	hl
	ld	(hl), d
;list.c:65: link->next = link_new;
	pop	hl
	push	hl
	ld	(hl), c
	inc	hl
	ld	(hl), b
;list.c:66: if ( list->last == link )
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	inc	de
	inc	de
	ld	a, (de)
	ld	-2 (ix), a
	inc	de
	ld	a, (de)
	ld	-1 (ix), a
	dec	de
	ld	a, -4 (ix)
	sub	a, -2 (ix)
	jr	NZ,00103$
	ld	a, -3 (ix)
	sub	a, -1 (ix)
	jr	NZ,00103$
;list.c:67: list->last = link_new;
	ld	a, c
	ld	(de), a
	inc	de
	ld	a, b
	ld	(de), a
00103$:
;list.c:68: }
	ld	sp, ix
	pop	ix
	ret
;list.c:71: void *list_remove_first(LIST *list)
;	---------------------------------
; Function list_remove_first
; ---------------------------------
_list_remove_first::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;list.c:74: if ( (link = list->first) != NULL )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	sp
	inc	sp
	push	de
	ld	a, d
	or	a, e
	jr	Z,00104$
;list.c:75: if ( (list->first = link->next) == NULL )
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	ld	(hl), e
	inc	hl
	ld	a,d
	ld	(hl),a
	or	a, e
	jr	NZ,00104$
;list.c:76: list->last = (LINK *) list;
	inc	bc
	inc	bc
	ld	a, 4 (ix)
	ld	d, 5 (ix)
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
00104$:
;list.c:77: return link;
	pop	hl
	push	hl
;list.c:78: }
	ld	sp, ix
	pop	ix
	ret
;list.c:80: BOOLEAN list_remove_item(LIST *list, void *elem)
;	---------------------------------
; Function list_remove_item
; ---------------------------------
_list_remove_item::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;list.c:82: LINK *link = list->first;
	ld	a, 4 (ix)
	ld	-8 (ix), a
	ld	a, 5 (ix)
	ld	-7 (ix), a
	pop	hl
	push	hl
	ld	a, (hl)
	ld	-6 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-5 (ix), a
;list.c:83: LINK *prev = NULL;
	xor	a, a
	ld	-4 (ix), a
	ld	-3 (ix), a
;list.c:84: while (link != NULL)
00108$:
	ld	a, -5 (ix)
	or	a, -6 (ix)
	jp	Z, 00110$
;list.c:86: if (link == (LINK *) elem)
	ld	c, 6 (ix)
	ld	b, 7 (ix)
;list.c:88: if (prev == NULL) list->first = link->next;
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;list.c:86: if (link == (LINK *) elem)
	pop	de
	pop	hl
	push	hl
	push	de
	cp	a, a
	sbc	hl, bc
	jr	NZ,00107$
;list.c:88: if (prev == NULL) list->first = link->next;
	ld	a, -3 (ix)
	or	a, -4 (ix)
	jr	NZ,00102$
	pop	hl
	push	hl
	ld	a, -2 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -1 (ix)
	ld	(hl), a
	jr	00103$
00102$:
;list.c:89: else prev->next = link->next;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, -2 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -1 (ix)
	ld	(hl), a
00103$:
;list.c:90: if (list->last == link) list->last = prev;
	ld	a, -8 (ix)
	add	a, #0x02
	ld	-2 (ix), a
	ld	a, -7 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	de
	pop	hl
	push	hl
	push	de
	cp	a, a
	sbc	hl, bc
	jr	NZ,00105$
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -3 (ix)
	ld	(hl), a
00105$:
;list.c:91: return TRUE;
	ld	hl, #0x0001
	jr	00111$
00107$:
;list.c:93: prev = link;
	ld	a, -6 (ix)
	ld	-4 (ix), a
	ld	a, -5 (ix)
	ld	-3 (ix), a
;list.c:94: link = link->next;
	ld	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, -1 (ix)
	ld	-5 (ix), a
	jp	00108$
00110$:
;list.c:96: return FALSE;
	ld	hl, #0x0000
00111$:
;list.c:97: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
